package org.hibernate.dialect;

/**
 * @author Pietro Polsinelli ppolsinelli@open-lab.com
 * @author Roberto Bicchierai rbicchierai@open-lab.com
 */
public class HSQL172PlusDialect extends HSQLDialect {

  static private Class[] hsqlTocharParams = {
    java.util.Date.class, String.class
  };

  /**
   * This will not work at all for HSQLDB v. 1.7.1 and earlier, because
   * there was no system_sequences table.
   */
  public String getQuerySequencesString() {
    try {
      // Does present HSQLDB Database class support schemas?
      Class.forName("org.hsqldb.Library", false,
        HSQLDialect.class.getClassLoader()).
        getDeclaredMethod("to_char", hsqlTocharParams);
      return "select sequence_name from "
        + "information_schema.system_sequences";
    } catch (Throwable t) {
      System.err.println("GOT " + t);
      return "select sequence_name from system_sequences";
    }
  }

}
