package org.hibernate.tools.hbm2x;

import org.hibernate.cfg.Configuration;
import org.hibernate.mapping.Component;
import org.hibernate.mapping.PersistentClass;
import org.hibernate.tool.hbm2x.ConfigurationNavigator;
import org.hibernate.tool.hbm2x.POJOExporter;

import java.io.File;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

/**
 * @author Pietro Polsinelli ppolsinelli@open-lab.com
 * @author Roberto Bicchierai rbicchierai@open-lab.com
 */
public class MyPOJOExporter extends POJOExporter {

  public MyPOJOExporter(Configuration config, File file) {
    super(config,file);
  }

  public void start(boolean ejb3, boolean generics, Set<String> exportClasses) {
    setupTemplates();
    getTemplateHelper().putInContext("cfg", getConfiguration());
    getTemplateHelper().putInContext("ejb3", Boolean.valueOf(ejb3));
    getTemplateHelper().putInContext("generics", Boolean.valueOf(generics));

    Map components = new HashMap();

    for (Iterator classes = getConfiguration().getClassMappings(); classes.hasNext();) {
      PersistentClass clazz = (PersistentClass) classes.next();
      if (exportClasses==null || exportClasses.contains(clazz.getClassName())) {
        ConfigurationNavigator.collectComponents(components, clazz);
        exportPersistentClass(clazz);
      }
    }

    for (Iterator comps = components.values().iterator(); comps.hasNext();) {
      Component component = (Component) comps.next();
      exportComponent(component);
    }

    setTemplateHelper(null);

  }

}
