package org.jblooming;

import org.jblooming.tracer.Tracer;
import org.jblooming.utilities.DateUtilities;
import org.jblooming.waf.settings.ApplicationState;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.io.Writer;
import java.util.Date;

public class ApplicationRuntimeException extends RuntimeException {

  public ApplicationRuntimeException(String message) {
    super(PlatformRuntimeException.getTime() + message);
    if (!ApplicationState.platformConfiguration.development)
      Tracer.platformLogger.fatal(message, this);
  }

  public ApplicationRuntimeException(String message, Throwable cause) {
    super(PlatformRuntimeException.getTime() + message, cause);
    if (!ApplicationState.platformConfiguration.development)
      Tracer.platformLogger.fatal(message, this);
  }

  public ApplicationRuntimeException(Throwable cause) {
    super(PlatformRuntimeException.getTime(), cause);
    if (!ApplicationState.platformConfiguration.development)
      Tracer.platformLogger.fatal(null, this);
  }

  public static String getStackTrace(Throwable aThrowable) {
    final Writer result = new StringWriter();
    final PrintWriter printWriter = new PrintWriter(result);
    aThrowable.printStackTrace(printWriter);
    return result.toString();
  }

  protected static String getTime() {
    return "Server time: " + DateUtilities.dateToString(new Date(), "yyyy MM dd hh:mm:ss") + ". ";
  }
}
