package org.jblooming;

import org.jblooming.operator.Operator;
import org.jblooming.persistence.PersistenceSession;
import org.jblooming.persistence.hibernate.HibernateFactory;

/**
 * @author Pietro Polsinelli : ppolsinelli@open-lab.com
 */
public class PlatformRuntimeException extends ApplicationRuntimeException {

  public PlatformRuntimeException() {

    this("");
  }

  public PlatformRuntimeException(Throwable cause) {
    this("",cause);
  }

  public PlatformRuntimeException(String message) {
    super(getExtendedMessage(message));
  }

  public PlatformRuntimeException(String message, Throwable cause) {
    super(getExtendedMessage(message)+"\nThe exception thrown:\n", cause);
  }

  private static String getExtendedMessage(String message) {

    //believe it or not, we put it here! HAHAHAHAHA (with a Satanic ring)!
    try {
      PersistenceSession persistenceSession = HibernateFactory.getPersistenceSession();
      if (persistenceSession!=null && persistenceSession.operator!=null) {
        Operator operator = persistenceSession.operator;
        message = message + " logged operator: ("+operator.getId()+") "+ operator.getDisplayName()+"\n";
      }
    } catch (Exception e) {      
    }

    message = message + PlatformRuntimeException.getTime();
    return message;
  }



}
