package org.jblooming.cursor;


import org.jblooming.cursor.exceptions.CursorException;

import java.util.Collection;

/**
 * Author: Andrea Costantinis (costantinis@remsoftware.it)
 * Date: October 2003
 * Time: 12:00:00
 */

public class Cursors {

  public static LazyFetchCursor union(LazyFetchCursor cursor, Collection targetIds) throws CursorException {
    LazyFetchCursor newCursor = new LazyFetchCursor(targetIds.iterator(), cursor.getCursorServer());
    return (LazyFetchCursor) cursor.union(newCursor);
  }

  public static LazyFetchCursor intersection(LazyFetchCursor cursor, Collection targetIds) throws CursorException {
    LazyFetchCursor newCursor = new LazyFetchCursor(targetIds.iterator(), cursor.getCursorServer());
    return (LazyFetchCursor) cursor.intersection(newCursor);
  }

  public static LazyFetchCursor difference(LazyFetchCursor cursor, Collection targetIds) throws CursorException {
    LazyFetchCursor newCursor = new LazyFetchCursor(targetIds.iterator(), cursor.getCursorServer());
    return (LazyFetchCursor) cursor.difference(newCursor);
  }

}
