package org.jblooming.http;

import org.jblooming.tracer.Tracer;
import org.jblooming.waf.settings.ApplicationState;

import javax.servlet.*;
import javax.servlet.http.HttpServletRequest;
import java.io.File;
import java.io.IOException;

/**
 * @author Pietro Polsinelli ppolsinelli@open-lab.com
 * @author Roberto Bicchierai rbicchierai@open-lab.com
 */
public class CaseSensitivityFilter implements Filter {

  public void init(FilterConfig filterConfig) throws ServletException {
  }

  public void doFilter(ServletRequest servletRequest, ServletResponse servletResponse, FilterChain filterChain) throws ServletException, IOException {

    if (ApplicationState.platformConfiguration!=null && ApplicationState.platformConfiguration.development) {

      HttpServletRequest request = (HttpServletRequest) servletRequest;
      String realPath = request.getSession(true).getServletContext().getRealPath(request.getRequestURI());
      String canonicalPath = new File(realPath).getCanonicalPath();

      if (!realPath.startsWith(canonicalPath)) {
        Tracer.platformLogger.error(realPath + " is different from " + canonicalPath);
        throw new RuntimeException(realPath + " is different from " + canonicalPath);

      }
    }

    filterChain.doFilter(servletRequest, servletResponse);
  }

  public void destroy() {
  }
}

