package org.jblooming.logging;

import org.hibernate.CallbackException;
import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.jblooming.operator.Operator;
import org.jblooming.persistence.hibernate.HibernateFactory;

import java.io.Serializable;
import java.sql.Connection;

/**
 * @author Pietro Polsinelli ppolsinelli@open-lab.com
 * @author Roberto Bicchierai rbicchierai@open-lab.com
 */
public class AuditLogHelper {

  public static void logEvent(
          String message,
          Sniffable entity,
          Operator logged,
          Connection connection)
          throws CallbackException {

    logEvent( message,
           entity,
           entity.getId(),
           logged,
           connection);

  }

   public static void logEvent(
          String message,
          Sniffable entity,
          Serializable entityId,
          Operator logged,
          Connection connection)
          throws CallbackException {

    AuditLogRecord record = new AuditLogRecord(message, entityId, entity.getClass().getName(), logged);
   // AuditLogRecord record = new AuditLogRecord(message, "pippo", AuditLog.class, new Operator());
    logEvent(record, connection);
  }

  public static void logEvent(AuditLogRecord record, Connection connection) {

    Session tempSession = HibernateFactory.getSessionFactory().openSession(connection);
    try {
      tempSession.save(record);
      tempSession.flush();
    } catch (Exception ex) {
      throw new CallbackException(ex);
    } finally {
      try {
        tempSession.close();
      } catch (HibernateException ex) {
        throw new CallbackException(ex);
      }
    }
  }
}