package org.jblooming.logging;

import org.jblooming.ontology.IdentifiableSupport;
import org.jblooming.operator.Operator;

import java.io.Serializable;
import java.util.Date;

/**
 * @author Pietro Polsinelli ppolsinelli@open-lab.com
 * @author Roberto Bicchierai rbicchierai@open-lab.com
 */
public class AuditLogRecord extends IdentifiableSupport {

  private String message;
  private String entityId;
  private String entityClass;
  private String fullName;
  private Date created;
  private String data;

  AuditLogRecord() {
  }

  public AuditLogRecord(String message,
                        Serializable entityId,
                        String entityClass,
                        Operator operator) {
    this.message = message;
    this.entityId = entityId!=null ? entityId.toString() : "null";
    this.entityClass = entityClass;
    this.fullName = operator.getFullname();
    this.created = new Date();
  }

  public String getMessage() {
    return message;
  }

  public void setMessage(String message) {
    this.message = message;
  }

  public String getEntityId() {
    return entityId;
  }

  public void setEntityId(String entityId) {
    this.entityId = entityId;
  }

  public String getEntityClass() {
    return entityClass;
  }

  public void setEntityClass(String entityClass) {
    this.entityClass = entityClass;
  }

  public String getFullName() {
    return fullName;
  }

  public void setFullName(String fullName) {
    this.fullName = fullName;
  }

  public Date getCreated() {
    return created;
  }

  public void setCreated(Date created) {
    this.created = created;
  }

  public String getData() {
    return data;
  }

  public void setData(String data) {
    this.data = data;
  }
}