package org.jblooming.messaging;

import org.jblooming.persistence.hibernate.HibernateFactory;
import org.jblooming.persistence.hibernate.PersistenceContext;
import org.jblooming.scheduler.ExecutableSupport;
import org.jblooming.scheduler.JobLogData;
import org.jblooming.tracer.Tracer;
import org.jblooming.utilities.DateUtilities;

public class ClockEventDispatcher extends ExecutableSupport {

  public JobLogData run(JobLogData jobLogData) throws Exception {
    boolean exception = true;
    PersistenceContext pc = null;

    try {
      pc = HibernateFactory.newFreeSession();

      SomethingHappened timerEvent = new SomethingHappened("NOT_AVAILABLE", "NOT_AVAILABLE", MessagingSystem.TIMER_EVENT, DateUtilities.getAbsoluteNow(), null);
      timerEvent.store(pc);
      pc.commitAndClose();

      jobLogData.notes = jobLogData.notes + "ClockEventDispatcher executed on " + DateUtilities.dateToTimestampString(DateUtilities.getAbsoluteNow());
      exception = false;
    } catch (Exception e) {
      Tracer.platformLogger.error("ClockEventDispatcher error",e);

    } finally {
      if (exception) {
        if (pc != null) {
          pc.rollback();
        }
        jobLogData.successfull = false;
      }
    }

    return jobLogData;
  }
}
