package org.jblooming.ontology;

import org.jblooming.operator.User;
import org.jblooming.security.Area;
import org.jblooming.security.Permission;
import org.jblooming.security.SecurableWithArea;

import javax.persistence.MappedSuperclass;

/**
 * @author Pietro Polsinelli ppolsinelli@open-lab.com
 * @author Roberto Bicchierai rbicchierai@open-lab.com
 */
@MappedSuperclass
public abstract class SecuredSupportWithArea extends SecuredLoggableHideableSupport implements SecurableWithArea {

  private Area area;

  public Area getArea() {
    return area;
  }

  public void setArea(Area area) {
    this.area = area;
  }

  public boolean hasPermissionFor(User u, Permission p) {

    if (getOwner() != null && getOwner().equals(u))
      return true;

    if (getArea() == null)
       return u.hasPermissionAsAdmin();

    return area.hasPermissionFor(u, p);

  }

}
