package org.jblooming.ontology.businessLogic;

import org.jblooming.ApplicationException;
import org.jblooming.PlatformRuntimeException;
import org.jblooming.ontology.LookupConfiguration;
import org.jblooming.persistence.exceptions.PersistenceException;
import org.jblooming.persistence.exceptions.RemoveException;
import org.jblooming.waf.ActionController;
import org.jblooming.waf.constants.Commands;
import org.jblooming.waf.constants.PlatformConstants;
import org.jblooming.waf.exceptions.ActionException;
import org.jblooming.waf.view.PageState;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author Pietro Polsinelli ppolsinelli@open-lab.com
 */
public class LookupController implements ActionController {
  private LookupConfiguration lookupConfiguration;

  public LookupController(LookupConfiguration lookupConfiguration) {
    this.lookupConfiguration = lookupConfiguration;
  }

  public PageState perform(HttpServletRequest request, HttpServletResponse response) throws PersistenceException, ActionException, org.jblooming.security.SecurityException, ApplicationException {

    PageState pageState = PageState.getCurrentPageState(request);

    final String command = pageState.getCommand();

    LookupAction la = new LookupAction();

    if (Commands.SAVE.equals(command))
      try {
        la.cmdSave(lookupConfiguration, pageState);
      } catch (ActionException e) {}

    else if (Commands.EDIT.equals(command) || Commands.DELETE_PREVIEW.equals(command))
      la.cmdEdit(lookupConfiguration, pageState);

    else if (Commands.DELETE.equals(command)) {
      try {
        la.cmdDelete(lookupConfiguration, pageState);
        pageState.setCommand(Commands.FIND);
      } catch (RemoveException ex) {
        // in order to feedback operator il partDelete.jsp
        pageState.setAttribute(PlatformConstants.DELETE_EXCEPTION, ex);
      } catch (Exception ex) {
        throw new PlatformRuntimeException(ex);
      }
    }
    return pageState;
  }
}
