package org.jblooming.operator.layout;

import org.jblooming.ApplicationException;
import org.jblooming.PlatformRuntimeException;
import org.jblooming.operator.Operator;
import org.jblooming.waf.html.core.JspHelper;
import org.jblooming.waf.html.state.Form;

import javax.servlet.ServletException;
import javax.servlet.jsp.PageContext;
import java.io.IOException;

/**
 * @author Pietro Polsinelli ppolsinelli@open-lab.com
 */
public class OperatorDrawer extends JspHelper {
  public static final String BASIC_DATA = "BASIC_DATA";
  public static final String SECURITY = "SECURITY";
  public static final String BUTTONS = "BUTTONS";
  public static final String STATE = "STATE";
  public static final String LDAP_GROUPS = "LDAP_GROUPS";
  public static final String LDAP_PROPERTIES = "LDAP_PROPERTIES";
  public Operator operator;
  public Form form;
  public boolean admonly = false;
  public boolean drawEditButton = false;
  public boolean drawStateButton = false;
  public boolean drawRoleSelector = true;
  public boolean drawGroupSelector = true;
  public boolean drawSecurityCollector = true;
  public boolean drawLocation = true;

  public boolean drawArea = false;
  public boolean areaRequired = false;
  public boolean nameSurnameRequired = false;

  private boolean isList = false;

  protected OperatorDrawer() {
    super();
  }

  public OperatorDrawer(Operator operator, Form form) {
    super();
    this.operator = operator;
    this.form = form;
    this.urlToInclude = "/commons/security/operator/partOperatorEditor.jsp";
  }

  public static OperatorDrawer getListInstance() {
    OperatorDrawer od = new OperatorDrawer();
    od.urlToInclude = "/commons/security/operator/partOperatorList.jsp";
    od.isList = true;
    return od;
  }

  public void drawData(PageContext pageContext) throws IOException, ServletException, ApplicationException {
    if (isList)
      throw new PlatformRuntimeException("Do not use as list");
    pageContext.getRequest().setAttribute(ACTION, BASIC_DATA);
    super.toHtml(pageContext);
  }

  public void drawSecurity(PageContext pageContext) throws IOException, ServletException, ApplicationException {
    if (isList)
      throw new PlatformRuntimeException("Do not use as list");
    pageContext.getRequest().setAttribute(ACTION, SECURITY);
    super.toHtml(pageContext);
  }

  public void drawButtons(PageContext pageContext) throws IOException, ServletException, ApplicationException {
    if (isList)
      throw new PlatformRuntimeException("Do not use as list");
    pageContext.getRequest().setAttribute(ACTION, BUTTONS);
    super.toHtml(pageContext);
  }

  public void drawState(PageContext pageContext) throws IOException, ServletException, ApplicationException {
    if (isList)
      throw new PlatformRuntimeException("Do not use as list");
    pageContext.getRequest().setAttribute(ACTION, STATE);
    super.toHtml(pageContext);
  }

  public void drawLdapGroups(PageContext pageContext) throws IOException, ServletException, ApplicationException {
  if (isList)
    throw new PlatformRuntimeException("Do not use as list");
  pageContext.getRequest().setAttribute(ACTION, LDAP_GROUPS);
  super.toHtml(pageContext);
}
  public void drawLdapProperties(PageContext pageContext) throws IOException, ServletException, ApplicationException {
  if (isList)
    throw new PlatformRuntimeException("Do not use as list");
  pageContext.getRequest().setAttribute(ACTION, LDAP_PROPERTIES);
  super.toHtml(pageContext);
}

  public void toHtml(PageContext pageContext) {
   super.toHtml(pageContext);
  }

}
