package org.jblooming.remoteFile;

import org.jblooming.messaging.MessagingSystem;
import org.jblooming.ontology.Node;
import org.jblooming.ontology.VersionComparator;
import org.jblooming.operator.Operator;
import org.jblooming.operator.User;
import org.jblooming.persistence.exceptions.PersistenceException;
import org.jblooming.security.Permission;

import java.util.List;


public class BasicDocument extends Document{

  public void setParent(BasicDocument n) {
     parent = n;
   }

   public void setParentNode(Node node) {
     setParent((BasicDocument) node);
   }

  public BasicDocument getParent() {
    return (BasicDocument) parent;
  }

  public Node getParentNode() {
    return getParent();
  }

  public int compareVersionTo(BasicDocument doc) {
    VersionComparator vc = new VersionComparator();
    return vc.compare(this.getVersion(), doc.getVersion());
  }

  public List<MessagingSystem.Media> getActiveMedia() {
    return MessagingSystem.activeMedia;
  }


  public boolean isEnabled(Operator logged) throws PersistenceException {
    return true ;//todo
  }

  public boolean hasPermissionFor(User u, Permission p) {
    return super.hasPermissionFor(u,p);
  }
}
