package org.jblooming.remoteFile;

import org.jblooming.PlatformRuntimeException;
import org.jblooming.agenda.CompanyCalendar;
import org.jblooming.operator.Operator;
import org.jblooming.tracer.Tracer;
import org.jblooming.utilities.DateUtilities;
import org.jblooming.waf.UploadHelper;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.List;

public class RemoteFileService extends RemoteFile {
  private URLConnection hpCon;//= urlToOpen.openConnection();
//            InputStream input = hpCon.getInputStream();
  private URL urlToOpen;
  private static final String DIRSEPARATOR = "d";
  private static final String FILESEPARATOR = "f";//todo
  private static final String USERSEPARATOR = "u";//todo
  private static final String DATEWGEIHTSEPARATOR = "*";//todo

  private String relativePath = null;
 // private boolean directory = true;
  private long lastModified = 0;
  private long length = 0;

  public RemoteFileService(Document document) {
    super(document);
  }


  private URL getClient() {
    if ((this.relativePath == null || this.relativePath.trim().length() <= 0))
      setTarget(document.getContent());
    else if (!relativePath.startsWith(document.getContent()))
      setTarget(document.getContent() + this.relativePath);
    if (urlToOpen == null)
      connect();
    return urlToOpen;
  }

  public boolean exists() {
    return (this.document.getConnectionHost() != null && this.document.getConnectionHost().trim().length() > 0);  //todo
  }

  public String getName() {
    //getClient();
    String name = "";
    //if (!relativePath.equals(document.getContent()))
      name = relativePath.substring(relativePath.lastIndexOf(File.separator) + 1);
    //else
      name = name.substring(name.lastIndexOf("/") + 1);

//      name=   relativePath;//.substring((document.getContent() + File.separator).length());
//    else
    //name=  relativePath.substring((document.getContent() ).length());
//    if (name.startsWith(File.separator))
//      name=name.substring(File.separator.length());
//    if(name.trim().length()<=0)
//    name=this.document.getCode();
    return name;
  }

  public boolean connect() {
    boolean ret = false;
    String dir = "";
    if (document.getConnectionHost() != null) {
      dir = (relativePath != null && !relativePath.trim().equals("\\") && !relativePath.trim().equals("/")) ? relativePath : "";
      try {
       // if(isDirectory())
        Operator usr= this.getLoggedOperator();
        urlToOpen = new URL(document.getConnectionHost() + "?" + DIRSEPARATOR + "=" + dir+"&"+USERSEPARATOR+"="+(usr!=null?usr.getLoginName():""));//todo da vedere
       // else
       // urlToOpen = new URL(document.getConnectionHost() + "?" + FILESEPARATOR + "=" + dir);

      } catch (MalformedURLException e) {
        Tracer.platformLogger.error(" Malformed URL ", e);
      }
      try {
        hpCon = urlToOpen.openConnection();
        ret = true;
      } catch (IOException e) {
        Tracer.platformLogger.error(" Cannot connect ", e);  //To change body of catch statement use File | Settings | File Templates.
      }
    }
    return ret;
  }


  public List<RemoteFile> listFiles() {
    StringBuffer str = new StringBuffer();
    int c;
    try {
      getClient();
      InputStream input = hpCon.getInputStream();
      while (((c = input.read()) != -1)) {
        str.append((char) c);
      }
      input.close();
      String[] ar = str.toString().split(":");

      List<RemoteFile> rf = new ArrayList<RemoteFile>();
      for (int i = 0; i < ar.length; i++) {

        if (ar[i] != null && ar[i].trim().length() > 0) {
          Document doc = document;
          String fileindex = ar[i].substring(0, DIRSEPARATOR.length());
          int pos=ar[i].indexOf(DATEWGEIHTSEPARATOR);
          String filename1=ar[i];
          if(pos>0)
           filename1 = ar[i].substring(0, ar[i].indexOf(DATEWGEIHTSEPARATOR));
          String filename = filename1.substring(DIRSEPARATOR.length());

          String datewg = ar[i].substring(ar[i].indexOf(DATEWGEIHTSEPARATOR) + 1);
          RemoteFileService rfs = new RemoteFileService(doc);
          if (!relativePath.startsWith(document.getContent()))
            rfs.setTarget(document.getContent() + (relativePath != null ? relativePath : "") + File.separator + filename);
          else
            rfs.setTarget((relativePath != null ? relativePath : "") + File.separator + filename);
          CompanyCalendar cc = new CompanyCalendar();
          rfs.setLoggedOperator( this.getLoggedOperator());
          if (fileindex.equals(DIRSEPARATOR)) {
            //rfs.setDirectory(true);
            if (datewg.trim().length() > 0) {
              try {
                cc.setTime(DateUtilities.dateFromString(datewg));
                rfs.setlastModified(cc.getTimeInMillis());
              } catch (ParseException e) {
                Tracer.platformLogger.error("Cannot get date file for " + relativePath, e);
              }
            }
          } else {
            if (datewg.trim().length() > 0) {
               pos=datewg.indexOf(DATEWGEIHTSEPARATOR);
              String dat=datewg;
              if(pos>0){
               dat = datewg.substring(0, datewg.indexOf(DATEWGEIHTSEPARATOR));
              String wg = datewg.substring(datewg.indexOf(DATEWGEIHTSEPARATOR) + 1);
                if(wg.trim().length()>0){
                  long length=Long.parseLong(wg);
                rfs.setlength(length);
                }
              }
              try {
                cc.setTime(DateUtilities.dateFromString(dat));
                rfs.setlastModified(cc.getTimeInMillis());

              } catch (ParseException e) {
                Tracer.platformLogger.error("Cannot get date file for " + relativePath, e);
              }
            }
            //rfs.setDirectory(false);
          }
          rf.add(rfs);
        }
      }
      return rf;

    } catch (IOException e) {
      Tracer.platformLogger.error("Cannot get listFiles for " + relativePath, e);
    }
    return null;
  }


  public boolean setTarget(String path) {
    relativePath = path;
    return true;
  }


  public String getParent() {
    getClient();
    if (relativePath != null && relativePath.length() > 0) {
      if (!relativePath.startsWith(document.getContent()))
        return document.getContent() + relativePath.substring(0, relativePath.lastIndexOf(File.separator));
      else
        return relativePath.substring(0, relativePath.lastIndexOf(File.separator));
    }
    return null;
  }

  public boolean isRoot() {
    getClient();
    return relativePath.equals(document.getContent());
  }
//
//  public void setDirectory(boolean directory) {
//    this.directory = directory;
//  }

  public boolean isDirectory() {
    getClient();
    int pos=relativePath.lastIndexOf(".");
    return (pos<0);  //todo change body of implemented methods use File | Settings | File Templates.
  }


  public String getRelativePath() {
    getClient();
    return relativePath;
  }


  public RemoteFile getParentFile() {
    RemoteFileService parent = null;
    getClient();
    parent = new RemoteFileService(document);
    if (relativePath != null && relativePath.length() > 0)
      if (!relativePath.startsWith(document.getContent()))
        parent.relativePath = document.getContent() + relativePath.substring(0, relativePath.lastIndexOf(File.separator));
      else{
       // int pos=relativePath.indexOf(File.separator);
        int pos=relativePath.lastIndexOf(File.separator);
        if(pos>=0)
        parent.relativePath = relativePath.substring(0, relativePath.lastIndexOf(File.separator));
        else
          parent.relativePath = relativePath.substring(0, relativePath.lastIndexOf("/"));


      }

    //parent.relativePath = relativePath.substring(0, relativePath.lastIndexOf(File.separator));
    return parent;
  }

  public void setlastModified(long lastModified) {
    this.lastModified=lastModified;
  }
  public long lastModified() {
    return lastModified;
  }
  public void setlength(long length) {
     this.length=length ;
   }

  public long length() {
    return length;
  }

  public boolean delete() {
    return false;  //To change body of implemented methods use File | Settings | File Templates.
  }

  public List<String> list() {
    return null;  //To change body of implemented methods use File | Settings | File Templates.
  }


  public boolean mkdir() {
    return false;  //To change body of implemented methods use File | Settings | File Templates.
  }

  public boolean mkdirs() {
    return false;  //To change body of implemented methods use File | Settings | File Templates.
  }

  public boolean renameTo(RemoteFile dest) {
    return false;  //To change body of implemented methods use File | Settings | File Templates.
  }


  public boolean disconnect() {
    return true;
  }


  public File downloadCopy() throws IOException {
    this.getClient();
    if (this.isDirectory())
      throw new PlatformRuntimeException("Silly developers try to download directories "+getClient().getPath());
    File tmp = File.createTempFile(this.getName(),"");

//todo
    //FileUtilities.mycopy(getClient(),tmp);
    return tmp;
  }

//  public File downloadCopy() throws IOException {//todo
//    return null;  //To change body of implemented methods use File | Settings | File Templates.
//  }

  public boolean canMakeDir() {
    return false;  //To change body of implemented methods use File | Settings | File Templates.
  }

  public boolean canZipFiles() {
    return false;  //To change body of implemented methods use File | Settings | File Templates.
  }

  public boolean canDeleteFiles() {
    return false;  //To change body of implemented methods use File | Settings | File Templates.
  }

  public boolean canUploadFiles() {
    return false;  //To change body of implemented methods use File | Settings | File Templates.
  }

  public InputStream getRemoteInputStream() throws IOException {
    getClient();
    return hpCon.getInputStream();   //To change body of implemented methods use File | Settings | File Templates.
  }

  public void upload(UploadHelper uploader) throws IOException {
    //To change body of implemented methods use File | Settings | File Templates.
  }


  public boolean canWrite() {
    return false;  //To change body of implemented methods use File | Settings | File Templates.
  }


}
