package org.jblooming.remoteFile.businessLogic;

import org.jblooming.ApplicationException;
import org.jblooming.persistence.exceptions.PersistenceException;
import org.jblooming.persistence.exceptions.RemoveException;
import org.jblooming.remoteFile.BasicDocument;
import org.jblooming.waf.ActionController;
import org.jblooming.waf.SessionState;
import org.jblooming.waf.constants.Commands;
import org.jblooming.waf.constants.PlatformConstants;
import org.jblooming.waf.exceptions.ActionException;
import org.jblooming.waf.view.PageSeed;
import org.jblooming.waf.view.PageState;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class DocumentController implements ActionController {

  public Class documentClass;


  public DocumentController (Class docClass) {
    this.documentClass = docClass;
  }


  public DocumentController () {
    this.documentClass = BasicDocument.class;
  }
  public PageState perform(HttpServletRequest request, HttpServletResponse response)
    throws PersistenceException, ActionException, org.jblooming.security.SecurityException, ApplicationException {
    SessionState sessionState = SessionState.getSessionState(request);
    PageState pageState = sessionState.getPageState(request, response);
    DocumentAction documentAction = new DocumentAction();
    String command = pageState.getCommand();
    if (Commands.ADD.equals(command) || "ADD_DOCUMENT".equals(command))
      documentAction.cmdAdd(pageState);
    else if ("ADD_VERSION".equals(command))
      documentAction.cmdAddVersion(pageState);
    else if (Commands.CUT.equals(command)) {
      documentAction.cmdEdit(pageState);
      documentAction.cmdCut(pageState);
    } else if (Commands.EDIT.equals(command) || Commands.DELETE_PREVIEW.equals(command))
      documentAction.cmdEdit(pageState);
    else if (Commands.SAVE.equals(command))
      documentAction.cmdSave(pageState);
    else if ("CHANGE_STATE_DOCUMENT".equals(command))
      documentAction.cmdChangeState(pageState);

    else if (Commands.DELETE.equals(command)) {
        try {
          documentAction.cmdDelete(pageState);
          PageSeed ps;
          ps = pageState.pageFromCommonsRoot("document/documentList.jsp");
          ps.setCommand(Commands.FIND);          
          pageState.redirect(ps);
        } catch (RemoveException ex) {
          // in order to feedback operator in partDelete.jsp
          pageState.setAttribute(PlatformConstants.DELETE_EXCEPTION, ex);
        }
    } else if ("TAKE_OWNERSHIP".equals(command))
         documentAction.cmdTakeOwnership(pageState);
    else
      documentAction.cmdFind(pageState);
    return pageState;
  }


}

