package org.jblooming.resource;

import org.jblooming.company.Department;
import org.jblooming.ontology.HideableIdentifiableSupport;
import org.jblooming.operator.Operator;
import org.jblooming.oql.OqlQuery;
import org.jblooming.persistence.exceptions.FindException;
import org.jblooming.security.AffiliationRole;

import java.util.Date;
import java.util.List;


/**
 * Connects an resource and a department with a role
 *
 * @author Pietro Polsinelli ppolsinelli@open-lab.com
 */
public class Affiliate extends HideableIdentifiableSupport {

  private Operator operator;
  private Department department;
  private AffiliationRole role;

  private Date endingDate;

  public Affiliate() {
  }

  public Operator getOperator() {
    return operator;
  }

  public void setOperator(Operator operator) {
    this.operator = operator;
  }

  public Department getDepartment() {
    return department;
  }

  public void setDepartment(Department department) {
    this.department = department;
  }

  public AffiliationRole getRole() {
    return role;
  }

  public void setRole(AffiliationRole role) {
    this.role = role;
  }

  public Date getEndingDate() {
    return endingDate;
  }

  public void setEndingDate(Date endingDate) {
    this.endingDate = endingDate;
  }


  public static List getAffiliateWithTypeRole(String properties, Operator operator,Department depart,
                                              String classRolename,String alias) throws FindException {
//    if(alias!=null&&alias.length()>0)
//      alias+=".";
    String hql =
            "select " + properties + "  from " + Affiliate.class.getName() +
                    " as "+alias+" where "+alias+".role.class=" + classRolename ;
    if(operator!=null)
        hql+= " and "+alias+".operator = :empl";
    if(depart!=null)
        hql+= " and "+alias+".department = :depart";

    OqlQuery oql = new OqlQuery(hql);

    if(operator!=null)
      oql.getQuery().setEntity("empl", operator);
    if(depart!=null)
      oql.getQuery().setEntity("depart", depart);

    return oql.list();
  }
  
}
