package org.jblooming.scheduler;

import org.jblooming.tracer.Tracer;

import java.io.Serializable;
import java.util.Date;

/**
 * @author Pietro Polsinelli ppolsinelli@open-lab.com
 * @author Roberto Bicchierai rbicchierai@open-lab.com
 */
public abstract class ExecutableSupport implements Executable {

  public JobLogData runAndLog(Serializable jobId)  {

    JobLogData jl = new JobLogData();
    jl.id = jobId;
    jl.date = new Date();
    try {
      run(jl);
      jl.successfull=true;
    } catch (Exception e) {
      jl.notes = jl.notes+" "+e.getMessage();
      Tracer.platformLogger.error(e.getMessage(),e);
    }

    return jl;
  }

}
