package org.jblooming.scheduler;

import org.jblooming.PlatformRuntimeException;
import org.jblooming.utilities.DateUtilities;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Date;

public class ExecuteSql extends ExecutableSupport {

  @Parameter("[jdbc compliant db url]")
          public String databaseUrl;

  @Parameter("")
          public String databaseUser;

  @Parameter("")
          public String databasePassword;

  @Parameter("[jdbcDriver must be available in path]")
          public String jdbcDriver;

  @Parameter("[complete sql statement]")
          public String sql;

  public JobLogData run(JobLogData jobLogData) throws IOException {

    try {
      Class.forName(jdbcDriver);
      Connection conn = DriverManager.getConnection(databaseUrl, databaseUser, databasePassword);
      Statement  s = conn.createStatement();
      s.execute(sql);
      s.close();
      conn.close();
    } catch (ClassNotFoundException e) {
      throw new PlatformRuntimeException(e);
    } catch (SQLException e) {
      throw new PlatformRuntimeException(e);
    }

    jobLogData.notes = jobLogData.notes + "Executed on " + DateUtilities.dateToTimestampString(new Date());

    return jobLogData;
  }
}
