package org.jblooming.security;

import org.jblooming.resource.Affiliate;

import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

/**
 * @author Pietro Polsinelli ppolsinelli@open-lab.com
 * @author Roberto Bicchierai rbicchierai@open-lab.com
 */
public  class AffiliationRole extends Role {

   private Set<Affiliate> affiliations = new HashSet<Affiliate>();

   public Iterator<Affiliate> getAffiliationsIterator() {
    return affiliations.iterator();
  }

  public boolean affiliationsContains(Affiliate affiliation) {
    return affiliations.contains(affiliation);
  }

  public int affiliationsSize() {
    return affiliations.size();
  }

  private Set<Affiliate> getAffiliations() {
    return affiliations;
  }

  private void setAffiliations(Set<Affiliate> affiliations) {
    this.affiliations = affiliations;
  }
}
