package org.jblooming.security;

import org.jblooming.persistence.PersistenceHome;
import org.jblooming.persistence.exceptions.PersistenceException;

import java.util.HashMap;
import java.util.Map;

/**
 * @author Pietro Polsinelli ppolsinelli@open-lab.com
 * @author Roberto Bicchierai rbicchierai@open-lab.com
 */
public class OrganizationalRole extends AffiliationRole {

  public enum Standard {USER, MANAGER, ASSISTANT }
  public static Map<Standard,String> roleNameDecode=new HashMap<Standard,String>();

  public static OrganizationalRole getStandardOrganizationalRole(OrganizationalRole.Standard standard) throws PersistenceException {
    OrganizationalRole rt = null;

    String id=roleNameDecode.get(standard);
    if (id==null)
      id=standard.toString();

    rt = (OrganizationalRole) PersistenceHome.findUniqueNullIfEmpty(OrganizationalRole.class, "id", id);
    if (rt == null) {
      //create the standard role
      rt = new OrganizationalRole();
      rt.id=id;
      rt.setName(roleNameDecode.get(standard));
      rt.store();
    }
    return rt;
  }

}
