package org.jblooming.security.businessLogic;

import org.jblooming.persistence.exceptions.PersistenceException;
import org.jblooming.persistence.exceptions.RemoveException;
import org.jblooming.waf.ActionController;
import org.jblooming.waf.SessionState;
import org.jblooming.waf.constants.Commands;
import org.jblooming.waf.constants.PlatformConstants;
import org.jblooming.waf.exceptions.ActionException;
import org.jblooming.waf.html.input.Collector;
import org.jblooming.waf.view.PageSeed;
import org.jblooming.waf.view.PageState;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class RoleController implements ActionController {

  public String hrefAfterDelete;
  public boolean hasAreas;

  public PageState perform(HttpServletRequest request, HttpServletResponse response) throws PersistenceException, ActionException, org.jblooming.security.SecurityException {

    SessionState ss = SessionState.getSessionState(request);
    PageState pageState = (PageState) ss.getPageState(request, response);
    RoleAction roleAction = new RoleAction();
    roleAction.hasAreas = hasAreas;

    String command = pageState.getCommand();

    if (Collector.isCollectorCommand("permColl", command)) {
      try {
        roleAction.cmdMove("permColl", pageState);
      } catch (PersistenceException e) {
      }
    } else if (Commands.ADD.equals(command)) {
      roleAction.cmdAdd(pageState);
    } else if (Commands.EDIT.equals(command) || Commands.DELETE_PREVIEW.equals(command)) {
      roleAction.cmdEdit(pageState);
    } else if (Commands.SAVE.equals(command)) {
      try {
        roleAction.cmdSave(pageState);
      } catch (ActionException ex) {}
    } else if (Commands.DELETE.equals(command)) {
      try {
        roleAction.cmdDelete(pageState);
        response.resetBuffer();
        PageSeed ps = new PageSeed(hrefAfterDelete);        
        pageState.redirect(ps);
      } catch (RemoveException ex) {
        // in order to feedback operator il partDelete.jsp
        pageState.setAttribute(PlatformConstants.DELETE_EXCEPTION, ex);
      }
    } else {//if (Commands.FIND.equals(command)) {
      roleAction.cmdFind(pageState);
    }
    return pageState;
  }
}
