package org.jblooming.security.layout;

import org.jblooming.ApplicationException;
import org.jblooming.resource.Affiliate;
import org.jblooming.waf.constants.Commands;
import org.jblooming.waf.html.core.JspHelper;
import org.jblooming.waf.html.state.Form;
import org.jblooming.waf.view.PageState;

import javax.servlet.ServletException;
import javax.servlet.jsp.PageContext;
import java.io.IOException;

public class AffiliateDrawer  extends JspHelper {

  public static final String BASIC_DATA = "BASIC_DATA";

  public static final String BUTTONS = "BUTTONS";

  public boolean admonly = false;
  public boolean drawDepartment = false;
  public Class<? extends Affiliate> fixedAffiliateClass;

  public Form form;

  protected AffiliateDrawer() {
    super();
  }

  public static AffiliateDrawer getListInstance() {
    AffiliateDrawer od = new AffiliateDrawer();
    od.urlToInclude = "/commons/security/affiliate/partAffiliateList.jsp";
    return od;
  }

  public static AffiliateDrawer getEditInstance() {
    AffiliateDrawer od = new AffiliateDrawer();
    od.urlToInclude = "/commons/security/affiliate/partAffiliateEditor.jsp";
    return od;
  }

  public static boolean isListCommand(PageState pageState) {
    return (pageState.getCommand()==null || Commands.FIND.equals(pageState.getCommand()));
  }

   public void drawData(PageContext pageContext) throws IOException, ServletException, ApplicationException {
    pageContext.getRequest().setAttribute(ACTION, BASIC_DATA);
    super.toHtml(pageContext);
  }

  public void drawButtons(PageContext pageContext) throws IOException, ServletException, ApplicationException {
    pageContext.getRequest().setAttribute(ACTION, BUTTONS);
    super.toHtml(pageContext);
  }

}
