package org.jblooming.security.layout;

import org.jblooming.ApplicationException;
import org.jblooming.security.Role;
import org.jblooming.waf.constants.Commands;
import org.jblooming.waf.html.core.JspHelper;
import org.jblooming.waf.html.state.Form;
import org.jblooming.waf.view.PageState;

import javax.servlet.ServletException;
import javax.servlet.jsp.PageContext;
import java.io.IOException;

/**
 * @author Pietro Polsinelli ppolsinelli@open-lab.com
 */
public class RoleDrawer extends JspHelper {

  public static final String BASIC_DATA = "BASIC_DATA";

  public static final String BUTTONS = "BUTTONS";

  public boolean admonly = false;
  public boolean drawArea = false;

  public boolean drawRoleType = false;
  public Class<? extends Role> fixedRoleClass;

  public boolean drawUsages = true;
  public boolean drawAffiliations = true;
  public Form form;

  protected RoleDrawer() {
    super();
  }

  public static RoleDrawer getListInstance() {
    RoleDrawer od = new RoleDrawer();
    od.urlToInclude = "/commons/security/role/partRoleList.jsp";
    return od;
  }

  public static RoleDrawer getEditInstance() {
    RoleDrawer od = new RoleDrawer();
    od.urlToInclude = "/commons/security/role/partRoleEditor.jsp";
    return od;
  }

  public static boolean isListCommand(PageState pageState) {
    return (pageState.getCommand()==null || Commands.FIND.equals(pageState.getCommand()));
  }

   public void drawData(PageContext pageContext) throws IOException, ServletException, ApplicationException {
    pageContext.getRequest().setAttribute(ACTION, BASIC_DATA);
    super.toHtml(pageContext);
  }

  public void drawButtons(PageContext pageContext) throws IOException, ServletException, ApplicationException {
    pageContext.getRequest().setAttribute(ACTION, BUTTONS);
    super.toHtml(pageContext);
  }
}
