package org.jblooming.utilities;


public class DateFormatException extends Error {

  protected String wrongFormat;
  protected String expectedFormat;

  public DateFormatException() {
    this("");
  }

  public DateFormatException(String s) {
    this(s, "", "");
  }


  public DateFormatException(String s, String wrongFormat, String expectedFormat) {
    super(s);
    this.wrongFormat = wrongFormat;
    this.expectedFormat = expectedFormat;
  }

  /**
   * Method getWrongFormat
   *
   * @return a String
   */
  public String getWrongFormat() {
    return wrongFormat;
  }

  /**
   * Method getExpectedFormat
   *
   * @return a String
   */
  public String getExpectedFormat() {
    return expectedFormat;
  }

}
