package org.jblooming.utilities;

import org.jblooming.PlatformRuntimeException;

import java.sql.*;
import java.util.Properties;


public class DbUtilities {
  // properties
  public static String dbdriverClassName = "driver";
  public static String dbUrl = "url";
  public static String dbUser = "user";
  public static String dbPwd = "password";
  public static String dbAutocommit = "autocommit";
  public static String dbPath = "dbPath";

  // properties setted to import the Db "work" via AccessToTeamwork's main
  private static String driver_class = "com.mysql.jdbc.Driver";
  private static String url = "jdbc:mysql://192.168.0.1/teamwork_ol";
  private static String username = "root";
  private static String password = "";


  public static ResultSet getData(String query) {
    Connection conn = null;

    try {
      Class.forName(driver_class);
    } catch (ClassNotFoundException e) {
      throw new PlatformRuntimeException("JDBC driver not found: '" + driver_class + "'.", e);
    }

    try {
      conn = DriverManager.getConnection(url, username, password);
    } catch (SQLException e) {
      throw new PlatformRuntimeException("Cannot connect to database: '" + url + "' user:'" + username + "' password:'" + password + "'.", e);
    }

    ResultSet rs = null;

    try {
      Statement stat = conn.createStatement();
      stat.execute(query);
      rs = stat.getResultSet();
    } catch (SQLException e) {
      throw new PlatformRuntimeException("Error test querying database.", e);
    }

    return rs;
  }

  public static Connection getConnection() {
    Connection conn = null;

    try {
      Class.forName(driver_class);
    } catch (ClassNotFoundException e) {
      throw new PlatformRuntimeException("JDBC driver not found: '" + driver_class + "'.", e);
    }

    try {
      conn = DriverManager.getConnection(url, username, password);
    } catch (SQLException e) {
      throw new PlatformRuntimeException("Cannot connect to database: '" + url + "' user:'" + username + "' password:'" + password + "'.", e);
    }

    return conn;
  }

  /**
   * @param properties requires the following properties: DBHome.dbdriverClassName, DBHome.dbUrl
   *                   can be provided: DbHome.dbAutocommit,DBHome.dbUser,DBHome.dbPwd
   * @return
   */
  public static Connection getConnection(Properties properties) {
    Connection conn = null;
    try {
      Class.forName((String) properties.get(dbdriverClassName));
    } catch (ClassNotFoundException e) {
      throw new PlatformRuntimeException("JDBC driver not found: '" + (String) properties.get(dbdriverClassName) + "'.", e);
    }
    try {
      conn = DriverManager.getConnection((String) properties.get(dbUrl), (String) properties.get(dbUser), (String) properties.get(dbPwd));
      if (properties.get(DbUtilities.dbAutocommit) != null) {
        boolean autocommit = ((Boolean) properties.get(DbUtilities.dbAutocommit)).booleanValue();
        conn.setAutoCommit(autocommit);
      }
    } catch (SQLException e) {
      throw new PlatformRuntimeException("Cannot connect to database: '" + (String) properties.get(dbUrl) + "' user:'" + (String) properties.get(dbUser) + "' password:'" + (String) properties.get(dbPwd) + "'.", e);
    }
    return conn;
  }

  public static String toAccessQueryParameter(String attribute) {
    if (attribute == null)
      return "null";
    else
      return '\'' + attribute.replaceAll("'", "''") + '\'';
  }

  public static String toAccessQueryParameter(boolean attribute) {
    return "" + ((attribute) ? 1 : 0);
  }

  public static String toAccessQueryParameter(java.util.Date attribute, String format) {
    if (attribute == null)
      return "null";
    else
      return '#' + DateUtilities.dateToString(attribute, format) + '#';
  }

  public static String toAccessQueryParameter(int attribute) {
    return "" + attribute;
  }

}
