package org.jblooming.waf.html.button;

import org.jblooming.waf.html.core.JspHelper;
import org.jblooming.waf.html.display.Img;

import javax.servlet.jsp.PageContext;

/**
 * @author Pietro Polsinelli : ppolsinelli@open-lab.com
 */
public class ButtonImg extends JspHelper {

  public ButtonSupport button;
  String origUrlToInclude;

  public ButtonImg(ButtonSupport bs, Img img) {
    origUrlToInclude = bs.urlToInclude;
    img.disabled = !bs.enabled;
    bs.setCentralImage(img);
    bs.urlToInclude = "/commons/layout/partImgButton.jsp";
    this.button = bs;

    //this.mainObject = button;
    this.urlToInclude = button.urlToInclude;

  }

  public void toHtml(PageContext pageContext) {
    button.toHtml(pageContext);
  }

  public ButtonSupport restoreButton() {
    button.urlToInclude=origUrlToInclude;
    button.setCentralImage(null);
    button.toolTip=toolTip;
    return button;
  }



  public void disable() {
    this.button.borderImages.get(ButtonSupport.BACKGROUND).disabled = true;
    this.button.enabled = false;
  }

}
