package org.jblooming.waf.html.button;

import org.jblooming.PlatformRuntimeException;
import org.jblooming.utilities.JSP;
import org.jblooming.waf.html.state.Form;
import org.jblooming.waf.view.PageState;


public class ButtonJS extends ButtonSupport {

  public String onClickScript;
  public String onMouseOverScript;

  public ButtonJS() {
    super("partButton.jsp");
  }

  public ButtonJS(String onClickScript) {
    super("partButton.jsp");
    this.onClickScript=onClickScript;
  }

  public String getLaunchedJsOnActionListened() {
    String ret = null;
    // todo:       sb.append(" onClick=\"stopBubble(event);");
    if (onClickScript != null)
      ret = onClickScript;
    if (additionalScript != null)
      ret = ret + " " + additionalScript;
    return ret;
  }

  public String generateLaunchJs() {
    return generateJs().toString();
  }

  public String getLabel() {
    return label;
  }

  public boolean isEnabled() {
    return enabled;
  }

  public String getToolTip() {
    return toolTip;
  }

  public StringBuffer generateJs() {

    if (additionalOnClickScript!=null)
      throw new PlatformRuntimeException("Use onClickScript not additionalOnClickScript on ButtonJS. Why ? Because we are fools !!!! Hahahahahah !! Id="+id);

    StringBuffer sb = new StringBuffer();
    if (enabled) {
      sb.append(" onClick=\"");

      if (confirmRequire) {
        sb.append("if (confirm('");
        if (confirmQuestion != null && confirmQuestion.length() > 0)
          sb.append(JSP.javascriptEncode(confirmQuestion));
        else
          sb.append("proceed?");
        sb.append("')");
        sb.append(')'); // close if parenthesis
        sb.append("{\n"); // open if block
      }


      if (onClickScript != null && onClickScript.length() > 0)
        sb.append(onClickScript);

      if (confirmRequire) {
        sb.append("}\n"); // close if block
      }

      sb.append("\" ");
      if (additionalScript != null && additionalScript.trim().length() > 0)
        sb.append(' ').append(additionalScript);
      if (onMouseOverScript != null && onMouseOverScript.length() > 0)  {
        sb.append(" onMouseOver=\"");
        sb.append(onMouseOverScript);
        sb.append("\"");
      }
    }
    return sb;
  }

  public static ButtonJS getResetInstance(Form f, PageState pageState) {
    return getResetInstance(f,pageState.getI18n("RESET"));
  }

   public static ButtonJS getResetInstance(Form form, String label) {
    ButtonJS bs = new ButtonJS();
    bs.onClickScript = "obj('" + form.id + "').reset();";
    bs.label = label;
    return bs;
  }


}

