package org.jblooming.waf.html.button;

import org.jblooming.waf.html.core.JspHelper;
import org.jblooming.waf.html.display.Img;
import org.jblooming.waf.html.layout.Dom;
import org.jblooming.waf.view.PageState;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.PageContext;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

/**
 * @author Pietro Polsinelli : ppolsinelli@open-lab.com
 */
public abstract class ButtonSupport extends JspHelper implements Button {

  public String label;
  public String target;

  /**
   * create confirm popup
   */
  public boolean confirmRequire = false;
  public String confirmQuestion;

  public boolean alertOnChange = true;

  public boolean hasFocus = false;
  public boolean enabled = true;
  public String style;
   
  public String width;
  public String align=null;
  /**
   *  Resize the button proportionally to font size;
   */
  public int fontResizer = -1;

  public String outputModality = GRAPHICAL;
  public static String TEXT_ONLY = "TEXT_ONLY";
  public static String GRAPHICAL = "GRAPHICAL";

  public String additionalScript;
  public String additionalOnClickScript;
  public Map<String,Img> borderImages = new HashMap();
  public static String N = "N";
  public static String NE = "NE";
  public static String E = "E";
  public static String SE = "SE";
  public static String S = "S";
  public static String SW = "SW";
  public static String W = "W";
  public static String NW = "NW";
  public static String BACKGROUND = "BACKGROUND";

  public boolean pressed = false;
  /**
   * key control
   */
  private String actionListened;
  private int keyToHandle;
  private String launchedJsOnActionListened;
  public boolean checkCtrlKey=false;



  public ButtonSupport(String part) {
    this.urlToInclude = "/commons/layout/" + part;
  }

  public boolean isEnabled() {
    return enabled;
  }

  public String getActionListened() {
    return actionListened;
  }

  public void setActionListened(String actionListened) {
    this.actionListened = actionListened;
  }

  public int getKeyToHandle() {
    return keyToHandle;
  }

  public void setKeyToHandle(int keyToHandle) {
    this.keyToHandle = keyToHandle;
  }

  public String getLaunchedJsOnActionListened() {
    return launchedJsOnActionListened;
  }

  public void setLaunchedJsOnActionListened(String launchedJsOnActionListened) {
    this.launchedJsOnActionListened = launchedJsOnActionListened;
  }


  public void addKeyPressControl(int keyToHandle, String actionListened) {
    this.setKeyToHandle(keyToHandle);
    this.setLaunchedJsOnActionListened(generateJs().toString());
    this.setActionListened(actionListened);
  }

  /**
   * Handling of DOM events relatively to this control
   *
   * @param keyToHandle    the int code of the key
   * @param launchedJs     on pressing the key, this js will be launched
   * @param actionListened the code is the event listened e.g. keypress
   */
  public void addKeyPressControl(int keyToHandle, String launchedJs, String actionListened) {
   addKeyPressControl(keyToHandle, launchedJs, actionListened, false);
  }

  public void addKeyPressControl(int keyToHandle, String launchedJs, String actionListened, boolean usingCtrl) {
    this.setKeyToHandle(keyToHandle);
    this.setLaunchedJsOnActionListened(launchedJs);
    this.setActionListened(actionListened);
    this.checkCtrlKey = usingCtrl;
  }

  public abstract StringBuffer generateJs();

  public void setCentralImage(Img img) {
    this.borderImages.put(BACKGROUND, img);
  }

  public String getWidth() {
    return width;
  }

  public void setWidth(String width) {
    this.width = width;
  }


  public void toHtml(PageContext pageContext) {
    this.addKeyPressControl(Dom.RETURN, Dom.KEYPRESS);
    super.toHtml(pageContext);
  }

  public String getId() {
    return id;
  }

  public void toHtmlInTextOnlyModality(PageContext pageContext) throws IOException, ServletException {
    this.outputModality = TEXT_ONLY;
    toHtml(pageContext);
  }

   public void toHtmlI18n(PageContext pageContext) {
     PageState pageState = PageState.getCurrentPageState((HttpServletRequest) pageContext.getRequest());     
     label = pageState.getI18n(label);
     toHtml(pageContext);
  }

}
