package org.jblooming.waf.html.button;

import org.jblooming.utilities.HTMLEncoderOld;
import org.jblooming.waf.SessionState;
import org.jblooming.waf.html.core.UrlComposer;
import org.jblooming.waf.html.display.Img;
import org.jblooming.waf.html.state.Form;
import org.jblooming.waf.view.PageSeed;


/**
 * Date: 14-feb-2003
 * Time: 16.53.53
 *
 * @author Pietro Polsinelli dev@open-lab.com
 * @deprecated use ButtonSubmit instead
 */
public class SubmitButton extends UrlComposer {

  /**
   * this can be the name of the image (no extension, no path) or the string to visualise (after i18n)
   */
  public String text;
  public String target;

  public boolean hasFocus = false;
  public boolean enabled = true;

  public String style;
  public String additionalScript;
  public int tabIndex = 0;

  public String additionalLinkText = null;
  public boolean textAfterImage = true;
  public String htmlClassOn = "textSmallBlackBold";
  public String htmlClassOff = "textSmallDarkBold";
  public String additionalOnClickScript = null;
  public Img image;
  public String width = "80";
  public String formAction = null; //issue_ELE_6
  public boolean displayTable = true;


  /**
   * @deprecated use ButtonSubmit instead
   */

  public SubmitButton(Form f, Img image, PageSeed variationsFromForm) {
    super(variationsFromForm);
    this.outputModality = UrlComposer.OUTPUT_AS_JS_SUBMIT;
    this.form = f;
    this.image = image;
    this.formAction = variationsFromForm.getHref(); //issue_ELE_6
  }

  /**
   * @deprecated use ButtonSubmit instead
   */
  public SubmitButton(Form f, String name, PageSeed variationsFromForm, SessionState sess) {
    super(variationsFromForm);
    this.outputModality = UrlComposer.OUTPUT_AS_JS_SUBMIT;
    this.form = f;
    this.text = name;
    this.formAction = variationsFromForm.getHref(); //issue_ELE_6
  }

  public StringBuffer toHtmlStringBuffer() {

    StringBuffer sb = new StringBuffer(512);

    if (this.enabled) {
      if (displayTable) {
        sb.append("<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\"");
        generateUrl(sb);
        sb.append(" ><tr><td align=\"center\"><a href=\"#\">\n");
      }
    }

    StringBuffer sbT = new StringBuffer(512);
    if (text != null) {

      if (displayTable) {
        openSpan(sb);
        sbT.append(text);
      } else {
        sbT.append("<a href=\"#\" ");
        generateUrl(sbT);
        openSpan(sbT);
        sbT.append('>');
        sbT.append(text);
        sbT.append("</span>");
        sbT.append("</a>");
      }
      if (displayTable)
        sbT.append("</span>");
    }

    StringBuffer sbI = new StringBuffer(512);
    if (image != null)
      sbI.append(image.toHtmlStringBuffer(null));

    if (textAfterImage)
      sb.append(sbI).append(sbT);
    else
      sb.append(sbT).append(sbI);

    if (this.enabled && displayTable)
      sb.append("</a></td></tr></table>");


    return sb;
  }

  private void generateUrl(StringBuffer sb) {

    if (enabled) {
      sb.append(" onClick=\"");

      sb.append(getHref());
      if (additionalOnClickScript != null && additionalOnClickScript.trim().length() > 0)
        sb.append(additionalOnClickScript);

      if (target != null && target.trim().length() > 0)
        sb.append("obj('").append(form.getUniqueName()).append("').target='").append(HTMLEncoderOld.removeBadCharsFromJSConstant(target)).append("'; ");

      //issue_ELE_6
      if (formAction != null && formAction.length() > 0 && !formAction.equals(form.url.getHref()))
        sb.append("obj('").append(form.getUniqueName()).append("').action='" + formAction + "'; ");

      sb.append("obj('").append(form.getUniqueName()).append("').submit();\" ");

      if (additionalScript != null && additionalScript.trim().length() > 0)
        sb.append(' ').append(additionalScript);

      if (tabIndex != 0) {
        sb.append(" tabindex=\"").append(tabIndex).append('\"');
      }

    }
  }

  private void openSpan(StringBuffer sb) {
    if (displayTable) {
      if (this.hasFocus)
        sb.append("<span class=\"").append(htmlClassOn).append("\">");
      else
        sb.append("<span class=\"").append(htmlClassOff).append("\">");
    } else {
      sb.append(Link.swapOnMouseOver(htmlClassOn, htmlClassOff));
    }
  }
}
