package org.jblooming.waf.html.container;

import org.jblooming.PlatformRuntimeException;
import org.jblooming.waf.html.core.HtmlBootstrap;
import org.jblooming.waf.html.core.JspHelper;
import org.jblooming.waf.view.PageState;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.PageContext;
import java.io.IOException;

public class Box extends JspHelper implements HtmlBootstrap { 

  public String title;
  public String width = "100%";
  public String height = null;

  /**
   * Level of nestedness in page layout. If > 0, extends the style with postfix _[level]
   */
  public int level = 0;

  private boolean closeBoxCalled;
  private boolean openBoxCalled = false;
  
  public static final String init = Box.class.getName();

  public static final String BOX_START = "BOX_START";
  public static final String BOX_END = "BOX_END";
  public static final String BOX_INITIALIZE = "BOX_INITIALIZE";
  public static final String BOX_BOOTSTRAP = "BOX_BOOTSTRAP";


  public Box() {
    this(null);
  }

   public String getDiscriminator() {
    return id;
  }

  public Box(String id) {
    this.urlToInclude = "/commons/layout/partBox.jsp";
    if (id != null)
      this.id = id;
  }

   private void init(PageContext pageContext) {
    PageState ps = PageState.getCurrentPageState((HttpServletRequest) pageContext.getRequest());
    if (!ps.initedElements.contains(init)) {
      pageContext.getRequest().setAttribute(ACTION, BOX_INITIALIZE);
      super.toHtml(pageContext);
      ps.initedElements.add(init);
    }
  }

  public void start(PageContext pageContext)  {
    openBoxCalled = true;
    init(pageContext); 
    pageContext.getRequest().setAttribute(ACTION, BOX_START);
    super.toHtml(pageContext);
  }

  public void end(PageContext pageContext)  {
    if (!openBoxCalled)
      throw new PlatformRuntimeException("Call start before end");
    closeBoxCalled = true;
    pageContext.getRequest().setAttribute(ACTION, BOX_END);
    super.toHtml(pageContext);
  }

  /**
   * @deprecated
   */
  public void toHtml(PageContext pageContext) {
    throw new RuntimeException("Call start and end");
  }

   public String getCssLevel() {
    return level!=0 ?  "_"+level : "";
  }

   public boolean validate(PageState pageState) throws IOException, ServletException {
    return openBoxCalled && closeBoxCalled;
  }

}
