package org.jblooming.waf.html.container;

import org.jblooming.utilities.JSP;
import org.jblooming.waf.html.button.ButtonJS;
import org.jblooming.waf.html.button.ButtonSupport;
import org.jblooming.waf.html.core.JspHelper;
import org.jblooming.waf.view.PageSeed;
import org.jblooming.waf.view.PageState;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.PageContext;

/**
 * @author Roberto Bicchierai rbicchierai@open-lab.com
 *         Date: 22-set-2005 : 14.20.15
 */
public class Popupper extends JspHelper {

  public Container container;

  public static final String init = Popupper.class.getName();

  public Popupper(String id,PageState pageState) {
    super("/commons/layout/partPopupper.jsp");
    container = new Container(pageState);
    this.id=id;
    container.id="popcnt_"+id;
    container.status=Container.HIDDEN;
    container.absolutePosition=true;
    container.top="0";
    container.left="0";

    container.draggable=true;
    container.closeable=true;
    container.overflow="auto";
    //container.collapsable=true;
  }


  private void init(PageContext pageContext) {
    PageState ps = PageState.getCurrentPageState((HttpServletRequest) pageContext.getRequest());
    if (!ps.initedElements.contains(getDiscriminator())) {
      pageContext.getRequest().setAttribute(ACTION, INITIALIZE);
      super.toHtml(pageContext);
      ps.initedElements.add(getDiscriminator());
    }
  }


  public ButtonSupport getPopupperButton(PageSeed pageSeed, String popupTitle) {
    ButtonJS bjs = new ButtonJS();

    bjs.onClickScript=  "loadSyncroContent('"+pageSeed.toLinkToHref()+"','"+getPopupDivId()+"'); " +
            "obj('"+container.getContainerTitleId()+"').innerHTML='"+ JSP.javascriptEncode(popupTitle)+"'; " +
            "centerObject('"+container.getContainerTableId()+"'); " +
            "displayDiv('"+container.getContainerTableId()+"');"+
            "centerObject('"+container.getContainerTableId()+"'); " ;
    return bjs;
  }


  public void toHtml(PageContext pageContext) {
    init(pageContext);
  }

  public String getId() {
    return id;
  }

  public String getDiscriminator() {
    return getId();
  }

  public String getPopupDivId() {
    return "POP_DIV_" + getId();
  }

  public String getPopupContainerId() {
    return "POP_DIV_CONT" + getId();
  }


}
