package org.jblooming.waf.html.container;

import org.jblooming.ontology.Node;
import org.jblooming.ontology.PerformantNodeSupport;
import org.jblooming.waf.constants.Commands;
import org.jblooming.waf.constants.Fields;
import org.jblooming.waf.html.core.JspHelper;
import org.jblooming.waf.html.state.Form;
import org.jblooming.waf.view.ClientEntries;
import org.jblooming.waf.view.PageState;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.PageContext;
import java.io.IOException;
import java.util.*;

/**
 * Created averacchi
 */
public class TreeCollector extends JspHelper {
  public String title;
  public PerformantNodeSupport root;
  private int padding;
  public int highlightValue;
  public int maxFontSize;
  public int minFontSize;
  public int gabSize;
  public HttpServletRequest request;
  public boolean selectParent;
  public boolean memory;
  private int depth;
  private int actualDepth = 1;
  public  static String  keySeparator ="#";
  public int checkBoxCellSize = -1;
  public boolean resizeRootChildren = true;

  public Form form;
  public String height;

  public boolean horizontalLayout = true;
  public boolean manageNode = false;
  public boolean rootSelect = true;
  public ButtonBar buttonbar=new ButtonBar();
  public int level = 0; 
  /**
   * makes sense only if not horizontalLayout
   */
  public boolean candidatesAbove = true;

  public TreeMap checkBoxes;
  //todo
  public TreeMap radioButtons;

  public String firstPaneWidth = "49%";
  public String centralPaneWidth = "2%";
  public String secondPaneWidth = "49%";

  public static final String DRAW_CANDIDATES = Fields.FORM_PREFIX + "DCND";
  public static final String DRAW_CHOSEN = Fields.FORM_PREFIX + "DCHS";

  public String CANDIDATES_LABEL = "Candidates";
  public String CHOSEN_LABEL = "Chosen";
  public String MOVE_ALL_TO_SELECTED_LABEL = ">>";
  public String MOVE_ALL_TO_SELECTED_TITLE = "Move all to chosen";
  public String MOVE_TO_SELECTED_LABEL = ">";
  public String MOVE_TO_SELECTED_TITLE = "Move selected to chosen";
  public String MOVE_TO_UNSELECTED_LABEL = "<";
  public String MOVE_TO_UNSELECTED_TITLE = "Move selected to candidates";
  public String MOVE_ALL_TO_UNSELECTED_LABEL = "<<";
  public String MOVE_ALL_TO_UNSELECTED_TITLE = "Move all to candidates";
  public String SYNCHRONIZE_LABEL = "<>";
  public String SYNCHRONIZE_TITLE = "Synchonize";
  public String NO_CANDIDATES = "No candidates";
  public String NO_CHOSEN = "No chosen ones";

  public static final String FLD_CAND_HIDDEN_ID = Fields.FORM_PREFIX + "CA_HID";
  public static final String FLD_CHS_HIDDEN_ID = Fields.FORM_PREFIX + "CH_HID";
  public static final String FLD_CAND_KEY = Fields.FORM_PREFIX + "CND_KEY";
  public static final String FLD_CHOSEN_KEY = Fields.FORM_PREFIX + "CHS_KEY";
  public static final String FLD_CHECK_ADDITIONAL = Fields.FORM_PREFIX + "F_C_A";
  public static final String FLD_RADIO_ADDITIONAL = Fields.FORM_PREFIX + "F_R_A";

  public static final String FLD_SEL_ELT_FROM = Fields.FORM_PREFIX + "F_S_E_F";
  public static final String FLD_SEL_ELT_TO = Fields.FORM_PREFIX + "F_S_E_T";

  public static final String ALL = Fields.FORM_PREFIX + "ALL";
  public static final String COMPONENT_ACTION = "FUNNYTREE_ACTION";
  public static final String CONTAINER = "CONTAINER";
  private boolean justTree;
  public String style = "width:100%";
  public boolean checkBoxesDisabled = false;
  /**
   * @deprecated with no use
   */
  public boolean displayPath = false;
  

/*_____________________________________________________________________________________

   FROM COLLECTOR
_________________________________________________________________
*/

  public TreeCollector(String id, String title, String height, Form form) {
    this(id, title, height, form, false);
  }

  public TreeCollector(String id, String title, String height, Form form, boolean justTree) {
    this.justTree = justTree;
    this.id = id;
    urlToInclude = "/commons/layout/partTreeCollector.jsp";
    this.form = form;
    this.height = height;
    this.title = title;
  }

  public void setTree(PerformantNodeSupport root, boolean selectParent, boolean memory, int depth, int padding, int highlightValue, int maxFontSize, int minFontSize, int gabSize) {
    this.selectParent = selectParent;
    this.memory = memory;
    this.depth = depth;
    this.root = root;
    this.padding = padding;

    this.highlightValue = highlightValue;
    this.maxFontSize = maxFontSize;
    this.minFontSize = minFontSize;
    this.gabSize = gabSize;
  }

  public void setTree(List<? extends PerformantNodeSupport> listNodes, boolean selectParent, boolean memory, int depth, int padding, int highlightValue, int maxFontSize, int minFontSize, int gabSize) {
    this.selectParent = selectParent;
    this.memory = memory;
    this.depth = depth;
    this.padding = padding;
    this.highlightValue = highlightValue;
    this.maxFontSize = maxFontSize;
    this.minFontSize = minFontSize;
    this.gabSize = gabSize;

    InnerNode relativeRoot = new InnerNode();
    for(int i = 0; i<listNodes.size(); i++)
      relativeRoot.addChild(listNodes.get(i));
    this.root = relativeRoot;
  }

  public void treeCollectorControl(PageState pageState) {
  }

  public String realizeTree() {
    StringBuffer treeBody = new StringBuffer();
    if (root.getChildrenNode() == null)
      return "";
    ArrayList<PerformantNodeSupport> listCN = new ArrayList(root.getChildrenNode());
    Collections.sort(listCN, new Comparator() {
      public int compare(Object a, Object b) {
        return ((PerformantNodeSupport) a).getName().compareTo(((PerformantNodeSupport) b).getName());
      }
    });
    for (int i = 0; i < listCN.size(); i++) {
      PerformantNodeSupport caNode = listCN.get(i);
      supportRealizeTree(caNode, treeBody);
    }
    return treeBody.toString();
  }

  private StringBuffer supportRealizeTree(PerformantNodeSupport caNodeParent, StringBuffer treeBody) {
    ArrayList<PerformantNodeSupport> listCN = new ArrayList(caNodeParent.getChildrenNode());
    Collections.sort(listCN, new Comparator() {
      public int compare(Object a, Object b) {
        return ((PerformantNodeSupport) a).getName().compareTo(((PerformantNodeSupport) b).getName());
      }
    });
    if (listCN.size() == 0 || actualDepth == depth) {
      treeBody.append("<div><div myId=\"" + caNodeParent.getId() + "\">&middot;&nbsp;");
      treeBody.append(caNodeParent.getName());
      treeBody.append("</div></div>\n");
      return treeBody;
    }

    treeBody.append("<div><div myId=\"" + caNodeParent.getId() + "\">");
    if (selectParent)
      treeBody.append("<span>+&nbsp;</span>");
    else
      treeBody.append("+&nbsp;");

    treeBody.append(caNodeParent.getName());
    treeBody.append("</div>");
    treeBody.append("<span style=\"padding-left:" + padding + "px;display:none;\">\n");
    for (int i = 0; i < listCN.size(); i++) {
      PerformantNodeSupport caNode = listCN.get(i);
      actualDepth++;
      treeBody = supportRealizeTree(caNode, treeBody);
      actualDepth--;
    }
    treeBody.append("</span></div>\n");
    return treeBody;
  }

/*_____________________________________________________________________________________

FROM COLLECTOR
____________________________________________________________________________
*/

  public String getDiscriminator() {
    return TreeCollector.class.getName();
  }

  public boolean bootstrap(PageState pageState, PageContext pageContext) throws IOException, ServletException {
    return true;
  }

  /**
   * Moves according to the action the selected ones as client entries to each side
   * altering the the TreeMap pair {candidates, chosen}
   *
   * @param pageState
   */
  public static void move(String id, PageState pageState) {
    String command = pageState.getCommand();
    ClientEntries ces = pageState.getClientEntries();

    String candidateFieldPrefix = TreeCollector.getCandidateFieldPrefix(id);
    String chosenFieldPrefix = TreeCollector.getChosenFieldPrefix(id);

    if ((Commands.MOVE_ALL_TO_SELECTED + id).equals(command))
      moveAll(candidateFieldPrefix, chosenFieldPrefix, ces, pageState);
    else if ((Commands.MOVE_TO_SELECTED + id).equals(command)) {
      moveTo(id, FLD_CHOSEN_KEY, chosenFieldPrefix, candidateFieldPrefix, ces, pageState);
      //move sel chosen to cands
    } else if ((Commands.MOVE_TO_UNSELECTED + id).equals(command)) {
      moveTo(id, FLD_CAND_KEY, candidateFieldPrefix, chosenFieldPrefix, ces, pageState);
    } else if ((Commands.SYNCHRONIZE + id).equals(command)) {
      synchronize( id,  pageState);
    } else if ((Commands.MOVE_ALL_TO_UNSELECTED + id).equals(command))
      moveAll(chosenFieldPrefix, candidateFieldPrefix, ces, pageState);
  }

  public static void synchronize(String id, PageState pageState) {
    moveTo(id, FLD_CHOSEN_KEY, TreeCollector.getChosenFieldPrefix(id), TreeCollector.getCandidateFieldPrefix(id), pageState.getClientEntries(), pageState);
    moveTo(id, FLD_CAND_KEY, TreeCollector.getCandidateFieldPrefix(id), TreeCollector.getChosenFieldPrefix(id), pageState.getClientEntries(), pageState);
  }

  private static void moveTo(String id, String fldKey, String newPrefix, String oldPrefix, ClientEntries ces, PageState pageState) {

    if (ces.getEntryKeys() != null) {
      Iterator i = new HashSet(ces.getEntryKeys()).iterator();
      while (i.hasNext()) {
        String key = (String) i.next();
        if (key.startsWith(fldKey + id)) {
          String keyMap = newPrefix + key.substring((fldKey + id).length());
          String hiddenFldCe = oldPrefix;
          String oldEntry = hiddenFldCe + keyMap.substring((fldKey + id).length() - 1);
          String refreshValue = ces.getEntry(oldEntry).stringValueNullIfEmpty();

          if(FLD_CHOSEN_KEY.equals(fldKey))  {
            if(refreshValue.indexOf(",")!=-1)
              refreshValue = refreshValue.substring(refreshValue.indexOf(",")+1,refreshValue.length());
          }
          pageState.addClientEntry(keyMap, refreshValue);
          ces.deleteEntry(oldEntry);
        }
      }
    }
  }

  private static void moveAll(String oldField, String newField, ClientEntries ces, PageState pageState) {
    if (ces.getEntryKeys() != null) {
      Iterator i = new HashSet(ces.getEntryKeys()).iterator();
      while (i.hasNext()) {
        String key = (String) i.next();
        if (key.startsWith(oldField)) {
          pageState.addClientEntry(newField + key.substring(oldField.length()), ces.getEntry(key).stringValueNullIfEmpty());
          ces.deleteEntry(key);
        }
      }
    }
  }

  public static boolean isTreeCollectorCommand(String id, String cmd) {
    return (Commands.MOVE_ALL_TO_SELECTED + id).equals(cmd) ||
            (Commands.MOVE_TO_SELECTED + id).equals(cmd) ||
            (Commands.MOVE_TO_UNSELECTED + id).equals(cmd) ||
            (Commands.MOVE_ALL_TO_UNSELECTED + id).equals(cmd) ||
            (Commands.SYNCHRONIZE + id).equals(cmd);
  }

  public static String getCandidateFieldPrefix(String id) {
    return FLD_CAND_HIDDEN_ID + id;
  }

  public static String getChosenFieldPrefix(String id) {
    return FLD_CHS_HIDDEN_ID + id;
  }

   public static String getSelectEltFromPrefix(String id) {
    return FLD_SEL_ELT_FROM + id;
  }

  public static String getSelectEltToPrefix(String id) {
    return FLD_SEL_ELT_TO + id;
  }

  public static String getChosenCheckValue(String key) {
    return FLD_CHOSEN_KEY + key.substring(FLD_CAND_HIDDEN_ID.length());
  }

  public static String getCandidateCheckValue(String key) {
    return FLD_CAND_KEY + key.substring(FLD_CHS_HIDDEN_ID.length());
  }

  public static void make(String id, TreeMap candidates, TreeMap chosen, PageState pageState, boolean tree) {
    if (tree) {
      if (chosen != null && chosen.size() > 0) {
        StringBuffer allMyId = new StringBuffer();
        for (Iterator iterator = chosen.keySet().iterator(); iterator.hasNext();) {
          int key = (Integer) iterator.next();
          allMyId.append(key + ";");
        }
        pageState.addClientEntry("allMyId"+id, allMyId.toString());
      }
      if (chosen != null && chosen.size() > 0) {
        for (Iterator iterator = chosen.keySet().iterator(); iterator.hasNext();) {
          Object key = iterator.next();
          String value = (String) chosen.get(key);
          pageState.addClientEntry(getChosenFieldPrefix(id) + value + keySeparator + key, chosen.get(key).toString() + keySeparator + key);
        }
      }
    } else {
      if (candidates != null && candidates.size() > 0) {
        for (Iterator iterator = candidates.keySet().iterator(); iterator.hasNext();) {
          Object key = iterator.next();
          pageState.addClientEntry(getCandidateFieldPrefix(id) + key, candidates.get(key).toString());
        }
      }
      if (chosen != null && chosen.size() > 0) {
        for (Iterator iterator = chosen.keySet().iterator(); iterator.hasNext();) {
          Object key = iterator.next();
          pageState.addClientEntry(getChosenFieldPrefix(id) + key, chosen.get(key).toString());
        }
      }
    }
  }

  public static String getKeyCollettor(String idCollector,String eltID,String eltKeyvalue,String keySeparator){
    String key=getChosenFieldPrefix(idCollector) + eltKeyvalue + keySeparator + eltID ;
    return key;
  }

   public static String getKeyAddcheckBoxes(String id, String key,String rowId){
    return TreeCollector.FLD_CHECK_ADDITIONAL+id+key.substring((getCandidateFieldPrefix(id)).length())+rowId;
  }

  /**
   * Makes a snapshot of current candidates and chosen of the MyCollector of id <code>id</code> returning them
   * collected in TreeMap[0],TreeMap[1] respectively.
   */
  public static TreeMap<String,String>[] snapShot(String id, PageState pageState) {

    TreeMap<String,String> cands = new TreeMap<String,String>();
    TreeMap<String,String> chosen = new TreeMap<String,String>();
    ClientEntries ces = pageState.getClientEntries();
    if (ces.getEntryKeys() != null) {
      Iterator i = new HashSet(ces.getEntryKeys()).iterator();
      while (i.hasNext()) {
        String key = (String) i.next();
        if (key.indexOf(TreeCollector.FLD_CAND_HIDDEN_ID + id) != -1)
          cands.put(key.substring((TreeCollector.FLD_CAND_HIDDEN_ID + id).length()), ces.getEntry(key).stringValueNullIfEmpty());
        else if (key.indexOf(TreeCollector.FLD_CHS_HIDDEN_ID + id) != -1) {
          chosen.put(key.substring((TreeCollector.FLD_CHS_HIDDEN_ID + id).length()), ces.getEntry(key).stringValueNullIfEmpty());
        }
      }
    }
    return new TreeMap[]{cands, chosen};
  }

  public static TreeMap<String,String> chosen(String id, PageState pageState) {
    return snapShot(id, pageState)[1];
  }

  public static TreeMap<String,String> cands(String id, PageState pageState) {
    return snapShot(id, pageState)[0];
  }

  /**
   * @return a map with as keys the id of the chosen element, as value a list of its selected checkboxes
   */
  public static Map<String,List<String>> selectedCheckBoxes(String collectorId, PageState pageState) {
    TreeMap<String,List<String>> selChecks = new TreeMap<String,List<String>>();
    Set ids = snapShot(collectorId, pageState)[1].keySet();
    ClientEntries ces = pageState.getClientEntries();
    if (ces.getEntryKeys() != null) {
      Iterator i = new HashSet(ces.getEntryKeys()).iterator();
      while (i.hasNext()) {
        String key = (String) i.next();
        if (key.startsWith(TreeCollector.FLD_CHECK_ADDITIONAL + collectorId)) {
          String idAndAddFld = key.substring((TreeCollector.FLD_CHECK_ADDITIONAL + collectorId).length());
          //find id
          if (ids != null && ids.size() > 0) {
            for (Iterator iterator = ids.iterator(); iterator.hasNext();) {
              String id = (String) iterator.next();
              if (idAndAddFld.startsWith(id)) {
                List checkedForId = selChecks.get(id);
                if (checkedForId == null)
                  checkedForId = new ArrayList();
                checkedForId.add(idAndAddFld.substring(id.length()));
                selChecks.put(id, checkedForId);
              }
            }
          }
        }
      }
    }
    return selChecks;
  }

  /**
   * @return a map with as keys the id of the chosen element, as value the value of the selected radio
   */
  public static Map<String,String> selectedRadios(String collectorId, PageState pageState) {
    TreeMap<String,String> selChecks = new TreeMap<String,String>();
    Set ids = snapShot(collectorId, pageState)[1].keySet();
    ClientEntries ces = pageState.getClientEntries();
    if (ces.getEntryKeys() != null) {
      Iterator i = new HashSet(ces.getEntryKeys()).iterator();
      while (i.hasNext()) {
        String key = (String) i.next();
        if (key.startsWith(TreeCollector.FLD_RADIO_ADDITIONAL)) {
          String idAndAddFld = key.substring(TreeCollector.FLD_RADIO_ADDITIONAL.length());
          //find id
          if (ids != null && ids.size() > 0) {
            for (Iterator iterator = ids.iterator(); iterator.hasNext();) {
              String id = (String) iterator.next();
              if (idAndAddFld.startsWith(collectorId + id)) {
                selChecks.put(id, ces.getEntry(key).stringValueNullIfEmpty());
              }
            }
          }
        }
      }
    }
    return selChecks;
  }

  public void setItalianDefaultLabels() {
    this.MOVE_ALL_TO_SELECTED_TITLE = "Seleziona tutti";
    this.MOVE_TO_SELECTED_TITLE = "Seleziona";
    this.MOVE_TO_UNSELECTED_TITLE = "Deseleziona";
    this.MOVE_ALL_TO_UNSELECTED_TITLE = "Deseleziona tutti";

    this.NO_CANDIDATES = "Non vi sono proprietà da scegliere.";
    this.NO_CHOSEN = "Non vi sono proprietà selezionate per il passo.";

    this.CANDIDATES_LABEL = "propietà selezionabili";
    this.CHOSEN_LABEL = "propietà selezionate";
  }

  public static void addSelectedCheckBox_old(String collectorId, String rowId, String checkBoxName, PageState pageState) {
    //pageState.addClientEntry(MyCollector.FLD_CHECK_ADDITIONAL+collectorId+checkBoxName,checkBoxName);
    pageState.addClientEntry(TreeCollector.FLD_CHECK_ADDITIONAL + collectorId + rowId + checkBoxName, "on");
  }

  public static void addSelectedCheckBox(String id, String rowId, String checkBoxName, PageState pageState) {
  //pageState.addClientEntry(MyCollector.FLD_CHECK_ADDITIONAL+collectorId+checkBoxName,checkBoxName);
    //pageState.addClientEntry(TreeCollector.FLD_CHECK_ADDITIONAL + id + rowId + checkBoxName, "on");
    pageState.addClientEntry(getKeyAddcheckBoxes(id, rowId,checkBoxName), "on");
  }

  public boolean showOnlyTree() {
    return justTree;
  }

  public class InnerNode extends PerformantNodeSupport {

    Set<PerformantNodeSupport> children = new HashSet();
    public Node getParentNode() {
      return null;
    }
    public void addChild(PerformantNodeSupport node){
      children.add(node);
    }
    public Collection getChildrenNode() {
      return children;
    }

    public void setParentNode(Node node) {}
  }
}
