package org.jblooming.waf.html.display;

import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.criterion.Example;
import org.hibernate.criterion.MatchMode;
import org.jblooming.ontology.IdentifiableSupport;
import org.jblooming.ontology.LoggableIdentifiableSupport;
import org.jblooming.oql.OqlQuery;
import org.jblooming.persistence.hibernate.HibernateFactory;
import org.jblooming.waf.constants.Fields;
import org.jblooming.waf.html.core.JspHelper;
import org.jblooming.waf.html.state.Form;
import org.jblooming.waf.view.ClientEntries;
import org.jblooming.waf.view.ClientEntry;
import org.jblooming.waf.view.PageState;

import javax.servlet.jsp.PageContext;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.*;


/**
 * @author Alessandro Veracchi "the vandal" averacchi@open-lab.com
 */

public class CubeNavigator extends JspHelper {

  public static final String init = CubeNavigator.class.getName();

  public Map arrayFilters = null;
  public String whichScreenArea;
  public Organizer organizer = new Organizer();
  public Object obj;
  public Form form;
  private List allFieldsHead = null;
  public String title;

  public CubeNavigator(String id, String whichScreenArea, Object obj, Form form) {
    this(id, null, whichScreenArea, obj, null, form);
  }

  public CubeNavigator(String id, String title, String whichScreenArea, Object obj, String[] AllfieldsHead, Form form) {
    /* obj gioca un ruolo importante:
    * innanzi tutto da la tipologia di quale file sto cercando
    * in secondo luogo dando valori hai suoi field creo implicitamente un clausula (rappresentata da lui stesso
    * dove viene utilizzato tramite Example di hibernate) con cui interrogo le informazioni persistenti
    */
    if (AllfieldsHead == null) this.allFieldsHead = CubeNavigator.getFieldsClazz(obj);
    else {
      this.allFieldsHead = new LinkedList();
      for (int i = 0; i < AllfieldsHead.length; i++) {
        this.allFieldsHead.add(AllfieldsHead[i]);
      }

    }
    this.id = id;
    urlToInclude = "/commons/layout/partCubeNavigator.jsp";
    this.whichScreenArea = whichScreenArea;
    this.obj = obj;
    this.form = form;
    if (title != null) this.title = title;
    else this.title = "Browse " + obj.getClass().getName();

  }


  private void init(PageContext pageContext) {
//    PageState ps = PageState.getCurrentPageState((HttpServletRequest) pageContext.getRequest());
//    if (!ps.initedElements.contains(init)) {
//      pageContext.getRequest().setAttribute(ACTION, INITIALIZE);
//      super.toHtml(pageContext);
//      ps.initedElements.add(init);
//    }
  }

  public void toHtml(PageContext pageContext) {

    init(pageContext);

    pageContext.getRequest().setAttribute(ACTION, "");
    super.toHtml(pageContext);
  }

  public void setCubeNavigator(Set values, String field, List fieldsHead, String valueActionedCombo) {
    List machFields = null;
    Object[] clausuleObjs = null;
    Object[] startObj = new Object[]{obj};

    /* 1) solo al primo avvio della pagina, seleziono automaticamente il primo attributo della classe in esame */
    if (field == null) field = (String) fieldsHead.iterator().next();

    /* 2) ho selezionato un QUALSIASI campo relativo ad un attributo della classe, anche uno passato */
    if (values == null) {

      /* 2.a) ci sono state selezioni passate con coppie campo valore */
      if (arrayFilters != null) clausuleObjs = getClausuleObjectsFromValues(arrayFilters, startObj);

      /* 2.b) selezione presente solo dal campo */
      if (clausuleObjs == null) clausuleObjs = startObj;
      machFields = getObjectsFromField(field, clausuleObjs);
    }

    /* 3) ho selezionato uno o pi� valori per un QUALSIASI campo, quindi anche uno passato */
    if (values != null) {

      /* 3.c) aggiorno gli arrayFilters per aggiornare organizer */
      if (arrayFilters == null) arrayFilters = new HashMap();
      arrayFilters.put(field, values);
      clausuleObjs = getClausuleObjectsFromValues(arrayFilters, startObj);
      if (valueActionedCombo == null) {
        Iterator itField = fieldsHead.iterator();
        if (itField.hasNext()) {
          field = (String) itField.next();
          machFields = getObjectsFromField(field, clausuleObjs);
        }
      } else {
        field = valueActionedCombo;
        machFields = getObjectsFromField(valueActionedCombo, clausuleObjs);
      }

    }
    organizer.addColumn(field, fieldsHead, machFields);
    //lastElement = false;
  }

  private List getObjectsFromField(String field, Object[] clausuleObjs) {
    /* per ogni oggetto clausula mi calcolo i valori di macth */
    Set TempMatchValues = new HashSet();
    List matchValues = new LinkedList();
    for (int countObj = 0; countObj < clausuleObjs.length; countObj++) {
      List objectSet = new LinkedList();
      List matchObjects = new LinkedList();
      Object obj = clausuleObjs[countObj];
      objectSet.add(obj);
      Class clazz = obj.getClass();
      Field[] fields = clazz.getDeclaredFields();
      //QUI per ogni campo che NON restituisci stringa eseguo il metodo//
      for (int i = 0; i < fields.length; i++) { //TODO QUI VA IL FILTRO DEI FILTRI
        Field reflectionField = fields[i];
        //if(Modifier.STATIC == reflectionField.getModifiers()) continue;
        if (!String.class.isAssignableFrom(reflectionField.getType())) {   //se non � una stringa;
          try {
            reflectionField.setAccessible(true);
            if (reflectionField.get(obj) != null)
              objectSet.add(reflectionField.get(obj)); //un oggetto con cui istanzio un criterio per clausula
          } catch (IllegalAccessException e) {                                             // all'inizio sono tutti nulli
            e.printStackTrace();
          }
        }
      }
      try {
        matchObjects = findObjects(objectSet.toArray());
      } catch (HibernateException e) {
        e.printStackTrace();
      }
      /* ricostrisco i valori */
      for (int i = 0; i < matchObjects.size(); i++) {
        //Object matchObj = matchObjects.get(i);
        //----------------------------------------------------------
        IdentifiableSupport matchObj = (IdentifiableSupport) matchObjects.get(i);
        int macthObjectId = matchObj.getIntId();

        //----------------------------------------------------------
        Class clazzMachObj = matchObj.getClass();
        Field fieldMachObj = null;
        try {
          fieldMachObj = clazzMachObj.getDeclaredField(field);
          //if(Modifier.STATIC == fieldMachObj.getModifiers()) break;
          fieldMachObj.setAccessible(true);
          //----------------------------------
          // STRING
          //-----------------------------------
          if (String.class.isAssignableFrom(fieldMachObj.getType())) {
            if (!TempMatchValues.contains((String) fieldMachObj.get(matchObj))) {
              MatchValue mv = new MatchValue();
              mv.name = ((String) fieldMachObj.get(matchObj)).replaceAll(" ", "#");
              //System.out.println("[CubeNavigator] mv.name: "+mv.name+" (String) fieldMachObj.get(matchObj):"+(String) fieldMachObj.get(matchObj));
              TempMatchValues.add(mv.name);
              matchValues.add(mv);
            }
          }
          //-------------------------------------------------------
          // OBJECTs in matchObject org.jblooming.ontology.IdentifiableSupport try to catch the name and id
          //-------------------------------------------------------
          else if (LoggableIdentifiableSupport.class.isAssignableFrom(fieldMachObj.getType())) {
            if (!TempMatchValues.contains(((IdentifiableSupport) fieldMachObj.get(matchObj)).getName())) {
              IdentifiableSupport innerMatchObj = (IdentifiableSupport) fieldMachObj.get(matchObj);
              MatchValue mv = new MatchValue();
              mv.id = innerMatchObj.getIntId();
              mv.name = innerMatchObj.getName().replaceAll(" ", "#");
              mv.className = fieldMachObj.getType().getName();
              TempMatchValues.add(innerMatchObj.getName());
              matchValues.add(mv);
            }
          }
          //------------------------------------------
          // COLLECTION
          //-------------------------------------------
          else if (Collection.class.isAssignableFrom(fieldMachObj.getType())) {
            //lastElement = true;
            // SET
            if (fieldMachObj.get(matchObj) instanceof Set) {
              Set values = (Set) fieldMachObj.get(matchObj);
              Iterator itValues = values.iterator();
              while (itValues.hasNext()) {
                Object value = itValues.next();
                if (value instanceof String)
                  matchValues.add((String) value);
                else {
                  boolean done = false;
                  Field[] fieldsValue = value.getClass().getDeclaredFields(); //TODO si potrebbe fare ricorsivo in profondit�
                  for (int numField = 0; numField < fieldsValue.length; numField++) {
                    Field fieldValue = fieldsValue[numField];
                    if (String.class.isAssignableFrom(fieldMachObj.getType()) && !done) {
                      // if (fieldValue.getType().getName().indexOf("String") != -1 && !done) {
                      if (!TempMatchValues.contains((String) fieldMachObj.get(matchObj))) {
                        TempMatchValues.add((String) fieldValue.get(value));
                        matchValues.add((String) fieldValue.get(value));
                        done = true;
                      }
                    }
                  }
                }
              }
            }
          }
          //}
          //}
          /* else if (Object.class.isAssignableFrom(fieldMachObj.getType())) {
            lastElement = true;

            Object value = (Object) fieldMachObj.get(matchObj);
            Class clazzObjValue = value.getClass();
            Field[] fieldsObjValue = clazzObjValue.getDeclaredFields();
            for (int countFieldsObjValue = 0; countFieldsObjValue < fieldsObjValue.length; countFieldsObjValue++) {
              Field fieldObjValue = fieldsObjValue[countFieldsObjValue];
              fieldObjValue.setAccessible(true);
              if (String.class.isAssignableFrom(fieldObjValue.getType())) {
                if(TempMatchValues.contains((String) fieldObjValue.get(value))) break;
                else {
                  TempMatchValues.add((String) fieldObjValue.get(value));
                  matchValues.add((String) fieldObjValue.get(value));  //se metodo privato da eccezione
                  break;
                }
              }
            }
          }*/
        } catch (NoSuchFieldException e) {
          e.printStackTrace();
        } catch (IllegalAccessException e) {
          e.printStackTrace();
        }
      }
    }

    return matchValues;
  }


  private Object[] getClausuleObjectsFromValues(Map arrayFilters, Object[] objs) {

    List clausuleObjects = new LinkedList();
    clausuleObjects.add(objs[0]);
    Class clazz = objs[0].getClass();
    Method[] methods = clazz.getDeclaredMethods();
    Iterator itKeys = arrayFilters.keySet().iterator();
    /* prendo la chiave */
    while (itKeys.hasNext()) {
      String key = (String) itKeys.next();
      /* dalla chiave risalgo al metodo giusto */
      for (int i = 0; i < methods.length; i++) {
        Method method = methods[i];
        String methodName = method.getName();
        if (methodName.indexOf("set") != -1 && (methodName.toLowerCase()).indexOf(key.toLowerCase()) != -1)
        {    //QUI SI STANDARDIZZA LE STRINGHE A TUTTO MINUSCOLO  TODO: migliorare il controllo
          Set setOfValuesActualKey = (Set) arrayFilters.get(key);
          try {
            /* per ogni oggetto che ho mi passo i valori della chiave */
            int length = clausuleObjects.size();
            for (int countClonedObjs = 0; countClonedObjs < length; countClonedObjs++) {
              Object obj = clausuleObjects.get(0);
              Set tempSetOfValuesActualKey = new HashSet(setOfValuesActualKey);
              Iterator tempItSetOfValuesActualKey = tempSetOfValuesActualKey.iterator();
              while (tempItSetOfValuesActualKey.hasNext()) {
                Method clone = clazz.getMethod("clone", null);
                Cloneable clonedObj = (Cloneable) clone.invoke(obj, null);
                /* qui c'� la necessita di inserire la giusta successione tipata di argomenti
                * per come � stata realizzata la classe qui avr� sempre un set di Stringhe perch� � cosi che vengono
                * immagazinati nell jsp tramite values e poi in organizer, ma da questa successione di stringhe dovrei
                * riuscire a dare valore a tutti i field che mi interessano, compresi i field non stringa
                *
                * TODO: quindi la difficolta � capire quale oggetto il metodo si sta aspettando, non solo stringhe
                */
                //differenziare con la stessa struttra di quando ho relizzato il set di valori
                //Verifico se il valore appartiene ad una stringa//
                MatchValue mv = (MatchValue) tempItSetOfValuesActualKey.next();
                if (mv.id == 0) {
                  method.invoke(clonedObj, new Object[]{mv.name.replaceAll("#", " ")});
                } else {
                  OqlQuery oql = new OqlQuery("select obj from " + mv.className + " as obj where obj.id = :id");
                  oql.getQuery().setString("id", "" + mv.id);
                  List fieldMatchObj = oql.list();
                  method.invoke(clonedObj, new Object[]{fieldMatchObj.get(0)});
                  //String whereForId = "where width.id = :"+SmartCombo.FILTER_PARAM_NAME;
                }
                clausuleObjects.add(clonedObj);
              }
              clausuleObjects.remove(0);
            }

          } catch (Exception e) {
            e.printStackTrace();
          }
          break; //non controllo gli altri metodi
        }
      }
    }
    return clausuleObjects.toArray();
  }


  public static List getFieldsClazz(Object objClazz) {
    Class classObject = objClazz.getClass();
    //Field[] fieldsClazz = classObject.getFields();
    Field[] fieldsClazz = classObject.getDeclaredFields();
    List fieldsHead = new LinkedList();
    int numColumn = fieldsClazz.length;
    for (int i = 0; i < numColumn; i++) {
      fieldsHead.add(fieldsClazz[i].getName());
    }
    return fieldsHead;
  }

  public Organizer getNewOrganizer() {
    return new Organizer();
  }

  public List findObjects(Object[] objs) throws HibernateException {
    List examples = new LinkedList();
    for (int i = 0; i < objs.length; i++) {
      Example example = Example.create(objs[i]).ignoreCase().enableLike(MatchMode.ANYWHERE);
      examples.add(example);
    }
    Iterator itExamples = examples.iterator();
    Criteria cri = HibernateFactory.getSession().createCriteria(objs[0].getClass())
      .setResultTransformer(Criteria.DISTINCT_ROOT_ENTITY)
      .add((Example) itExamples.next());

    // codice originale by Peru
//    while (itExamples.hasNext()) {
//    Field[] fields = objs[0].getClass().getDeclaredFields();
//    String fieldName = null;
//    for(int i = 0; i<fields.length; i++){
//      for(int count = 1; count < objs.length; count++) {
//        String className = objs[count].getClass().getName();
//        if(fields[i].getType().getName().equals(className)){
//          fieldName = fields[i].getName();
//          cri = cri.createCriteria(fieldName).add((Example) itExamples.next());
//          break;
//        }
//      }
//
//    }

    // codice modificato by Fero
    for (Object o : examples) {
      Example e = (Example) o;
      Field[] fields = objs[0].getClass().getDeclaredFields();
      String fieldName = null;
      for (int i = 0; i < fields.length; i++) {
        for (int count = 1; count < objs.length; count++) {
          String className = objs[count].getClass().getName();
          if (fields[i].getType().getName().equals(className)) {
            fieldName = fields[i].getName();
            cri = cri.createCriteria(fieldName).add(e);
            break;
          }
        }
      }

      //count++;
    }
    return cri.list();

  }

  public void surfInUSA(PageState pageState) {

    String valueActionedCombo = null;
    //boolean back = false;
    int numColumn = -1;

    /* set field and values */
    try {
      ClientEntries ces = pageState.getClientEntries();
      if (ces.getEntry(Fields.FORM_PREFIX + "cubeNav" + id + "_numActionedColumn") != null &&
        !ces.getEntry(Fields.FORM_PREFIX + "cubeNav" + id + "_numActionedColumn").stringValue().equals(""))
        numColumn = Integer.parseInt(ces.getEntry(Fields.FORM_PREFIX + "cubeNav" + id + "_numActionedColumn").stringValue());

      if (ces.getEntry(Fields.FORM_PREFIX + "cubeNav" + id + "_valueActionedCombo") != null &&
        !ces.getEntry(Fields.FORM_PREFIX + "cubeNav" + id + "_valueActionedCombo").stringValue().equals(""))
        valueActionedCombo = ces.getEntry(Fields.FORM_PREFIX + "cubeNav" + id + "_valueActionedCombo").stringValue();

      Iterator itCeKeys = ces.getEntryKeys().iterator();

      // Realize arrayFields : key = field; values = checked checkBoxes
      itCeKeys = ces.getEntryKeys().iterator();
      Map mapForFields = new HashMap();
      Map mapForValues = new HashMap();
      while (itCeKeys.hasNext()) {
        String ceKey = (String) itCeKeys.next();
        ClientEntry ce = ces.getEntry(ceKey);
        if (ce.name.matches(Fields.FORM_PREFIX + "cubeNav" + id + "_checkbox_[0-9]*_.*")) {
          String[] elementsName = ce.name.split("_");
          //in elementsName[4] there is the column number
          //in elementsName[5] there is the name of the value
          //in elementsName[6] there is id
          //in elementsName[7] there is nameClass
          if (mapForValues.get(elementsName[4]) == null) {
            // genero il set che raccogliera i valori e inserisco il primo
            Set elOfmapForValues = new HashSet();
            MatchValue mv = new MatchValue();
            mv.name = elementsName[5];
            mv.id = Integer.parseInt(elementsName[6]);
            mv.className = elementsName[7];
            elOfmapForValues.add(mv);
            mapForValues.put(elementsName[4], elOfmapForValues);

          } else {
            // aggiungo un valore al set di vaori gi� esistente
            Set elOfmapForValues = (Set) mapForValues.get(elementsName[4]);
            MatchValue mv = new MatchValue();
            mv.name = elementsName[5];
            mv.id = Integer.parseInt(elementsName[6]);
            mv.className = elementsName[7];
            elOfmapForValues.add(mv);
          }
        }
        if (ce.name.matches(Fields.FORM_PREFIX + "cubeNav" + id + "_select_.*")) {
          String[] elementsName = ce.name.split("_");
          //in elementsName[4] there is the column number
          if (mapForFields.get(elementsName[4]) == null) {
            mapForFields.put(elementsName[4], ce.stringValue());
          }
        }
      }

      List allInfo = new LinkedList();
      for (int countField = 0; countField < mapForFields.size(); countField++) {

        String tempField = (String) mapForFields.get("" + countField);
        Set tempValues = (Set) mapForValues.get("" + countField);
        allInfo.add(new Object[]{tempField, tempValues});
      }

      List fieldsHead = new LinkedList(allFieldsHead);
      /* clausua per la prima colonna */
      if (allInfo.size() != 0) setCubeNavigator(null, (String) ((Object[]) allInfo.get(0))[0], allFieldsHead, null);
      else setCubeNavigator(null, null, allFieldsHead, null);

      /* la clausula per la colonna futura */
      int internalCountColumn = 0;
      for (int countSize = 0; countSize < allInfo.size(); countSize++) {
        if (numColumn == -1 || internalCountColumn < numColumn) {
          String tempField = (String) ((Object[]) allInfo.get(countSize))[0];
          Set tempValues = (Set) ((Object[]) allInfo.get(countSize))[1];
          if (tempValues == null || tempValues.size() == 0) break;
          fieldsHead.remove(tempField);
          if ((internalCountColumn + 1) == numColumn) {
            setCubeNavigator(tempValues, tempField, new LinkedList(fieldsHead), valueActionedCombo);
          } else {
            //if (itArrayFilters2.hasNext()) {
            if ((countSize + 1) < allInfo.size()) {
              setCubeNavigator(tempValues, tempField, new LinkedList(fieldsHead), (String) ((Object[]) allInfo.get(countSize + 1))[0]);
            } else setCubeNavigator(tempValues, tempField, new LinkedList(fieldsHead), null);
          }
          internalCountColumn++;
        } else break;

      }

    } catch (Exception e) {
      e.printStackTrace();
    }
  }

//---------------------------------------------------------------------------------------------------------


  public class Organizer {
    public List infoColumns = new LinkedList();

    void addColumn(String selectedField, List fieldsHead, List valuesColumn) {
      InfoColumn ic = new InfoColumn();
      ic.selectedField = selectedField;
      ic.fieldsHead = fieldsHead;
      ic.valuesColumn = valuesColumn;
      infoColumns.add(ic);
    }
  }

  public class InfoColumn { // tutte le imformazioni relaitive ad 1 colanna
    public List valuesColumn = null;   //i valori di una colonna
    public List fieldsHead = null;      // valori del compo box
    public String selectedField = null;// campo selezionato tra i valori del combo box
    //public boolean lastElement = false;

  }

  public class MatchValue { // tutte le imformazioni relaitive ad 1 colanna
    public int id = 0;   // dell'oggetto persisisto se esiste altrimenti 0
    public String name = "#"; // il valore per il layout
    public String className = "#"; // nome della classe dell'oggetto persistito
  }

}

