package org.jblooming.waf.html.display;

import org.jblooming.ApplicationException;
import org.jblooming.PlatformRuntimeException;
import org.jblooming.utilities.HTMLEncoderOld;
import org.jblooming.waf.html.input.HtmlElement;
import org.jblooming.waf.view.PageState;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.PageContext;
import java.io.IOException;

/**
 * @author Pietro Polsinelli : ppolsinelli@open-lab.com
 */
public class FeedbackError extends HtmlElement {
  public boolean translateError;
  public String errorCode;
  public String suggestedValue;

  public FeedbackError() {

  }

  public void toHtml(PageContext pageContext) {

    if (errorCode != null && errorCode.length() > 0) {
      try {
        PageState ps = PageState.getCurrentPageState((HttpServletRequest) pageContext.getRequest());

        pageContext.getOut().write("&nbsp;");

        if (suggestedValue != null && suggestedValue.length() > 0)
          errorCode = errorCode + ' ' + suggestedValue;

        pageContext.getOut().write("<a href='#' onclick=\"alert('");
        if (translateError)
          errorCode = HTMLEncoderOld.jsFormattedString(ps.getI18n(errorCode));
        pageContext.getOut().write(errorCode + "\\n");

        pageContext.getOut().write("')\" tooltip=\"" + errorCode + "\">");

        Img i = new Img(ps.sessionState.getPathToImages() + "/alert.gif", "alert");
        i.toolTip = errorCode;
        i.width = "17";
        i.height = "17";
        i.script = " align='absmiddle'";
        i.translateToolTip = translateError;
        i.toHtml(pageContext);
        pageContext.getOut().write("</a>\n");

      } catch (IOException e) {
        throw new PlatformRuntimeException(e);

      }
    }


  }

  public StringBuffer toHtmlStringBuffer(PageContext pageContext) throws ApplicationException {
    throw new PlatformRuntimeException("Do not use this");
  }
}
