package org.jblooming.waf.html.display;

import org.jblooming.waf.html.core.HtmlBootstrap;
import org.jblooming.waf.html.core.HtmlFinalizer;
import org.jblooming.waf.html.core.JspHelper;
import org.jblooming.waf.html.core.JspIncluder;
import org.jblooming.waf.view.PageState;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.PageContext;
import java.io.IOException;


public class QBEHelp extends JspHelper implements HtmlBootstrap, HtmlFinalizer{


  public static final String init = QBEHelp.class.getName();

  public static final String INITIALIZE = "INITIALIZE";
  public static final String DRAW = "DRAW";
  public static final String FILL ="FILL" ;

  /**
   * if helpAsPopup only one container hidden will be created per page. The link will show the container
   * As default a visible container will be drawn
   */
  public boolean helpAsPopup = false;


  private boolean inited=false;
  public int fontResizer = -1;


  public QBEHelp(PageState pageState) {
    this.urlToInclude = "/commons/layout/partQBEHelp.jsp";
    pageState.htmlBootstrappers.add(this);
  }

  private void init(PageContext pageContext) {
  }

  public void toHtml(PageContext pageContext) {
   
      init(pageContext);

    pageContext.getRequest().setAttribute(ACTION, DRAW);
    super.toHtml(pageContext);
  }


  public void fill(PageContext pageContext) throws IOException, ServletException {
    pageContext.getRequest().setAttribute(JspIncluder.ACTION, QBEHelp.FILL);
    super.toHtml(pageContext);
  }


  public String getId() {
    return id;
  }

  public String getDiscriminator() {
    return getId();
  }

  public boolean validate(PageState pageState) throws IOException, ServletException {
    return inited;
  }

  public void finalize(PageContext pageContext) throws IOException, ServletException {
    if (helpAsPopup && !inited) {
      PageState pageState=null;

        pageState = PageState.getCurrentPageState((HttpServletRequest) pageContext.getRequest());

      if (!pageState.initedElements.contains(init)) {
        pageContext.getRequest().setAttribute(ACTION, INITIALIZE);
        super.toHtml(pageContext);
      }
    }
    inited=true;
  }


}
