package org.jblooming.waf.html.display;

import org.jblooming.waf.html.layout.Skin;

import java.util.Arrays;
import java.util.Calendar;

/**
 * User: averacchi
 * Date: 4-ott-2005
 */

public class ToolTip {
  private static long id=0;
  private static String positionX="left: 3em;";
  private static String positionY="top: 3em;";
  private static String border="border: 1px solid;";
  private static String padding = "padding: 0.5em;";
  //private String width="200px;";


  public static String  setToolTipToJavascript(String htmlShowedElement, String htmlTooltippedElement, Skin skin){
    String width = "200px;";
    if(htmlTooltippedElement!=null){
      String[] innerRows = htmlTooltippedElement.split("<br>");
      double max = 0;

      for(String innerRox: Arrays.asList(innerRows))
        if(max<((double)innerRox.length())*0.6)
           max = ((double)innerRox.length())*0.6;
      if(max!=0){
        width = max+"em;";
      }
    }
    if(htmlShowedElement!=null && !"".equals(htmlShowedElement)) {
      htmlTooltippedElement = htmlTooltippedElement.replaceAll("\\n","<br>").replaceAll("\\r|\\t"," ").replaceAll("\"","-").replaceAll("\'","-");
      
      if(htmlTooltippedElement!=null && !"".equals(htmlTooltippedElement))
        return realizeTooltipToJavascript(htmlShowedElement, htmlTooltippedElement, skin,  width);
      else
        return htmlShowedElement;
    }
    return "-";
  }
  public static String  setToolTip(String htmlShowedElement, String htmlTooltippedElement, Skin skin){
      htmlTooltippedElement = htmlTooltippedElement.replaceAll("\\n","<br>").replaceAll("\\r|\\t"," ");
     return setToolTip(htmlShowedElement, htmlTooltippedElement, skin, ToolTip.positionX, ToolTip.positionY, ToolTip.border, ToolTip.padding);
  }
  public static String  setToolTip(String htmlShowedElement, String htmlTooltippedElement, Skin skin, String positionX, String positionY, String border, String padding){
    if(positionX==null) positionX = ToolTip.positionX;
    if(positionY==null) positionY = ToolTip.positionY;
    if(border==null) border = ToolTip.border;
    if(padding==null) padding = ToolTip.padding;
    if(htmlShowedElement!=null && !"".equals(htmlShowedElement))
      if(htmlTooltippedElement!=null && !"".equals(htmlTooltippedElement))
        return realizeTooltip(htmlShowedElement, htmlTooltippedElement, skin , positionX, positionY, border, padding);
      else
        return htmlShowedElement;
    return "-";
  }
  private static String realizeTooltipToJavascript(String htmlShowedElement, String htmlTooltippedElement, Skin skin, String width) {
    if(htmlTooltippedElement!=null && !"".equals(htmlTooltippedElement.trim()) && skin!=null)  {
      if(id==0)
         id = Calendar.getInstance().getTimeInMillis();
      else
          id++;
      return "<span style=\\\"position:relative;\\\" onmouseover=\\\"displayDiv('tooltip_" + id + "');\\\" onmouseout=\\\"displayNoneDiv('tooltip_" + id + "')\\\">" +
              " " + htmlShowedElement + " " +
              " <div id=\\\"tooltip_" + id + "\\\" style=\\\"display: none; position:absolute; width:"+width+" " +
              " top: 3em; left: 3em; z-index: 25; padding: 0.5em;" +
              " border: 1px solid "+skin.COLOR_BACKGROUND_TITLE+"; background-color: "+skin.COLOR_BACKGROUND_CONTENT+"; color:"+skin.COLOR_TEXT_MAIN+";\\\" >" +
              " " + htmlTooltippedElement + "" +
              " </div>" +
              " </span>";
    } else
        return htmlShowedElement;
  }
  private static String realizeTooltip(String htmlShowedElement, String htmlTooltippedElement, Skin skin, String positionX,                                       String positionY, String border, String padding) {
     if(htmlTooltippedElement!=null && !"".equals(htmlTooltippedElement))  {
      if(id==0)
         id = Calendar.getInstance().getTimeInMillis();
      else
          id++;
    return  "<span style=\"position:relative;\" onmouseover=\"displayDiv('tooltip_" + id + "');\" onmouseout=\"displayNoneDiv('tooltip_" + id + "')\">" +
            " " + htmlShowedElement + " " +
            "<table id=\"tooltip_" + id + "\" style=\"display: none; position:absolute; z-index: 25; "+positionY+" "+positionX+" "+border+" " + skin.COLOR_BACKGROUND_TITLE + "; background-color: " + skin.COLOR_BACKGROUND_CONTENT + "; color:" + skin.COLOR_TEXT_MAIN + ";\" >" +
            "<tr>" +
              "<td nowrap>" +
                "<div style=\"  "+padding+" width:100%;\" nowrap>"+
                  htmlTooltippedElement+
                "</div>" +
              "</td>" +
            "</tr>" +
            "</table>" +
            "</span>";
  } else
        return htmlShowedElement;
  }
}
