package org.jblooming.waf.html.display;

import org.jblooming.ontology.Node;
import org.jblooming.ontology.SecuredNodeComparator;
import org.jblooming.waf.SessionState;
import org.jblooming.waf.html.core.JspHelper;
import org.jblooming.waf.html.layout.Skin;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.jsp.PageContext;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public class Tree extends JspHelper {

  public Node root;
  public int depth;
  public Img image;
  public Skin skin;

  public Tree(Node root, Img image, int depth, Skin skin) {
    super(skin.partsPath + "partTree.jsp");
    this.skin = skin;
    this.image = image;
    this.root = root;
    this.depth = depth;
  }

  public int[] draw(Node node, int d, HttpServletRequest request, HttpServletResponse response, PageContext pageContext, SessionState sessionState)
          throws org.jblooming.security.SecurityException, IOException, ServletException {
    int totalNodes = 1;
    int totalDocs = 0;

    boolean hasChildren = false;
    if (node.getChildrenNode() != null && node.getChildrenNode().size() > 0)
      hasChildren = true;

    pageContext.getOut().print("<span class='trigger'>");
    TreeLine tl = new TreeLine(node, this.image, this.skin);
    tl.toHtml(pageContext);
    pageContext.getOut().print("</span>");

    if (hasChildren)
      pageContext.getOut().print("<span class='branch' id='" + node.getIntId() + "'>");

    if (hasChildren) {
      List children = new ArrayList(node.getChildrenNode());
      Collections.sort(children, new SecuredNodeComparator());
      Iterator i = children.iterator();
      while (i.hasNext()) {
        Node child = (Node) i.next();
        // recursive call
        totalNodes += draw(child, d + 1, request, response, pageContext, sessionState)[0];
      }
    }

    if (hasChildren)
      pageContext.getOut().print("</span>");

    return new int[]{totalNodes, totalDocs};
  }
}

