package org.jblooming.waf.html.input;

import org.jblooming.ApplicationException;
import org.jblooming.utilities.CodeValueList;
import org.jblooming.waf.html.core.HtmlBootstrap;
import org.jblooming.waf.html.core.JspHelper;
import org.jblooming.waf.html.state.Form;
import org.jblooming.waf.view.PageState;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.PageContext;
import java.io.IOException;

/**
 * @author Pietro Polsinelli ppolsinelli@open-lab.com
 */
public class LoadSaveFilter extends JspHelper implements HtmlBootstrap {

  public static final String init = LoadSaveFilter.class.getName();
  public Form form;
  public String category;
  public String newFldSeparator;
  public String saveComboSeparator;

  public CodeValueList additionalComboEntries;

  public static final String DRAW_NEW_FILTER = "DNF";
  public static final String DRAW_SAVED_FILTERS = "DSF";


  public LoadSaveFilter(String id, String category, Form form) {
    this.id = id;
    urlToInclude = "/commons/layout/partLoadSaveFilter.jsp";
    this.form = form;
    this.category = category;

  }

  /**
   * @param id
   * @param category           e.g. Task.TASK
   * @param newFldSeparator    e.g. "<td></td>"
   * @param saveComboSeparator e.g. "&nbsp;"
   * @param form
   */
  public LoadSaveFilter(String id, String category, String newFldSeparator, String saveComboSeparator, Form form) {
    this(id, category, form);
    this.newFldSeparator = newFldSeparator;
    this.saveComboSeparator = saveComboSeparator;
  }

  public String getDiscriminator() {
    return LoadSaveFilter.class.getName();
  }

  public boolean validate(PageState pageState) throws IOException, ServletException {
    return true;
  }

  private void init(PageContext pageContext) throws ApplicationException, IOException, ServletException {
    PageState ps = PageState.getCurrentPageState((HttpServletRequest) pageContext.getRequest());
    if (!ps.initedElements.contains(init)) {
      pageContext.getRequest().setAttribute(ACTION, INITIALIZE);
      super.toHtml(pageContext);
      ps.initedElements.add(init);
    }
  }

  public void drawNewFilter(PageContext pageContext) throws IOException, ServletException, ApplicationException {
    init(pageContext);
    pageContext.getRequest().setAttribute(ACTION, DRAW_NEW_FILTER);
    super.toHtml(pageContext);
  }

  public void drawSavedFilters(PageContext pageContext) throws IOException, ServletException, ApplicationException {
    init(pageContext);
    pageContext.getRequest().setAttribute(ACTION, DRAW_SAVED_FILTERS);
    super.toHtml(pageContext);
  }

  /**
   * default display as a stand alone table
   */
  public void toHtml(PageContext pageContext) {
    super.toHtml(pageContext);
  }
}