package org.jblooming.waf.html.input;

import org.jblooming.PlatformRuntimeException;
import org.jblooming.ontology.Lookup;

public class PathCombo extends SmartCombo {

  private PathCombo() {
    this.urlToInclude = "/commons/layout/partPathCombo.jsp";
  }

  public PathCombo(String fieldName, String hql, String whereForFiltering, String whereForId) {
    this();
    this.fieldName = fieldName;
    this.hql = hql;
    this.whereForFiltering = whereForFiltering;
    this.whereForId = whereForId;
  }

  public PathCombo(String fieldName, Class lookupClass) {
    this(fieldName,
            "select p.id, p.description from " + lookupClass.getName() + " as p",
            "where p.description like :" + SmartCombo.FILTER_PARAM_NAME + " order by p.description",
            "where p.id = :" + SmartCombo.FILTER_PARAM_NAME);
    try {
      if (!(lookupClass.newInstance() instanceof Lookup))
        throw new PlatformRuntimeException("This constructor of SmartCombo accepts Lookup extensions only");
    } catch (InstantiationException e) {
      throw new PlatformRuntimeException(e);
    } catch (IllegalAccessException e) {
      throw new PlatformRuntimeException(e);
    }
  }
}
