package org.jblooming.waf.html.input;

import org.jblooming.utilities.JSP;
import org.jblooming.waf.constants.AgendaConstants;
import org.jblooming.waf.html.core.HtmlBootstrap;
import org.jblooming.waf.html.core.JspHelper;
import org.jblooming.waf.html.state.Form;
import org.jblooming.waf.view.PageState;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.PageContext;
import java.io.IOException;


public class PeriodInput extends JspHelper implements HtmlBootstrap {
  
  public DateField startField;
  public String onBlurStartAdditionalScript;

  public DateField endField;
  public String onBlurEndAdditionalScript;

  public HourCombo startHour;
  public HourCombo endHour;

  public TextField durationField;
  public String onBlurDurationAdditionalScript;

  public boolean addjavascript = false;

  public String composerType = ScheduleComposer.Schedule_Type.PERIOD.toString();

  public static final String COMPUTE_FIELDS = "CMPF";


  public PeriodInput(Form f, PageState pageState) {

    this.startField = new DateField(AgendaConstants.FLD_START, pageState);
    this.endField = new DateField(AgendaConstants.FLD_END, pageState);
    this.durationField = new TextField("TEXT", AgendaConstants.FLD_DURATION, "</td><td>", 5);
    this.startHour = new HourCombo(AgendaConstants.FLD_START_HOUR, "</td><td>");
    this.endHour = new HourCombo(AgendaConstants.FLD_END_HOUR, "</td><td>");

    this.startField.onblurOnDateValid = JSP.w(onBlurStartAdditionalScript) +
            "resynchDates('" + AgendaConstants.FLD_START + "');";

    this.endField.onblurOnDateValid = JSP.w(onBlurEndAdditionalScript) +
            "resynchDates('" + AgendaConstants.FLD_END + "');";

    this.durationField.script = " onBlur=\"" + JSP.w(onBlurDurationAdditionalScript) +
            "resynchDates('" + AgendaConstants.FLD_DURATION + "');\" ";

    this.startHour.script = " onBlur=\"" + JSP.w(onBlurDurationAdditionalScript) +
            "resynchDates('" + AgendaConstants.FLD_START_HOUR + "');\" ";

    this.endHour.script = " onBlur=\"" + JSP.w(onBlurDurationAdditionalScript) +
            "resynchDates('" + AgendaConstants.FLD_END_HOUR + "');\" ";

    this.urlToInclude = "/commons/scheduler/parts/partPeriodInput.jsp";

  }

  public String getDiscriminator() {
    return this.getClass().getName();
  }

  public boolean validate(PageState pageState) throws IOException, ServletException {
    return true;
  }

  private void init(PageContext pageContext) {
    PageState ps = PageState.getCurrentPageState((HttpServletRequest) pageContext.getRequest());
    if (!ps.initedElements.contains(getDiscriminator())) {
      pageContext.getRequest().setAttribute(ACTION, DateDurationInput.INITIALIZE);
      super.toHtml(pageContext);
      ps.initedElements.add(getDiscriminator());
    }
  }

  public void drawStart(PageContext pageContext) {
    init(pageContext);
    startField.toHtml(pageContext);
  }


  public void drawDuration(PageContext pageContext) {
    init(pageContext);
    durationField.toHtml(pageContext);
  }


  public void drawEnd(PageContext pageContext) {
    init(pageContext);
    endField.toHtml(pageContext);
  }

  public void drawStartHour(PageContext pageContext) {
     init(pageContext);
     startHour.toHtml(pageContext);
   }

  public void drawEndHour(PageContext pageContext) {
     init(pageContext);
     endHour.toHtml(pageContext);
   }


  /**
   * @deprecated
   */
  public void toHtml(PageContext pageContext) {
    throw new RuntimeException("Call start and end");
  }

}
