package org.jblooming.waf.html.input;

import org.jblooming.waf.html.core.HtmlBootstrap;
import org.jblooming.waf.html.core.JspHelper;
import org.jblooming.waf.html.display.Img;
import org.jblooming.waf.view.PageSeed;
import org.jblooming.waf.view.PageState;

import javax.servlet.ServletException;
import java.io.IOException;
import java.util.List;
import java.util.Map;

public class ZoomControl extends JspHelper implements HtmlBootstrap {

  public InputElement inputSearch;
  public InputElement secondaryInputElement;
  public PageSeed zoomView;
  public String hiddenFieldName;
  public String separator;
  public boolean required = false;
  public boolean excludeFromAlert = false;

  public Img image;
  public String additionalOnClickScript;
  public List<String> additionalEntries;
  public String mandatoryOnClickScript; //signature of function in javascript that must return a boolean
  public Map<String,String> additionalParameters;

  public String popup_menubar;
  public String popup_resizable;
  public String popup_scrollbars;
  public String popup_status;
  public String popup_titlebar;
  public String popup_toolbar;
  public String popup_height="400";
  public String popup_left = "200";
  public String popup_top = "200";
  public String popup_width="600";

  public static final String INITIALIZE = "IN";
  public static final String DRAW_INPUT = "DI";

  protected ZoomControl() {
    urlToInclude = "/commons/layout/partZoom.jsp";
  }

  public ZoomControl(InputElement inputSearch, String hiddenFieldName, PageSeed zoomView) {
    this(inputSearch, null, hiddenFieldName, zoomView);
  }

  public ZoomControl(InputElement inputSearch, InputElement secondaryInputElement, String hiddenFieldName, PageSeed zoomView) {
    this();
    this.inputSearch = inputSearch;
    this.secondaryInputElement = secondaryInputElement;
    this.zoomView = zoomView;
    this.hiddenFieldName = hiddenFieldName;
    this.required = inputSearch.required;
  }

  public String getDiscriminator() {
    return "ZOOMCTRL";
  }

  public boolean validate(PageState pageState) throws IOException, ServletException {
    return true;
  }

  public String getWindowFeatures() {

    StringBuffer sb = new StringBuffer();
    sb.append(popup_menubar != null ? "menubar=" + popup_menubar + ',' : "");
    sb.append(popup_resizable != null ? "resizable=" + popup_resizable + ',' : "");
    sb.append(popup_scrollbars != null ? "scrollbars=" + popup_scrollbars + ',' : "");
    sb.append(popup_status != null ? "status=" + popup_status + ',' : "");
    sb.append(popup_titlebar != null ? "titlebar=" + popup_titlebar + ',' : "");
    sb.append(popup_toolbar != null ? "toolbar=" + popup_toolbar + ',' : "");
    sb.append(popup_height != null ? "height=" + popup_height + ',' : "");
    sb.append(popup_left != null ? "left=" + popup_left + ',' : "");
    sb.append(popup_top != null ? "top=" + popup_top + ',' : "");
    sb.append(popup_width != null ? "width=" + popup_width + ',' : "");

    return sb.substring(0, Math.max(sb.length() - 1, 0));
  }


}


