package org.jblooming.waf.html.input.documentDrawer;

import org.jblooming.remoteFile.Document;
import org.jblooming.waf.html.core.HtmlBootstrap;
import org.jblooming.waf.html.core.HtmlFinalizer;
import org.jblooming.waf.html.core.JspHelper;
import org.jblooming.waf.html.input.SmartCombo;
import org.jblooming.waf.html.layout.Skin;
import org.jblooming.waf.view.PageState;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.PageContext;
import java.io.IOException;

public class DocumentLinkDrawer  extends JspHelper implements HtmlBootstrap, HtmlFinalizer  {

  public static final String init = DocumentLinkDrawer.class.getName();
  public static final String INITIALIZE = "DOCUMENTUPLOAD_INIT";
  public static final String DOCUMENTUPLOAD_BOOTSTRAP = "DOCUMENTUPLOAD_BOOTSTRAP";


  public Skin skin;
  public String fieldName;
  public boolean disabled = false;
  public boolean required = false;
  public boolean readOnly = false;
  public int size = 10;
  public String labelstr;



  public Document currentDocument;

  public DocumentLinkDrawer(String fieldName, PageState pageState) {

    this.urlToInclude ="/commons/document/partDocumentUpload.jsp";

    this.skin = pageState.getSkin();

    this.fieldName = fieldName;
    pageState.htmlBootstrappers.add(this);
  }

  //todo provvisorio guai a chi lo usa

  public DocumentLinkDrawer(String fieldName, PageState pageState,String urlToInclude) {

    this.urlToInclude = urlToInclude;
    this.skin = pageState.getSkin();
    this.fieldName = fieldName;
    pageState.htmlBootstrappers.add(this);
  }

  private void init(PageContext pageContext) {
    PageState ps = PageState.getCurrentPageState((HttpServletRequest) pageContext.getRequest());
    if (!ps.initedElements.contains(init)) {
      pageContext.getRequest().setAttribute(ACTION, INITIALIZE);
      super.toHtml(pageContext);
      ps.initedElements.add(init);
    }
  }


  public String getDiscriminator() {
    return SmartCombo.class.getName();
  }

  public boolean validate(PageState pageState) throws IOException, ServletException {
    return true;
  }
  public void toHtml(PageContext pageContext) {

    init(pageContext);
    pageContext.getRequest().setAttribute(ACTION, "");
    super.toHtml(pageContext);
  }


  public void toHtmlI18n(PageContext pageContext) {
    PageState pageState = PageState.getCurrentPageState((HttpServletRequest) pageContext.getRequest());
    labelstr = pageState.getI18n(fieldName);
    toHtml(pageContext);
  }

  public void finalize(PageContext pageContext) {
      pageContext.getRequest().setAttribute(ACTION, DOCUMENTUPLOAD_BOOTSTRAP);
      super.toHtml(pageContext);
  }

}
