package org.jblooming.waf.html.layout;

import javax.servlet.jsp.PageContext;
import java.io.IOException;

/**
 * Facilitates developers in identifying the css classes to use in code.
 *
 * @author Pietro Polsinelli ppolsinelli@open-lab.com
 */
public class Css {
  private static boolean row;

  //container postfix
  public static String postfixLight = "Light";
  public static String postfixThin = "Thin";
  public static String postfixWarning = "Warn";


  //container
  public static String containerTitle = "containerTitle";
  public static String containerMainTitle = "containerMainTitle";
  public static String containerContent = "containerContent";
  public static String box = "box";

  //button areas
  public static String buttonArea = "buttonArea";

  public static String toolbar = "toolbar";
  public static String toolbarElement = "toolbarElement";
  public static String toolbarContent = "toolbarContent";

  public static String underline = "underline";

  //table
  public static String table = "table";
  public static String tableHeader = "tableHeader";
  public static String tableContent = "tableContent";
  public static String alternateTrue = "alternateTrue";
  public static String alternateFalse = "alternateFalse";
  public static String trOver = "trOver";

  public static String paginator = "paginator";

  //form
  public static String formElements = "formElements";
  public static String formElementsError = "formElementsError";
  public static String formElementsWarning = "formElementsWarning";
  public static String formSearchLabel = "formSearchLabel";

  //help
  public static String descriptiveElement = "descrEl";


  /**
   * @return the html class for alternate &lt;tr&gt; rows
   *         use: &lt;tr class="&lt;%=Css.alternate()%&gt;"&gt;
   * @deprecated use alternate(boolean start, PageContext pc)
   */
  public static String alternate() {
    row = !row;
    if (row)
      return alternateTrue;
    return alternateFalse;
  }


  /**
   *
   * @param start is the seed used for the alternate
   * @param pc 
   * @return the html class for alternate &lt;tr&gt; rows
   *         use: &lt;tr &lt;%Css.alternate(start,pc);%&gt;&gt;
   */
  public static boolean alternate(boolean start, PageContext pc) throws IOException {
    start = !start;
    if (start)
      pc.getOut().print("class=\"alternateTrue\"");
    else
      pc.getOut().print("class=\"alternateFalse\"");
    return start;
  }

  public static boolean alternate(boolean start, PageContext pc, String colorTrue, String colorFalse) throws IOException {
    start = !start;
    if (start)
      pc.getOut().print("style=\"background-color:"+colorTrue+";\"");
    else
      pc.getOut().print("style=\"background-color:"+colorFalse+";\"");
   return start;
 }

  /**
   * @return the script to manage &lt;tr&gt; rollover
   */
  public static String trRollOver() {
    return "oldclass='' onMouseOver=\"this.oldclass=this.className; this.className='" + trOver + "';\"  onMouseOut=\"this.className=this.oldclass;\" ";
  }


}
