package org.jblooming.waf.settings;

import org.apache.log4j.Logger;
import org.hibernate.cfg.Configuration;
import org.jblooming.ApplicationException;
import org.jblooming.persistence.exceptions.PersistenceException;
import org.jblooming.persistence.hibernate.PersistenceContext;

import javax.servlet.jsp.PageContext;
import java.io.File;
import java.util.Properties;

public interface AdvancedSettings {
 
  String getRoot();
  void setRoot(String root);
  LogConfiguration getLogConfiguration();
  void setLogConfiguration(LogConfiguration logConfiguration);
  Configuration getHibConfiguration();
  void setHibConfiguration(Configuration configuration);
  void createDefaultOperator(PersistenceContext pc) throws PersistenceException, ApplicationException;
  void configHibernateProperties(Configuration hibConfiguration, String POOL_ALIAS, Class dialect);
  void configPool(Properties hibProperties, String POOL_ALIAS, String db_user_name, String db_user_psw, String driver_class, String driver_url);
  void configNoPool(Properties hibernateProperties, String db_user_name, String db_user_psw, String driver_class, String driver_url);
  void configLog4J();
  void createLogger(String pattern, String logFilesRoot, Logger logger, String consoleAppenderName, String logFileName, String fileAppenderName);
  void configGlobalSettings(PageContext pageContext);
  void fillApplication(File global);
  void configAndBuildHibSessionFactory();
  void createDefaultOperators();
  void createSystemOperator(PersistenceContext pc) throws PersistenceException, ApplicationException;


}
