package org.jblooming.waf.settings;

import org.jblooming.security.Permission;

import javax.servlet.jsp.PageContext;
import java.util.Map;


/**
 * A platform application configuration.
 * 
 * @see org.jblooming.waf.settings.PlatformConfiguration
 */
public interface Application {

  public final static String PLATFORM_APP_NAME = "Platform";

  String getName();

  String getRootFolder();

  boolean isLoginCookieEnabled();

  void configurePersistence(PlatformConfiguration pc) throws Exception;

  void configureFreeAccess(PlatformConfiguration pc);

  void configureNeedingPersistence(PlatformConfiguration pc);

  void configureNeedingPageContext(PageContext pageContext);
  
  /**
   * Adds files whose serving is not monitored by platform utilities
   * for example as done by FrontController and monitor.jsp
   * Example:
   * FrontControllerFilter.notMonitored.add("monitor.jsp");
   */
  void configureNotMonitored(PlatformConfiguration pc);

  /**
   * load:
   * - login, error and such general filter screens.
   * - constant views of the application
   */
  void configureViews(PlatformConfiguration pc);

  Map<String,Permission> getPermissions();

  Class getDefaultScreenClass();

}
