package org.jblooming.waf.settings;

import org.jblooming.operator.Operator;
import org.jblooming.security.Permission;
import org.jblooming.security.Permissions;
import org.jblooming.utilities.HashTable;
import org.jblooming.waf.ScreenBasic;

import javax.servlet.jsp.PageContext;
import java.util.Map;

public abstract class ApplicationSupport implements Application {

  protected ApplicationSupport(Permissions permissionsImpl) {
    this(Operator.class,permissionsImpl);
  }

  protected ApplicationSupport(Class defaultOperatoSubClass, Permissions permissionsImpl) {
    PlatformConfiguration.defaultOperatorSubclass = defaultOperatoSubClass;
    if (permissionsImpl!=null)
      Permission.addPermissions(permissionsImpl,permissions);
  }

  protected ApplicationSupport(Class defaultOperatoSubClass, Permissions[] permissionsImpl) {
    PlatformConfiguration.defaultOperatorSubclass = defaultOperatoSubClass;
    if (permissionsImpl!=null) {
      for (int i = 0; i < permissionsImpl.length; i++) {
        Permissions permissions1 = permissionsImpl[i];
        Permission.addPermissions(permissions1,permissions);
      }
    }
  }

  protected Map<String,Permission> permissions = new HashTable();

  public Map<String,Permission> getPermissions() {
      return permissions;
    }


  public Class getDefaultScreenClass() {
      return getDefaultScreenInstance().getClass();
    }

  public ScreenBasic getDefaultScreenInstance() {
    return null;
  }

  public void configureNeedingPageContext(PageContext pageContext) {

  }


}
