package org.jblooming.waf.settings;

import org.apache.log4j.Level;

/**
 * Logging configuration class.
 */
public class LogConfiguration {

  private boolean logOnConsole;
  private boolean logOnFile;
  private Level hibernateLogLevel;
  private Level platformLogLevel;
  private Level i18nLogLevel;
  private Level jobLogLevel;

  public boolean htmlDebug;


  /**
   * logging possible values:
   * <ul>
   * <li>public static final Level OFF;    </li>
   * <li>public static final Level FATAL;  </li>
   * <li>public static final Level ERROR;  </li>
   * <li>public static final Level WARN;   </li>
   * <li>public static final Level INFO;   </li>
   * <li>public static final Level DEBUG;  </li>
   * <li>public static final Level ALL;    </li>
   * </ul>
   */
  public LogConfiguration(boolean logOnConsole, boolean logOnFile, Level hibernateLogLevel, Level platformLogLevel, Level i18nLogLevel) {
     this(logOnConsole,logOnFile,hibernateLogLevel,platformLogLevel,i18nLogLevel,Level.ERROR);
  }

  public LogConfiguration(boolean logOnConsole, boolean logOnFile, Level hibernateLogLevel, Level platformLogLevel, Level i18nLogLevel, Level jobLogLevel) {
    this.logOnConsole = logOnConsole;
    this.logOnFile = logOnFile;
    this.hibernateLogLevel = hibernateLogLevel;
    this.platformLogLevel = platformLogLevel;
    this.i18nLogLevel = i18nLogLevel;
    this.jobLogLevel = jobLogLevel;
  }


  public static LogConfiguration defaultDevelopment = new LogConfiguration(true, false, Level.WARN, Level.INFO, Level.INFO ,Level.ERROR);
  public static LogConfiguration defaultProduction = new LogConfiguration(false, true, Level.WARN, Level.WARN, Level.WARN ,Level.ERROR);
                                                                       
  public boolean isLogOnConsole() {
    return logOnConsole;
  }

  public void setLogOnConsole(boolean logOnConsole) {
    this.logOnConsole = logOnConsole;
  }

  public boolean isLogOnFile() {
    return logOnFile;
  }

  public void setLogOnFile(boolean logOnFile) {
    this.logOnFile = logOnFile;
  }

  public Level getHibernateLogLevel() {
    return hibernateLogLevel;
  }

  public void setHibernateLogLevel(Level hibernateLogLevel) {
    this.hibernateLogLevel = hibernateLogLevel;
  }

  public Level getPlatformLogLevel() {
    return platformLogLevel;
  }

  public void setPlatformLogLevel(Level platformLogLevel) {
    this.platformLogLevel = platformLogLevel;
  }

  public Level getI18nLogLevel() {
    return i18nLogLevel;
  }

  public void setI18nLogLevel(Level i18nLogLevel) {
    this.i18nLogLevel = i18nLogLevel;
  }

  public Level getJobLogLevel() {
    return jobLogLevel;
  }

  public void setJobLogLevel(Level jobLogLevel) {
    this.jobLogLevel = jobLogLevel;
  }
}
