package org.jblooming.security;

import com.octo.captcha.component.image.backgroundgenerator.UniColorBackgroundGenerator;
import com.octo.captcha.component.image.fontgenerator.TwistedRandomFontGenerator;
import com.octo.captcha.component.image.textpaster.RandomTextPaster;
import com.octo.captcha.component.image.wordtoimage.ComposedWordToImage;
import com.octo.captcha.component.word.wordgenerator.RandomWordGenerator;
import com.octo.captcha.engine.image.ListImageCaptchaEngine;
import com.octo.captcha.image.gimpy.GimpyFactory;
import com.octo.captcha.service.image.ImageCaptchaService;
import com.octo.captcha.service.multitype.GenericManageableCaptchaService;

import java.awt.*;

/**
 * (c) Open Lab - www.open-lab.com
 * Date: Mar 12, 2007
 * Time: 9:46:52 AM
 */
public class CaptchaServiceSingleton {


  public static class SimpleListImageCaptchaEngine extends ListImageCaptchaEngine {

    public SimpleListImageCaptchaEngine() {
    }

    protected void buildInitialFactories() {
      com.octo.captcha.component.word.wordgenerator.WordGenerator wordGenerator = new RandomWordGenerator("ABCDEFGHIJKLMNOPQRSTUVWXYZ");
      com.octo.captcha.component.image.textpaster.TextPaster textPaster = new RandomTextPaster(new Integer(4), new Integer(6), Color.black);
      com.octo.captcha.component.image.backgroundgenerator.BackgroundGenerator backgroundGenerator = new UniColorBackgroundGenerator(new Integer(200), new Integer(100));
      com.octo.captcha.component.image.fontgenerator.FontGenerator fontGenerator = new TwistedRandomFontGenerator(new Integer(25), new Integer(30));
      com.octo.captcha.component.image.wordtoimage.WordToImage wordToImage = new ComposedWordToImage(fontGenerator, backgroundGenerator, textPaster);
      addFactory(new GimpyFactory(wordGenerator, wordToImage));
    }
  }


  private static ImageCaptchaService instance = new GenericManageableCaptchaService(new SimpleListImageCaptchaEngine(), 1, 1);

  public static ImageCaptchaService getInstance() {

    return instance;
  }

}
