package org.jblooming.designer;

import org.jblooming.PlatformRuntimeException;
import org.jblooming.waf.html.core.HtmlBootstrap;
import org.jblooming.waf.html.core.JspHelper;
import org.jblooming.waf.view.PageState;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.PageContext;
import java.io.IOException;
import java.util.LinkedHashMap;

/**
 * @author Pietro Polsinelli ppolsinelli@open-lab.com
 * @author Roberto Bicchierai rbicchierai@open-lab.com
 */
public class Detail extends DesignerField {
  public static final String DRAW_INPUT = "DI";
  public static final String ACTION = "JSPACT";
  public static final String INITIALIZE = "IN";
  public int maxLine;  //questo attributo serve esclusivamente ad un uso interno.....NON MODIFICARE!!!!!!!
  public boolean firstLineVisible = false;
  public boolean drawContainer = true;
  public boolean confirmRequire = true;

  /*if true, the component may not be added or removed, but just corrected*/
  public boolean correctionOnly;
  public static final String DETAIL_SEPARATOR = "_DETAIL_SEPARATOR_";  
  public LinkedHashMap<String, DesignerField> detailDesignerFields = new LinkedHashMap<String, DesignerField>();

  protected Detail() {
    super();
  }

  public void add(DesignerField designerField) {
    if(designerField instanceof Detail)
      throw new PlatformRuntimeException("You cannot add a detail to another detail.");
    designerField.designer = designer;
    detailDesignerFields.put(designerField.name, designerField);
  }

  
  public void toHtml(PageContext pageContext) {
    PageState ps = PageState.getCurrentPageState((HttpServletRequest) pageContext.getRequest());
    if (!ps.initedElements.contains(Detail.class.getName())) {
      pageContext.getRequest().setAttribute(ACTION, INITIALIZE);
      new Drawer(this).toHtml(pageContext);
      ps.initedElements.add(Detail.class.getName());
    } else {
      pageContext.getRequest().setAttribute(ACTION, DRAW_INPUT);
      new Drawer(this).toHtml(pageContext);
    }
  }

  public class Drawer extends JspHelper implements HtmlBootstrap {

    public Detail detail;

    public Drawer(Detail fd) {
      super();
      this.detail = fd;
      urlToInclude = "/commons/layout/partDesignerDetail.jsp";
    }

    public String getDiscriminator() {
      return Drawer.class.getName();
    }

    public boolean validate(PageState pageState) throws IOException, ServletException {
      return true;
    }
  }
}
