package com.opnlb.rss;

import com.opnlb.website.news.News;
import org.jblooming.ontology.IdentifiableSupport;
import org.jblooming.ontology.PersistentFile;

import java.util.HashSet;
import java.util.Set;

/**
 * RSSFeed (c) 2006 - Open Lab - www.open-lab.com
 * since a feed has one and only one channel
 * we need only one class for both
 */
public class RSSFeed extends IdentifiableSupport {
  private String version = "2.0";    // for now, fixed to "2.0"

  // mandatory subelements
  private String title;
  private String link;
  private String description;

  // optional subelements
  private String language;
  private String copyright;
  private String managingEditor;
  private String webMaster;
  private String pubDate;

  private RSSFeedCategory category;
  private String categoryDomain;
  private String generator = "OpenLab Platform";

  private String docs = "http://rssboard.org/rss-specification";
  private int ttl = 0;
  // if there's an image, the first three are mandatory
  private PersistentFile image;
  private String imageTitle;
  private String imageLink;

  private String imageDescription;
  private int imageWidth = 88;
  private int imageHeight = 31;

  private Set<News> items = new HashSet();


  public void addItem(News item) {
    items.add(item);
  }

  public String getCategoryDomain() {
    return categoryDomain;
  }

  public void setCategoryDomain(String categoryDomain) {
    this.categoryDomain = categoryDomain;
  }

  public String getVersion() {
    return version;
  }

  public void setVersion(String version) {
    this.version = version;
  }

  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public String getLink() {
    return link;
  }

  public void setLink(String link) {
    this.link = link;
  }

  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public String getLanguage() {
    return language;
  }

  public void setLanguage(String language) {
    this.language = language;
  }

  public String getCopyright() {
    return copyright;
  }

  public void setCopyright(String copyright) {
    this.copyright = copyright;
  }

  public String getManagingEditor() {
    return managingEditor;
  }

  public void setManagingEditor(String managingEditor) {
    this.managingEditor = managingEditor;
  }

  public String getWebMaster() {
    return webMaster;
  }

  public void setWebMaster(String webMaster) {
    this.webMaster = webMaster;
  }

  public String getPubDate() {
    return pubDate;
  }

  public void setPubDate(String pubDate) {
    this.pubDate = pubDate;
  }

  public RSSFeedCategory getCategory() {
    return category;
  }

  public void setCategory(RSSFeedCategory category) {
    this.category = category;
  }

  public String getGenerator() {
    return generator;
  }

  public void setGenerator(String generator) {
    this.generator = generator;
  }

  public String getDocs() {
    return docs;
  }

  public void setDocs(String docs) {
    this.docs = docs;
  }

  public int getTtl() {
    return ttl;
  }

  public void setTtl(int ttl) {
    this.ttl = ttl;
  }

  public PersistentFile getImage() {
    return image;
  }

  public void setImage(PersistentFile image) {
    this.image = image;
  }

  public String getImageTitle() {
    return imageTitle;
  }

  public void setImageTitle(String imageTitle) {
    this.imageTitle = imageTitle;
  }

  public String getImageLink() {
    return imageLink;
  }

  public void setImageLink(String imageLink) {
    this.imageLink = imageLink;
  }

  public String getImageDescription() {
    return imageDescription;
  }

  public void setImageDescription(String imageDescription) {
    this.imageDescription = imageDescription;
  }

  public int getImageWidth() {
    return imageWidth;
  }

  public void setImageWidth(int imageWidth) {
    this.imageWidth = imageWidth;
  }

  public int getImageHeight() {
    return imageHeight;
  }

  public void setImageHeight(int imageHeight) {
    this.imageHeight = imageHeight;
  }

  public Set<News> getItems() {
    return items;
  }

  public void setItems(Set<News> items) {
    this.items = items;
  }
}
