package com.opnlb.website.dynamicLink;

import org.jblooming.ontology.LoggableIdentifiableSupport;
import org.jblooming.ontology.PersistentFile;
import org.jblooming.operator.Operator;

import java.util.Date;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;


public class DynamicLink  extends LoggableIdentifiableSupport {

  public enum Open_Type {POPUP, MAKEFRAME, BLANK ,TOP, SELF}

  private String openTypeString = Open_Type.BLANK +"";

  private int click_Count = 0;
  private double weight    = 0;

  private String url;
  private String urlDescription;
  private Date startingDate;
  private Date endingDate;
  private boolean visible = false;

  //private NewsCategory category;
  private DynamicLinkCategory category;
  private DynamicLink linkParent;
  private String imageWidth;
  private String imageHeight;


  private Operator owner;
  private Set<DynamicLink> childrens = new  HashSet<DynamicLink>();

  public static final String DYNAMIC_LINK = "DYNAMIC_LINK";

  private PersistentFile linkImage;


  public DynamicLink() {

  }

  public PersistentFile getLinkImage() {
     return linkImage;
   }

   public void setLinkImage(PersistentFile linkImage) {
     this.linkImage = linkImage;
   }

   public String getImageWidth() {
     return imageWidth;
   }

   public void setImageWidth(String imageWidth) {
     this.imageWidth = imageWidth;
   }

   public String getImageHeight() {
     return imageHeight;
   }

   public void setImageHeight(String imageHeight) {
     this.imageHeight = imageHeight;
   }

  private String getOpenTypeString() {
    return openTypeString;
  }

  private void setOpenTypeString(String openTypeString) {
    this.openTypeString = openTypeString;
  }

  public Open_Type getOpenType() {
    if (openTypeString!=null && openTypeString.trim().length()>0)
    return Open_Type.valueOf(openTypeString);
    else
      return null;
  }

  public void setOpenType(Open_Type openType) {
    this.openTypeString = openType+"";
  }

  public Operator getOwner() {
    return owner;
  }

  public void setOwner(Operator owner) {
    this.owner = owner;
  }

  public String getUrl() {
    return url;
  }

  public void setUrl(String url) {
    this.url = url;
  }

  public String getUrlDescription() {
    return urlDescription;
  }

  public void setUrlDescription(String urlDescription) {
    this.urlDescription = urlDescription;
  }

  public DynamicLinkCategory getCategory() {
    return category;
  }

  public void setCategory(DynamicLinkCategory category) {
    this.category = category;
  }

  public Date getStartingDate() {
    return startingDate;
  }

  public void setStartingDate(Date startingDate) {
    this.startingDate = startingDate;
  }

  public Date getEndingDate() {
    return endingDate;
  }

  public void setEndingDate(Date endingDate) {
    this.endingDate = endingDate;
  }

  public boolean isVisible() {
    return visible;
  }

  public void setVisible(boolean visible) {
    this.visible = visible;
  }

  public void addChildren(DynamicLink children) {
    childrens.add(children);
  }

  public void removeChildren(DynamicLink children) {
    childrens.remove(children);
  }

  public Iterator getChildrensIterator() {
    return childrens.iterator();
  }

  private Set getChildrens() {
    return childrens;
  }

  public int childrensSize() {
    return getChildrens().size();
  }
  private void setChildrens(Set childrens) {
    this.childrens = childrens;
  }

  public int getClick_Count() {
    return click_Count;
  }

  public void setClick_Count(int click_Count) {
    this.click_Count = click_Count;
  }

  public double getWeight() {
    return weight;
  }

  public void setWeight(double weight) {
    this.weight = weight;
  }

  public DynamicLink getLinkParent() {
    return linkParent;
  }

  public void setLinkParent(DynamicLink linkParent) {
    this.linkParent = linkParent;
  }

}
