package com.opnlb.website.dynamicLink;

import org.jblooming.ontology.LookupSupport;
import org.jblooming.operator.Operator;
import org.jblooming.persistence.exceptions.StoreException;

import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

/**
 * DynamicLinkCategory (c) 2005 - Open Lab - www.open-lab.com
 */
public class DynamicLinkCategory extends LookupSupport  {

  //read only collection
  private Set<DynamicLinkCategoryManager> dynamicLinkCategoryManager = new HashSet<DynamicLinkCategoryManager>();

  public static final String DYNAMIC_LINK_CATEGORY = "DYNAMIC_LINK_CATEGORY";

  private Set<DynamicLinkCategoryManager> getDynamicLinkCategoryManager() {
    return dynamicLinkCategoryManager;
  }

  private void setDynamicLinkCategoryManager(Set<DynamicLinkCategoryManager> categoryManager) {
    this.dynamicLinkCategoryManager = categoryManager;
  }

  public void addManagerAndPersist(Operator operator) throws StoreException {
    DynamicLinkCategoryManager ncm = new DynamicLinkCategoryManager();
    ncm.setDynamicLinkCategory(this);
    ncm.setOperator(operator);
    ncm.store();
  }

  public void removeManagerFromMemory(DynamicLinkCategoryManager ncm) {
    dynamicLinkCategoryManager.remove(ncm);
  }

  public Iterator getManagersIterator() {
    Set tmp = new HashSet(dynamicLinkCategoryManager);
    return tmp.iterator();
  }

  public boolean managersContains(Operator operator) {
    return dynamicLinkCategoryManager.contains(operator);
  }

  public int managersSize() {
    return dynamicLinkCategoryManager.size();
  }

}
