package com.opnlb.website.htmlParser;

import java.io.OutputStream;
import java.io.PrintWriter;


public class HtmlDumper extends HtmlVisitor {

  protected PrintWriter out;

  public HtmlDumper(OutputStream os) {
    out = new PrintWriter(os);
  }

  public HtmlDumper(PrintWriter pw) {
    out = pw;
  }

  public void finish() {
    out.flush();
  }

  public void visit(HtmlDocument.Tag t) {
    out.print(t);   }

  public void visit(HtmlDocument.EndTag t) {
    out.print(t);
  }

  public void visit(HtmlDocument.Comment c) {
    out.print(c);
  }

  public void visit(HtmlDocument.Text t) {
    out.print(t);
  }

  public void visit(HtmlDocument.Newline n) {
    out.println();
  }

  public void visit(HtmlDocument.Annotation a) {
    out.print(a);
  }

}



