package com.opnlb.website.htmlParser;

import java.util.Enumeration;

public abstract class HtmlVisitor {

  public void visit(HtmlDocument.Tag t)         { }

  public void visit(HtmlDocument.EndTag t)      { }

  public void visit(HtmlDocument.Comment c)     { }

  public void visit(HtmlDocument.Text t)        { }

  public void visit(HtmlDocument.Newline n)     { }

  public void visit(HtmlDocument.Annotation a)  { }

  public void visit(HtmlDocument.TagBlock bl) {
    bl.startTag.accept(this);
    visit(bl.body);
    bl.endTag.accept(this);
  }

  public void visit(HtmlDocument.ElementSequence s) {
    for (Enumeration e = s.elements(); e.hasMoreElements(); )
      ((HtmlDocument.HtmlElement)e.nextElement()).accept(this);
  }

  public void visit(HtmlDocument d) {
    start();
    visit(d.elements);
    finish();
  }

  public void start()  { }

  public void finish() { }

}

