package com.opnlb.website.news;

import org.jblooming.ontology.LookupSupport;
import org.jblooming.operator.Operator;
import org.jblooming.persistence.exceptions.StoreException;

import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

/**
 * NewsCategory (c) 2005 - Open Lab - www.open-lab.com
 */
public class NewsCategory extends LookupSupport {

  //read only collection
  private Set<NewsCategoryManager> newsCategoryManager = new HashSet<NewsCategoryManager>();

  public static final String NEWSCATEGORY = "NEWSCATEGORY";

  private Set<NewsCategoryManager> getNewsCategoryManager() {
    return newsCategoryManager;
  }

  private void setNewsCategoryManager(Set<NewsCategoryManager> newsCategoryManager) {
    this.newsCategoryManager = newsCategoryManager;
  }

  public void addManagerAndPersist(Operator operator) throws StoreException {
    NewsCategoryManager ncm = new NewsCategoryManager();
    ncm.setNewsCategory(this);
    ncm.setOperator(operator);
    ncm.store();
  }

  public void removeManagerFromMemory(NewsCategoryManager ncm) {
    newsCategoryManager.remove(ncm);
  }

  public Iterator getManagersIterator() {
    Set tmp = new HashSet(newsCategoryManager);
    return tmp.iterator();
  }

  public boolean managersContains(Operator operator) {
    return newsCategoryManager.contains(operator);
  }

  public int managersSize() {
    return newsCategoryManager.size();
  }  

}
