package com.opnlb.website.template;

import org.jblooming.ontology.PersistentFile;
import org.jblooming.ontology.SecuredLoggableHideableSupport;
import org.jblooming.operator.User;
import org.jblooming.security.Permission;
import org.jblooming.security.Securable;
import org.jblooming.waf.html.core.JspIncluder;

import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.jsp.PageContext;
import java.io.IOException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Stack;


public class Template extends SecuredLoggableHideableSupport implements JspIncluder, Securable {

  private String name;
  private String description;
  private PersistentFile templateFile;
  private String jspFileLocation;

  private boolean installed = true;
  private boolean isDefault = false;
  //private Map<String, WebsiteArea> aree = new HashMap();
  private Map<String, String> aree = new HashMap();

  public static final String TEMPLATE = "TEMPLATE";

  public String pageIdParam;
  public String urlToInclude; //this.getFile().getFileLocation();

  public void toHtml(PageContext pageContext) throws IOException, ServletException {
    Stack stack = getStack(pageContext.getRequest());
    stack.push(this);
    try {
      //pageContext.include(this.urlToInclude);
      pageContext.include(this.urlToInclude!=null ? this.urlToInclude : "/"+this.jspFileLocation);
    } finally {
      stack.pop();
    }
  }

  protected Stack getStack(ServletRequest request) {
    Stack stack = (Stack) request.getAttribute(MAIN_OBJECT_STACK);
    if (stack == null) {
      stack = new Stack();
      request.setAttribute(MAIN_OBJECT_STACK, stack);
    }
    return stack;
  }

  /**
   * CONSTRUCTORS
   */
  public Template () {
  }

  /**
   * getters and setters
   */
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public PersistentFile getTemplateFile() {
    return templateFile;
  }

  public void setTemplateFile(PersistentFile templateFile) {
    this.templateFile = templateFile;
  }

  public String getJspFileLocation() {
    return jspFileLocation;
  }

  public void setJspFileLocation(String jspFileLocation) {
    this.jspFileLocation = jspFileLocation;
  }

  public boolean isInstalled() {
    return installed;
  }

  public void setInstalled(boolean installed) {
    this.installed = installed;
  }

  public boolean getIsDefault() {
    return isDefault;
  }

  public void setIsDefault(boolean aDefault) {
    isDefault = aDefault;
  }

  public Map getAree() {
    return aree;
  }

  //public void putArea(String key, WebsiteArea area) {
//  public void putArea(String key, String area) {
//      getAree().put(key, area); 
//  }

//  public void addElement( String name , String layout ) {
//    WebsiteArea element = createElement( name , layout );
//    aree.put( name , element );
//  }

  /**
   * Factory method:
   * Creates a new WebsiteArea without adding it to this Template elements
   */
//  public WebsiteArea createElement( String name , String impaginazione ) {
//    return new WebsiteArea ( name, impaginazione );
//  }

//  public WebsiteArea createElement( String name ) {
//    return createElement(name, null);
//  }

  public void removeOptionByKey(String key) {
    getAree().remove(key);
  }

  public Iterator getAreeKeysetIterator() {
    return getAree().keySet().iterator();
  }

  //private void setAree(Map<String, WebsiteArea> aree) {
  private void setAree(Map<String, String> aree) {
    this.aree = aree;
  }

  /**
   * SECURABLE
   */
  public boolean hasPermissionFor(User u, Permission p) {
    //return u.hasPermissionFor(p);
    if (getOwner() != null && getOwner().equals(u))
      return true;
    else
      return u.hasPermissionFor(p);
  }



  /*
  public void removeOptionByValue(WebsiteArea area) {
    Iterator keySet = new HashSet(getAree().keySet()).iterator();
    while (keySet.hasNext()) {
      final String key = (String) keySet.next();
      WebsiteArea loopValue = getArea(key);
      if (loopValue.equals(area)) {
        removeOptionByKey(key);
      }
    }
  }

  public WebsiteArea getArea(String key) {
    return (WebsiteArea) getAree().get(key);
  }
 */

}
