package com.opnlb.website.util;

import org.jblooming.utilities.JSP;
import org.jblooming.utilities.StringUtilities;

/**
 * WebsiteUtilities (c) 2005 - Open Lab - www.open-lab.com
 */
public class WebsiteUtilities {

  public static String showPreviewScript(String pfFileLocation, String underlyingText) {
    String text = StringUtilities.replaceAllNoRegex(underlyingText, "\"", "");
    text = JSP.javascriptEncode(text);
    return "onMouseOver=\"showPreview('/"+ StringUtilities.replaceAllNoRegex(pfFileLocation,"\\","/")+"','" + text +"');\"";
  }

  public static String showPreviewScript(String pfFileLocation, String underlyingText, int width) {
    return "onMouseOver=\"showPreview('/"+ StringUtilities.replaceAllNoRegex(pfFileLocation,"\\","/")+"','" + JSP.javascriptEncode(underlyingText) +"', '"+width+"');\"";
  }

  public static String showPreviewOnClick(String pfFileLocation) {
    return "onClick=\"showPreviewOnClick('/"+ StringUtilities.replaceAllNoRegex(pfFileLocation,"\\","/")+"');\"";
  }

  public static String showPreviewOnClick(String pfFileLocation, String title, int imageWidth) {
    if (imageWidth>0)
      return "onClick=\"showPreviewOnClick('/"+ StringUtilities.replaceAllNoRegex(pfFileLocation,"\\","/")+"','" + title +"', '"+imageWidth+"');\"";
    else
      return "onClick=\"showPreviewOnClick('/"+ StringUtilities.replaceAllNoRegex(pfFileLocation,"\\","/")+"','" + title +"');\"";
  }


  public static String normalizePageName(String text){
    if (text!=null){
      text = StringUtilities.replaceAllNoRegex(text, " ", "_");
      text = StringUtilities.replaceAllNoRegex(text, "-", "");
      text = StringUtilities.replaceAllNoRegex(text, "/", "");
      text = StringUtilities.replaceAllNoRegex(text, "\\", "");
      text = StringUtilities.replaceAllNoRegex(text, "\"", "");
      text = StringUtilities.replaceAllNoRegex(text, ",", "");
      text = StringUtilities.replaceAllNoRegex(text, ";", "");
      text = StringUtilities.replaceAllNoRegex(text, "'", "");
      text = StringUtilities.replaceAllNoRegex(text, "+", "");
      text = StringUtilities.replaceAllNoRegex(text, "°", "");
      text = StringUtilities.replaceAllNoRegex(text, "§", "");
      text = StringUtilities.replaceAllNoRegex(text, "@", "");
      text = StringUtilities.replaceAllNoRegex(text, "à", "a");
      text = StringUtilities.replaceAllNoRegex(text, "è", "e");
      text = StringUtilities.replaceAllNoRegex(text, "é", "e");
      text = StringUtilities.replaceAllNoRegex(text, "ì", "i");
      text = StringUtilities.replaceAllNoRegex(text, "ò", "o");
      text = StringUtilities.replaceAllNoRegex(text, "ù", "u");
      text = StringUtilities.replaceAllNoRegex(text, "ç", "c");
    }
    return text;
  }

}
