package com.opnlb.website.waf;

import com.opnlb.website.news.News;
import com.opnlb.website.news.NewsCategory;
import org.jblooming.ApplicationException;
import org.jblooming.waf.html.core.HtmlBootstrap;
import org.jblooming.waf.html.core.JspHelper;
import org.jblooming.waf.view.PageState;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.PageContext;
import java.io.IOException;


/**
 * NewsReader (c) 2005 - Open Lab - www.open-lab.com
 */
public class NewsReader extends JspHelper implements HtmlBootstrap  {

  private NewsCategory category;
  private News news;

  public static final String init = NewsReader.class.getName();
  public static final String DISPLAY_NEWS = "DISPLAY_NEWS";
  public static final String CLOSE = "CLOSE";
  private boolean drawCalled=false;
  private boolean closeCalled=false;

  public NewsReader(String newsId, boolean isTopNews, String suffix, PageState pageState) {
    if (id != null)
      this.id = newsId;
    if (suffix==null)
      suffix = "";
    if (isTopNews)
      this.urlToInclude = "/applications/website/layout/partNewsReaderTop"+suffix+".jsp";
    else
      this.urlToInclude = "/applications/website/layout/partNewsReader"+suffix+".jsp";

    pageState.htmlBootstrappers.add(this);
  }

  public String getDiscriminator() {
    return init;
  }

  public boolean validate(PageState pageState) throws IOException, ServletException {
    return drawCalled && closeCalled;
  }

  private void init(PageContext pageContext) throws ApplicationException, IOException, ServletException {
    PageState ps = PageState.getCurrentPageState((HttpServletRequest) pageContext.getRequest());
    if (!ps.initedElements.contains(init)) {
      pageContext.getRequest().setAttribute(ACTION, INITIALIZE);
      super.toHtml(pageContext);
      ps.initedElements.add(init);
    }
  }

  public void displayNews (PageContext pageContext) throws IOException, ServletException, ApplicationException {
    drawCalled = true;
    init(pageContext);
    pageContext.getRequest().setAttribute(ACTION, DISPLAY_NEWS);
    super.toHtml(pageContext);
  }

  public void close(PageContext pageContext) throws IOException, ServletException, ApplicationException {
    if (!drawCalled)
      throw new ApplicationException("Call start before end");
    closeCalled = true;
    pageContext.getRequest().setAttribute(ACTION, CLOSE);
    super.toHtml(pageContext);
  }


}
