package com.opnlb.website.waf.html;

import com.opnlb.website.dynamicLink.DynamicLink;
import com.opnlb.website.dynamicLink.DynamicLinkCategory;
import org.jblooming.waf.html.container.Container;
import org.jblooming.waf.html.core.HtmlBootstrap;
import org.jblooming.waf.html.core.JspHelper;
import org.jblooming.waf.html.display.Img;
import org.jblooming.waf.view.PageState;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.PageContext;
import java.io.IOException;
import java.io.Serializable;
import java.util.HashSet;
import java.util.List;
import java.util.Set;


public class DynamicLinkDesigner extends JspHelper implements HtmlBootstrap {

  public enum Order_Type {
    RANDOM, RELEVANCE, WEIGHT,CLICKCOUNT,STARTDATE}

  public enum Direction {
    UP,LEFT,DOWN,RIGHT}

  public static final String init = DynamicLinkDesigner.class.getName();
  public static final String INITIALIZE = "DYN_INIT";

  private String openTypeString = Order_Type.STARTDATE.toString();      //todo da vedere nel drawer
  private String directionString;                                       //todo da vedere nel drawer
  public Set<DynamicLinkCategory> categories = new HashSet<DynamicLinkCategory>();
  public int numberoflink = 0;
  public Img image;
  public boolean linkWithImages = false;

  public String title;
  public Container container;
  private String urlCountLink = "/applications/website/layout/partDynamicLinkCount.jsp";
  public String tableCssClass = "";
  public String linkSeparator = "<br>";
  public String linkInit = "&#149;";
  public String titleCssClass = "";
  public String linkCssClass = "";
  public boolean linkCategoryTitle = true;

  private Class associationClass;
  private String associationClassIdName;
  private String associationLinkName;
  private Serializable associationLinkId;
  private List<DynamicLink> listDynamicLink=null;

  public DynamicLinkDesigner() {
    this (null, null, null, null, null,null);
  }

  public DynamicLinkDesigner(Set<DynamicLinkCategory> categories) {
    this (categories, null, null, null, null,null);
  }

  public DynamicLinkDesigner(Set<DynamicLinkCategory> categories, Container container) {
    this (categories, container, null, null, null,null);
  }


  public DynamicLinkDesigner(Set<DynamicLinkCategory> categories, Class associationClass, String associationLinkName, Serializable associationLinkId,String associationClassIdName) {
    this (categories, null, associationClass, associationLinkName, associationLinkId, associationClassIdName);
  }


  public DynamicLinkDesigner(Container container, Class associationClass, String associationLinkName, Serializable associationLinkId,String associationClassIdName) {
    this (null, container, associationClass, associationLinkName, associationLinkId, associationClassIdName);
  }

  public DynamicLinkDesigner(Class associationClass, String associationLinkName, Serializable associationLinkId,String associationClassIdName) {
    this (null, null, associationClass, associationLinkName, associationLinkId, associationClassIdName);
  }

  public DynamicLinkDesigner(Set<DynamicLinkCategory> categories, Container container, Class associationClass,
                             String associationLinkName, Serializable associationLinkId,String associationClassIdName) {
    this.urlToInclude = "/applications/website/layout/partDynamicLink.jsp";
    this.categories = categories;
    this.container = container;
    this.setAssociationClass(associationClass);
    this.setAssociationLinkName(associationLinkName);
    this.setAssociationLinkId(associationLinkId);
    this.setAssociationClassIdName(associationClassIdName);

  }

  private void init(PageContext pageContext) {
    PageState ps = PageState.getCurrentPageState((HttpServletRequest) pageContext.getRequest());
    if (!ps.initedElements.contains(init)) {
      pageContext.getRequest().setAttribute(ACTION, INITIALIZE);
      super.toHtml(pageContext);
      ps.initedElements.add(init);
    }
  }

  public void toHtml(PageContext pageContext) {
    init(pageContext);
    pageContext.getRequest().setAttribute(ACTION, "");
    super.toHtml(pageContext);
  }

  public List<DynamicLink> getListDynamicLink() {
     return listDynamicLink;
   }

   public void setListDynamicLink(List<DynamicLink> listDynamicLink) {
     this.listDynamicLink = listDynamicLink;
   }

   public String getAssociationClassIdName() {
     return associationClassIdName;
   }

   private void setAssociationClassIdName(String associationClassIdName) {
     this.associationClassIdName = associationClassIdName;
   }

  public String getDiscriminator() {
    return init;
  }

  public boolean validate(PageState pageState) throws IOException, ServletException {
    return true;
  }

  public String getOpenTypeString() {
    return openTypeString;
  }

  public void setOpenTypeString(Order_Type openType) {
    this.openTypeString = openType.toString();
  }

  public String getDirectionString() {
    return directionString;
  }

  public void setDirectionString(Direction directionString) {
    this.directionString = directionString.toString();
  }

  public Class getAssociationClass() {
    return associationClass;
  }

  private void setAssociationClass(Class associationClass) {
    this.associationClass = associationClass;
  }

  public String getAssociationLinkName() {
    return associationLinkName;
  }

  private void setAssociationLinkName(String associationLinkName) {
    this.associationLinkName = associationLinkName;
  }

  public Serializable getAssociationLinkId() {
    return associationLinkId;
  }

  private void setAssociationLinkId(Serializable associationLinkId) {
    this.associationLinkId = associationLinkId;
  }

  public String getUrlCountLink() {
    return urlCountLink;
  }

  private void setUrlCountLink(String urlCountLink) {
    this.urlCountLink = urlCountLink;
  }

}
