package com.opnlb.website.waf.html;

import com.opnlb.website.news.News;
import org.jblooming.waf.html.input.InputElement;

import javax.servlet.jsp.PageContext;
import java.net.URLEncoder;

/**
 * @author matteo rossi info@twproject.com
 */
public class NewsLinkMaker extends InputElement {

  public News news;
  public String linkedText;
  public String completeUrlWithProtocol;
  public String target;
  public String protocol;
  public String port;
  public String userName;
  public String pwd;

  public NewsLinkMaker(News news) {
    this(news, news.getUrlDescription());
  }

  public NewsLinkMaker(News news, String linkedText) {
    this(news, linkedText, null, null, null);
  }

  public NewsLinkMaker(News news, String linkedText, String completeUrlWithProtocol) {
    this(news, linkedText, completeUrlWithProtocol, null, null);
  }

  public NewsLinkMaker(News news, String linkedText, String target, String protocol, String port) {
    this(news, linkedText, target, protocol, port, null, null);
  }

  public NewsLinkMaker(News news, String linkedText, String target, String protocol, String port, String userName, String pwd) {
    this.news = news;
    this.linkedText = linkedText;
    this.target = target;
    this.protocol = protocol;
    this.port = port;
    this.userName = userName;
    this.pwd = pwd;
  }

  public StringBuffer toHtmlStringBuffer(PageContext pageContext) {

    StringBuffer sb = new StringBuffer();
    String url = news.getUrl();
    String linkedText = this.linkedText;
    String protocol = ( this.protocol!=null ? this.protocol+"://" : ( url.contains("//") ? "" : "http://" ) );
    String port = this.port!=null ? ":" + this.port : "";
    String userName = this.userName!=null ? ":" + this.userName : "";
    String pwd = this.pwd!=null ? ":" + this.pwd+ "@" : "";
    String target = this.target !=null ? " target=\""+this.target+"\"" : ( this.news!=null && this.news.getLinkTarget()!=null ? " target=\""+this.news.getLinkTarget() +"\"" : "" );

    // ftp://FTP_jbitnet:bijf@www.twproject.com
//    if (this.completeUrlWithProtocol!=null) {
//      sb.append( "<a href=\"" + this.completeUrlWithProtocol +"\""+ target+ " title=\""+url+"\">" );
//    } else if (url!=null) {
//      sb.append( "<a href=\"" + protocol + userName + pwd + url + port +"\"" + target + " title=\""+url+"\">" );
//    }
    boolean isFtp = false;
    boolean isMailto = false;
    if (url!=null && url.trim().length()>0) {
      if (url.contains("//")) {
        sb.append( "<a href=\"" + url +"\""+ target+ " title=\""+url+"\">" );
        isFtp = true;

      } else if (url.contains("mailto:")) {
        sb.append( "<a href=\"" + url +"\""+ target+ " title=\""+url+"\">" );
        isMailto = true;

      } else {
        sb.append( "<a href=\"http://" + url +"\""+ target+ " title=\""+url+"\">" );
      }
    }

    if (linkedText!=null && linkedText.trim().length()>0) {
      sb.append( linkedText );
    } else {
      if (isFtp)
        sb.append("link");        
      else if (isMailto)
        sb.append("mail"); 
      else
        sb.append( news.getUrl() );
    }
    if (url!=null) {
      sb.append( "</a>" );
    }

    return sb;
  }

  //###################################################################################################################
  //da WW3
  //###################################################################################################################

  public static boolean isSafeUrlString( String s ) {
    return s!=null && s.indexOf('.')<0 && s.indexOf(' ')<0 && s.equals ( URLEncoder.encode(s) );
  }

  public static  boolean isSafeUrlNickname( News news ) {
//    try {
//      String nick = news.getNickname();
//      if(!isSafeUrlString( nick ))
//        return false;
//      Filter filter = new Filter();
//      filter.addAttributeFilter( FilterHelper.getAttributeFilter( TeamworkDocument.getFiltrable() , TeamworkDocument.Nickname , "\""+nick+"\"") );
//      Cursor c = PortalFactory.getInstance().getDocumentManager().selectDocument( filter );
//      switch( c.getElementCount() ) {
//        case 0:
//          return true;
//        case 1:
//          return ((News)c.firstElement()).equals(news);
//        default:
//          return false;
//      }
//    } catch( Throwable t ) {
//      return false;
//    }
    return true;
  }

  /*
  public static String dotPageDocIdLink( com.opnlb.webwork.portal.SessionState sessionState , HttpServletRequest request , Node node , String documentid , String screen ) {
    if( node==null )
      node = sessionState.getLastChoosenNode( request );
    StringBuffer sb = new StringBuffer();
    if( isSafeUrlNickname( node ) )
      sb.append( node.getNickname() );
    else
      sb.append( node.getId() );
    if( documentid!=null ) {
      sb.append( "." ).append( documentid );
    }
    sb.append(WebSitePage.page);
    if( screen !=null ) {
      sb.append("?SCREEN=").append(URLEncoder.encode( screen ));
    }
    return sb.toString();
  }
  */


}
