package com.twproject.classification;

import com.twproject.document.TeamworkDocument;
import org.jblooming.classification.ClassificationNode;
import org.jblooming.ontology.Node;

import java.util.Iterator;
import java.util.Set;

/**
 * @author Pietro Polsinelli ppolsinelli@open-lab.com
 * @author Roberto Bicchierai rbicchierai@open-lab.com
 */
public class DocumentClassification extends ClassificationNode {

  //read only coll
  private Set documents;

  public DocumentClassification() {
    super();
  }

  public DocumentClassification(String id) {
    super();
    setId(id);
  }

  public void setParent(DocumentClassification n) {
    parent = n;
  }

  public DocumentClassification getParent() {
    return (DocumentClassification) parent;
  }

  public Node getParentNode() {
    return getParent();
  }

  public void setParentNode(Node node) {
    setParent((DocumentClassification) node);
  }

  private Set getDocuments() {
    return documents;
  }

  private void setDocuments(Set documents) {
    this.documents = documents;
  }

  public Iterator getDocsIterator() {
    return documents.iterator();
  }

  public boolean docsContains(TeamworkDocument document) {
    return documents.contains(document);
  }

  public int documentSize() {
    return documents.size();
  }
}
