package com.twproject.classification;

import com.twproject.resource.Resource;
import org.jblooming.classification.ClassificationNode;
import org.jblooming.ontology.Node;

import java.util.Iterator;
import java.util.Set;

/**
 * @author Pietro Polsinelli ppolsinelli@open-lab.com
 * @author Roberto Bicchierai rbicchierai@open-lab.com
 */
public class ResourceClassification extends ClassificationNode {

  //read only coll
  private Set resources;

  public ResourceClassification() {
    super();
  }

  public ResourceClassification(String id) {
    super();
    setId(id);
  }

  public void setParent(ResourceClassification n) {
    parent = n;
  }

  public ResourceClassification getParent() {
    return (ResourceClassification) parent;
  }

  public Node getParentNode() {
    return getParent();
  }

  public void setParentNode(Node node) {
    setParent((ResourceClassification) node);
  }

  private Set getResources() {
    return resources;
  }

  private void setResources(Set resources) {
    this.resources = resources;
  }

  public Iterator getResourcesIterator() {
    return resources.iterator();
  }

  public boolean resourcesContains(Resource resource) {
    return resources.contains(resource);
  }

  public int resourcesSize() {
    return resources.size();
  }

}
