package com.twproject.classification;

import com.twproject.task.Task;
import org.jblooming.classification.ClassificationNode;
import org.jblooming.ontology.Node;

import java.util.Iterator;
import java.util.Set;

/**
 * @author Pietro Polsinelli ppolsinelli@open-lab.com
 */
public class TaskClassification extends ClassificationNode {
  
  //read only coll
  private Set tasks;

  public TaskClassification() {
    super();
  }

  public TaskClassification(String id) {
    super();
    setId(id);
  }

  public void setParent(TaskClassification n) {
    parent = n;
  }

  public TaskClassification getParent() {
    return (TaskClassification) parent;
  }

  public Node getParentNode() {
    return getParent();
  }

  public void setParentNode(Node node) {
    setParent((TaskClassification) node);
  }

  private Set getTasks() {
    return tasks;
  }

  private void setTasks(Set tasks) {
    this.tasks = tasks;
  }

  public Iterator getTasksIterator() {
    return tasks.iterator();
  }

  public boolean tasksContains(Task task) {
    return tasks.contains(task);
  }

  public int tasksSize() {
    return tasks.size();
  }
}
