package com.twproject.messaging.board;

import com.twproject.messaging.stickyNote.StickyNote;
import org.jblooming.logging.Sniffable;
import org.jblooming.ontology.SecuredSupportWithArea;

import java.util.Date;
import java.util.HashSet;
import java.util.Set;

/**
 * @author Pietro Polsinelli : ppolsinelli@open-lab.com
 */
public class Board extends SecuredSupportWithArea implements Sniffable {

  private String name;
  private String description;

  private boolean active = true;

  private Date lastPostedOn;

  private Set<StickyNote> stickyNotes = new HashSet<StickyNote>();

  
  public Board() {
  }


  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }


  /**
   * is inverse
   */
  public Set<StickyNote> getStickyNotes() {
    return stickyNotes;
  }

  private void setStickyNotes(Set<StickyNote> stickyNotes) {
    this.stickyNotes = stickyNotes;
  }


  public boolean isActive() {
    return active;
  }

  public void setActive(boolean active) {
    this.active = active;
  }

  public Date getLastPostedOn() {
    return lastPostedOn;
  }

  public void setLastPostedOn(Date lastPostedOn) {
    this.lastPostedOn = lastPostedOn;
  }

}
