package com.twproject.messaging.stickyNote;

import com.twproject.messaging.board.Board;
import com.twproject.resource.Person;
import org.jblooming.ontology.LoggableIdentifiableSupport;

import java.io.Serializable;
import java.util.Date;

/**
 * @author pietro polsinelli info@twproject.com
 */
public class StickyNote extends LoggableIdentifiableSupport {

  private String type;
  private Person author;
  private Person receiver;
  private String message;
  private Date created;
  private Date read;
  private int x;
  private int y;
  private int w;
  private int h;
  private boolean iconized;

  private String color="#ffff80";
  private String icon;
  private int zorder;

  private Board board;

  private Date lastModified;



  public StickyNote() {
  }

  public StickyNote(Serializable id) {
    super(id);
  }

  public StickyNote(int id, String message) {
    super(id);
    this.message = message;
  }

  public Person getAuthor() {
    return author;
  }

  public void setAuthor(Person author) {
    this.author = author;
  }

  public Person getReceiver() {
    return receiver;
  }

  public void setReceiver(Person receiver) {
    this.receiver = receiver;
  }

  public String getMessage() {
    return message;
  }

  public void setMessage(String message) {
    this.message = message;
  }

  public Date getCreated() {
    return created;
  }

  public void setCreated(Date created) {
    this.created = created;
  }

  public Date getRead() {
    return read;
  }

  public void setRead(Date read) {
    this.read = read;
  }

  public int getX() {
    return x;
  }

  public void setX(int x) {
    this.x = x;
  }

  public int getY() {
    return y;
  }

  public void setY(int y) {
    this.y = y;
  }

  public int getW() {
    return w;
  }

  public void setW(int w) {
    this.w = w;
  }

  public int getH() {
    return h;
  }

  public void setH(int h) {
    this.h = h;
  }

  public boolean isIconized() {
    return iconized;
  }

  public void setIconized(boolean iconized) {
    this.iconized = iconized;
  }

  public String getType() {
    return type;
  }

  public void setType(String type) {
    this.type = type;
  }

  public String getName() {
    return getMessage();
  }

  public String getColor() {
    return color;
  }

  public void setColor(String color) {
    this.color = color;
  }


  public Board getBoard() {
    return board;
  }

  public void setBoard(Board board) {
    this.board = board;
  }
}
