package com.twproject.reservableService;

import com.twproject.resource.Person;
import org.jblooming.oql.QueryHelper;
import org.jblooming.page.HibernatePage;
import org.jblooming.persistence.exceptions.PersistenceException;
import org.jblooming.utilities.JSP;
import org.jblooming.waf.constants.AnagraphicalDataConstants;
import org.jblooming.waf.constants.Commands;
import org.jblooming.waf.constants.OperatorConstants;
import org.jblooming.waf.exceptions.ActionException;
import org.jblooming.waf.html.core.JspHelper;
import org.jblooming.waf.html.display.Paginator;
import org.jblooming.waf.html.input.Collector;
import org.jblooming.waf.html.state.Form;
import org.jblooming.waf.view.ClientEntries;
import org.jblooming.waf.view.ClientEntry;
import org.jblooming.waf.view.PageState;

import java.util.List;
import java.util.TreeMap;

/**
 * Created by IntelliJ IDEA.
 * User: angantcha
 * Date: 5-feb-2007
 * Time: 14.51.36
 * To change this template use File | Settings | File Templates.
 */

public class DrawPeopleSearch extends JspHelper {
  public boolean drawGroup = false;
  public boolean drawCommunity = false;
  private TreeMap collectorTreeMapForCheckBox = null;
  public boolean drawPeopleAjaxSearch = true;
  public boolean forCollector = true;
  public String comandSeachr= Commands.CMD_SEARCH_OPERATOR;
  public Form form;

  public DrawPeopleSearch(String id, Form form) {
    this(id, null, form);
  }

  public DrawPeopleSearch(String id, TreeMap collectorTreeMapForCheckBox, Form form) {
    super();
    this.id = id;
    this.form = form;
    setCollectorTreeMapForCheckBox(collectorTreeMapForCheckBox);
    this.urlToInclude = "/commons/reservableService/parts/partUserSearch.jsp";
    if (drawPeopleAjaxSearch) {
//      getPeopleAjaxSearch().drawGroup = this.drawGroup;
//      getPeopleAjaxSearch().drawCommunity = this.drawCommunity;
    }
  }



  public TreeMap getCollectorTreeMapForCheckBox() {
    return collectorTreeMapForCheckBox;
  }

  public void setCollectorTreeMapForCheckBox(TreeMap collectorTreeMapForCheckBox) {
    this.collectorTreeMapForCheckBox = collectorTreeMapForCheckBox;
  }


  public static void addEntriesOperatorSearch(PageState pageState)throws ActionException {

     String my_form_id = pageState.getEntry("MY_FORM_ID").stringValueNullIfEmpty();
     if(my_form_id!=null){
       pageState.addClientEntry(OperatorConstants.FLD_NAME + "", pageState.getEntry(OperatorConstants.FLD_NAME + "1").stringValue());
       pageState.addClientEntry(AnagraphicalDataConstants.FLD_TELEPHONE + "", pageState.getEntry( AnagraphicalDataConstants.FLD_TELEPHONE + "1").stringValue());
       pageState.addClientEntry("MYCOSTCENTER", pageState.getEntry( "MYCOSTCENTER1").stringValue());
     }
   }

  public static void clearClientEntry(PageState pageState) {
    ClientEntries oldEntries = pageState.getClientEntries();
    pageState.setClientEntries(null);
    ClientEntries newEntries = new ClientEntries();
    if (oldEntries != null && oldEntries.size() > 0) {
      for (String key : oldEntries.getEntryKeys()) {
        if (!key.startsWith(Collector.getCandidateFieldPrefix("EC"))) {
          ClientEntry entry = oldEntries.getEntry(key);
          newEntries.addEntry(entry);
        }
      }
    }
    pageState.setClientEntries(newEntries);
  }

  public static void refillCollector(PageState pageState, String colletorId, boolean forCollector) throws PersistenceException, ActionException {
    clearClientEntry(pageState);
    addEntriesOperatorSearch( pageState);
//          TeamworkOperator twop = (TeamworkOperator) PersistenceHome.findByPrimaryKey(TeamworkOperator.class,key);
//          Person person = twop.getMyPerson();

    String hql = "select distinct operator.id, operator.PersonName, operator.PersonSurname from " + Person.class.getName() + " as operator ";

    String inputTel = pageState.getEntry(AnagraphicalDataConstants.FLD_TELEPHONE ).stringValueNullIfEmpty();

    String orderby = pageState.getEntry(Form.FLD_FORM_ORDER_BY + "ORDERBY").stringValueNullIfEmpty();
    if (orderby == null) {
      hql = hql + " order by operator.PersonSurname, operator.PersonName ";
    } else {
      pageState.addClientEntry(Form.FLD_FORM_ORDER_BY + "ORDERBY", (orderby));
    }
    QueryHelper qhelp = new QueryHelper(hql);
    qhelp.convertToUpper = true;

    String inputName = pageState.getEntry(OperatorConstants.FLD_NAME ).stringValueNullIfEmpty();
    if (inputName != null) {

      qhelp.defaultMatch = QueryHelper.DefaultMatch.STARTS_WITH;
      int pos =inputName.trim().indexOf(" ");
      if (pos >= 0)
        inputName = "\"" + inputName + "\"";
      qhelp.addQueryClause(qhelp.getQbeClause("operator.PersonName", "name", inputName, QueryHelper.TYPE_CHAR)
              + " OR " +
              qhelp.getQbeClause("operator.PersonSurname", "surname", inputName, QueryHelper.TYPE_CHAR));
      qhelp.defaultMatch = QueryHelper.DefaultMatch.CONTAINS;
    }


    String mycostcenter = pageState.getEntry("MYCOSTCENTER").stringValueNullIfEmpty();
    if (mycostcenter != null) {
      qhelp.addOQLClause( "operator.myCostAggregator.id=:myCostAggregator", "myCostAggregator", Integer.parseInt(mycostcenter));

    }

    if(forCollector){
      TreeMap<String, String> ctm = Collector.chosen("EC", pageState);
      List<Object[]> cand = qhelp.toHql().list();
     //cand.
      TreeMap<String, String> candTm = new TreeMap<String, String>();
      if (cand != null && cand.size() > 0) {
        for (Object[] aCand : cand) {
          if (ctm == null || !ctm.keySet().contains(aCand[0]+""))
            candTm.put(aCand[0]+"", JSP.w(aCand[2]) + " " + JSP.w(aCand[1]));
        }
      }
      Collector.make(colletorId, candTm, ctm, pageState);
    }else{
      pageState.setPage(
              HibernatePage.getHibernatePageInstance(qhelp.toHql().getQuery(),
                      Paginator.getWantedPageNumber(pageState), Paginator.getWantedPageSize(pageState))
      );

    }
  }
}
