package com.twproject.reservableService;

//import com.boehringer.eu.bijf.community.Community;

import com.twproject.resource.Person;
import org.jblooming.company.Location;
import org.jblooming.ontology.SecuredLoggableHideableSupport;
import org.jblooming.operator.Operator;
import org.jblooming.persistence.exceptions.StoreException;

import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;


public class ReservableService   extends SecuredLoggableHideableSupport {
  private String name;
  private String description;
  private ReservableServiceType reservableServiceType;
  private boolean free=false; //visibilità a tutti ?
  private Location location;
  private boolean cantseeWithOutRigth;
  private double hourCost;//CostoOrario
  private double otherCost;//Costoforfettario

  private Set<ReservableServiceUser> reservableServiceUsers = new HashSet<ReservableServiceUser>();
  private Set<ReservableServiceImage> reservableServiceImages = new HashSet<ReservableServiceImage>();
  //private Set<Reservation> reservableServiceReservations = new HashSet<Reservation>();

 // private Community community;
  private boolean cancelled =false;


/*

  public Iterator getReservableServiceReservationsIterator() {
    Set tmp = new HashSet(getReservableServiceReservations());
    return tmp.iterator();
  }

  public boolean reservableServiceReservationContains(Reservation reservation) {
    return getReservableServiceReservations().contains(reservation);
  }

  public int reservableServiceReservationSize() {
    return getReservableServiceReservations().size();
  }

  private Set<Reservation> getReservableServiceReservations() {
    return reservableServiceReservations;
  }

  private void setReservableServiceReservations(Set<Reservation> reservableServiceReservations) {
    this.reservableServiceReservations = reservableServiceReservations;
  }

  public void removereservableServiceReservationFromMemory(Reservation reservation) {
    getReservableServiceReservations().remove(reservation);
  }
*/


  public Iterator getReservableServiceImagesIterator() {
    Set tmp = new HashSet(getReservableServiceImages());
    return tmp.iterator();
  }

  public boolean reservableServiceImageContains(ReservableServiceImage image) {
    return getReservableServiceImages().contains(image);
  }

  public int reservableServiceImageSize() {
    return getReservableServiceImages().size();
  }

  public Set<ReservableServiceImage> getReservableServiceImages() {
    return reservableServiceImages;
  }

  private void setReservableServiceImages(Set<ReservableServiceImage> reservableServiceImages) {
    this.reservableServiceImages = reservableServiceImages;
  }

  public void removereservableServiceImageFromMemory(ReservableServiceImage img) {
    getReservableServiceImages().remove(img);
  }

  public void addreservableServiceImageFromMemory(ReservableServiceImage img) {
    getReservableServiceImages().add(img);
  }

/*

  public void addReservableServiceImageAndPersist(ReservableServiceImage ncm,PersistentFile image) throws StoreException {
    ReservableServiceImage ncm = new ReservableServiceImage();
    ncm.setIdAsNew();
    ncm.setImage(image);
    ncm.setReservableService(this);
    ncm.store();
  }
*/


  public Iterator getReservableServiceUsersIterator() {
    Set tmp = new HashSet(getReservableServiceUsers());
    return tmp.iterator();
  }

  public boolean reservableServiceUserContains(Operator operator) {
    return getReservableServiceUsers().contains(operator);
  }

  public int reservableServiceUserSize() {
    return getReservableServiceUsers().size();
  }

  public Set<ReservableServiceUser> getReservableServiceUsers() {
    return reservableServiceUsers;
  }

  private void setReservableServiceUsers(Set<ReservableServiceUser> reservableServiceUsers) {
    this.reservableServiceUsers = reservableServiceUsers;
  }

  public void removereservableServiceUserFromMemory(ReservableServiceUser usr) {
    getReservableServiceUsers().remove(usr);
  }

  public void addReservableServiceUserAndPersist(Person operator) throws StoreException {
    ReservableServiceUser ncm = new ReservableServiceUser();
    ncm.setIdAsNew();
    ncm.setOperator(operator);
    ncm.setReservableService(this);
    ncm.store();
  }


  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public ReservableServiceType getReservableServiceType() {
    return reservableServiceType;
  }

  public void setReservableServiceType(ReservableServiceType reservableServiceType) {
    this.reservableServiceType = reservableServiceType;
  }

  public boolean isFree() {
    return free;
  }

  public void setFree(boolean free) {
    this.free = free;
  }

  public Location getLocation() {
    return location;
  }

  public void setLocation(Location location) {
    this.location = location;
  }

  public boolean isCantseeWithOutRigth() {
    return cantseeWithOutRigth;
  }

  public void setCantseeWithOutRigth(boolean cantseeWithOutRigth) {
    this.cantseeWithOutRigth = cantseeWithOutRigth;
  }

//  public Community getCommunity() {
//    return community;
//  }
//
//  public void setCommunity(Community community) {
//    this.community = community;
//  }

  public boolean isCancelled() {
    return cancelled;
  }

  public void setCancelled(boolean cancelled) {
    this.cancelled = cancelled;
  }


  public double getHourCost() {
    return hourCost;
  }

  public void setHourCost(double hourCost) {
    this.hourCost = hourCost;
  }

  public double getOtherCost() {
    return otherCost;
}

  public void setOtherCost(double otherCost) {
    this.otherCost = otherCost;
  }
}


