package com.twproject.security;

import org.jblooming.security.Permission;
import org.jblooming.security.Permissions;

/**
 * @author Roberto Bicchierai rbicchierai@open-lab.com
 *         Date: 8-apr-2005 : 15.46.02
 */
public class TeamworkPermissions extends Permissions {

  protected static final String TW_BASE = "TW_";

  public static final Permission system_canManageCalendar = new Permission(TW_BASE + "sys_cal");

  public static final Permission resource_canRead = new Permission(TW_BASE + "res_r");
  public static final Permission resource_canWrite = new Permission(TW_BASE + "res_w");
  public static final Permission resource_canCreate = new Permission(TW_BASE + "res_c");
  public static final Permission resource_cost_canRead = new Permission(TW_BASE + "res_cstiu");

  // used for giving assignability to all resources of an area
  public static final Permission resource_assignment_manage = new Permission(TW_BASE + "res_ass");
  //same but at task level
  public static final Permission task_assignment_manage = new Permission(TW_BASE + "tk_ass");

  public static final Permission task_canRead = new Permission(TW_BASE + "task_r");
  public static final Permission task_canCreate = new Permission(TW_BASE + "task_c");
  public static final Permission task_canWrite = new Permission(TW_BASE + "task_w");


  public static final Permission task_cost_canRead = new Permission(TW_BASE + "tk_cost_r");
  public static final Permission task_cost_canCreate = new Permission(TW_BASE + "tk_cost_c");
  public static final Permission task_cost_canWrite = new Permission(TW_BASE + "tk_cost_w");

  public static final Permission issue_canRead = new Permission(TW_BASE + "issue_r");
  public static final Permission issue_canWrite = new Permission(TW_BASE + "issue_w");
  public static final Permission issue_canCreate = new Permission(TW_BASE + "issue_c");

  public static final Permission document_canRead = new Permission(TW_BASE + "doc_r");
  public static final Permission document_canWrite = new Permission(TW_BASE + "doc_w");
  public static final Permission document_canCreate = new Permission(TW_BASE + "doc_c");

  public static final Permission classificationTree_canManage = new Permission(TW_BASE + "clTree_m");

  public static final Permission board_canRead = new Permission(TW_BASE + "board_r");
  public static final Permission board_canWrite = new Permission(TW_BASE + "board_w");
  public static final Permission board_canCreate = new Permission(TW_BASE + "board_c");

  public static final Permission fileStorage_canRead =new Permission(TW_BASE + "fileStor_r");
  public static final Permission fileStorage_canWrite =new Permission(TW_BASE + "fileStor_w");
  public static final Permission fileStorage_canCreate =new Permission(TW_BASE + "fileStor_c");

  public static final Permission fileStorage_explorer_canRead =new Permission(TW_BASE + "filStoEx_r");
  public static final Permission fileStorage_explorer_canWrite =new Permission(TW_BASE + "filStoEx_w");
  public static final Permission fileStorage_explorer_canCreate =new Permission(TW_BASE + "filStoEx_c");

}
