package com.twproject.task;

import com.twproject.resource.Resource;
import com.twproject.worklog.Worklog;
import org.jblooming.logging.Auditable;
import org.jblooming.logging.Sniffable;
import org.jblooming.ontology.PersistentFile;
import org.jblooming.ontology.PersistentText;
import org.jblooming.ontology.SecuredLoggableHideableSupport;
import org.jblooming.operator.Operator;

import java.util.Date;
import java.util.HashSet;
import java.util.Set;

/**
 * @author Pietro Polsinelli ppolsinelli@open-lab.com
 * @author Roberto Bicchierai rbicchierai@open-lab.com
 */
public abstract class IssuePersistent extends SecuredLoggableHideableSupport implements Auditable, Sniffable {

  private Operator owner;
  private String status;
  private String gravity;
  private IssueType type;
  private IssueImpact impact;
  private double orderFactor;

  private String description;
  private int votes;
  private Date shouldCloseBy;
  private Date dateSignalled;
  private Task task;
  private Resource assignedTo;
  private Resource assignedBy;
  private PersistentFile screenShot1;
  private PersistentFile screenShot2;
  private String url1;
  private String url2;

  private PersistentText notes;

  private Date lastStatusChangeDate;
  private String estimatedDuration;

  //read only
  protected Set<Worklog> worklogs = new HashSet<Worklog>();

  public IssuePersistent() {
    }

  public Set<Worklog> getWorklogs() {
    return worklogs;
  }

  private void setWorklogs(Set<Worklog> worklogs) {
    this.worklogs = worklogs;
  }

  public String getStatus() {
    return status;
  }

  public void setStatus(String status) {
    this.status = status;
  }

  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public String getGravity() {
    return gravity;
  }

  public void setGravity(String gravity) {
    this.gravity = gravity;
  }

  public int getVotes() {
    return votes;
  }

  public void setVotes(int votes) {
    this.votes = votes;
  }

  public Date getShouldCloseBy() {
    return shouldCloseBy;
  }

  public void setShouldCloseBy(Date shouldCloseBy) {
    this.shouldCloseBy = shouldCloseBy;
  }


  public Task getTask() {
    return task;
  }

  public void setTask(Task task) {
    this.task = task;
  }

  public Resource getAssignedTo() {
    return assignedTo;
  }

  public void setAssignedTo(Resource assignedTo) {
    this.assignedTo = assignedTo;
  }

  public Operator getOwner() {
    return owner;
  }

  public void setOwner(Operator owner) {
    this.owner = owner;
  }

  public PersistentFile getScreenShot1() {
    return screenShot1;
  }

  public void setScreenShot1(PersistentFile screenShot1) {
    this.screenShot1 = screenShot1;
  }

  public IssueImpact getImpact() {
    return impact;
  }

  public void setImpact(IssueImpact impact) {
    this.impact = impact;
  }

  public IssueType getType() {
    return type;
  }

  public void setType(IssueType type) {
    this.type = type;
  }

  public Date getLastStatusChangeDate() {
    return lastStatusChangeDate;
  }

  public void setLastStatusChangeDate(Date lastStatusChangeDate) {
    this.lastStatusChangeDate = lastStatusChangeDate;
  }

  public Resource getAssignedBy() {
    return assignedBy;
  }

  public void setAssignedBy(Resource assignedBy) {
    this.assignedBy = assignedBy;
  }

  public String getEstimatedDuration() {
    return estimatedDuration;
  }

  public void setEstimatedDuration(String estimatedDuration) {
    this.estimatedDuration = estimatedDuration;
  }

  public double getOrderFactor() {
    return orderFactor;
  }

  public void setOrderFactor(double orderFactor) {
    this.orderFactor = orderFactor;
  }

  public PersistentFile getScreenShot2() {
    return screenShot2;
  }

  public void setScreenShot2(PersistentFile screenShot2) {
    this.screenShot2 = screenShot2;
  }

  public String getUrl1() {
    return url1;
  }

  public void setUrl1(String url1) {
    this.url1 = url1;
  }

  public String getUrl2() {
    return url2;
  }

  public void setUrl2(String url2) {
    this.url2 = url2;
  }

  public PersistentText getNotes() {
    return notes;
  }

  public void setNotes(PersistentText notes) {
    this.notes = notes;
  }

  public Date getDateSignalled() {
    return dateSignalled;
  }

  public void setDateSignalled(Date dateSignalled) {
    this.dateSignalled = dateSignalled;
  }
}
