package com.twproject.task;

import org.jblooming.ontology.LookupStringWithAreaSupport;
import org.jblooming.oql.OqlQuery;
import org.jblooming.persistence.exceptions.FindException;

/**
 * @author Pietro Polsinelli ppolsinelli@open-lab.com
 */


public class TaskType extends LookupStringWithAreaSupport {
  public enum Type {FEASIBILITY, PRODUCTION }

  public static TaskType getDefaultTaskType(Type code) throws FindException {
    String hql = "from "+TaskType.class.getName() + " as dt where dt.stringValue = :typ";
    OqlQuery oql = new OqlQuery(hql);
    oql.getQuery().setString("typ",code.toString());
    return (TaskType) oql.uniqueResult();
  }

}
