package com.twproject.two.ontology;

import com.twproject.two.security.AreaOld;

import java.util.Date;


/**
 * This class holds a group of nodes
 *
 * @author Roberto Bicchierai & Pietro Polsinelli
 * @since JDK 1.4
 */

public class GroupOld  {
  private String id;

  protected String name;

  private AreaOld area;

  private String type;

  private boolean deleted;
  private Date lastModified;

  // interface OperatorAggregator implementation
// start
  private boolean resourceInherit;
  private boolean resourcePropagate;

  public static final String package_prefix = "com.twproject.tree";
  public static final String GROUP = package_prefix + ".GROUP";
  public static final String GROUP_WITH_SAME_USER_EXISTING = package_prefix + ".GROUP_WITH_SAME_USER_EXISTING";

  public GroupOld() {
  }

  public GroupOld(String id) {
    this.setId(id);
  }

  public String getId() {
    return id;
  }



  /**
   * Method setFullName
   *
   * @param s a  String
   */
  public void setName(String s) {
    name = s;
  }

  public String getName() {
    return name;
  }



  /**
   * Method setPropagate  NOT USED
   *
   * @param propagate a  boolean
   */
  public void setPropagate(boolean propagate) {
  }

  /**
   * Method getPropagate NOT USED return allways false
   * interface OperatorAggregator implementation
   *
   * @return a boolean
   */
  public boolean getPropagate() {
    return false;
  }

  /**
   * Method setInherit NOT USED
   * interface OperatorAggregator implementation
   *
   * @param inherit a  boolean
   */
  public void setInherit(boolean inherit) {
  }

  /**
   * Method getInherit NOT USED return allways false
   * interface OperatorAggregator implementation
   *
   * @return a boolean
   */
  public boolean getInherit() {
    return false;
  }



  public AreaOld getArea() {
    return area;
  }

  public void setArea(AreaOld area) {
    this.area = area;
  }

  public void setId(String id) {
    this.id = id;
  }

  public String getType() {
    return type;
  }

  public void setType(String type) {
    this.type = type;
  }

  public boolean isDeleted() {
    return deleted;
  }

  public void setDeleted(boolean deleted) {
    this.deleted = deleted;
  }

  public Date getLastModified() {
    return lastModified;
  }

  public void setLastModified(Date lastModified) {
    this.lastModified = lastModified;
  }
}
