package com.twproject.two.resource;


import java.util.Date;


/**
 * <code>AnagraphicalData</code> holds a record for a location reference
 * <br>
 * <p/>
 * <code>locationDescription</code> e.g.: office, home, etc.<br>
 *
 * @author Pietro Polsinelli, Roberto Bicchierai
 * @version 2 alpha
 * @since JDK 1.4
 */

public class AnagraphicalDataOld  {

  private String id;

  private String locationDescription;

  private String address;
  private String zip;
  private String telephone;
  private String mobile;
  private String fax;
  private String email;
  private String url;
  private String city;
  private String province;
  private String state;
  private String country;
  private String orderFactor;

  private boolean deleted;
  private Date lastModified;

  public static final String ANAGRAPHICALDATA = ResourceOld.package_prefix + ".ANAGRAPHICALDATA";

  public AnagraphicalDataOld() {
  }

  public AnagraphicalDataOld(String pId) {
    id = pId;
  }

  public void setId(String id) {
    this.id = id;
  }

  public String getId() {
    return id;
  }


  /**
   * Method setLocationDescription
   *
   * @param locationDescription a  String
   */
  public void setLocationDescription(String locationDescription) {
    this.locationDescription = locationDescription;
  }

  /**
   * Method getLocationDescription
   *
   * @return a String
   */
  public String getLocationDescription() {
    return locationDescription;
  }

  /**
   * Method setAddress
   *
   * @param address a  String
   */
  public void setAddress(String address) {
    this.address = address;
  }

  /**
   * Method getAddress
   *
   * @return a String
   */
  public String getAddress() {
    return address;
  }

  /**
   * Method setTelephone
   *
   * @param telephone a  String
   */
  public void setTelephone(String telephone) {
    this.telephone = telephone;
  }

  /**
   * Method getTelephone
   *
   * @return a String
   */
  public String getTelephone() {
    return telephone;
  }

  /**
   * Method setFax
   *
   * @param fax a  String
   */
  public void setFax(String fax) {
    this.fax = fax;
  }

  /**
   * Method getFax
   *
   * @return a String
   */
  public String getFax() {
    return fax;
  }

  /**
   * Method setEmail
   *
   * @param email a  String
   */
  public void setEmail(String email) {
    this.email = email;
  }

  /**
   * Method getEmail
   *
   * @return a String
   */
  public String getEmail() {
    return email;
  }

  /**
   * Method setUrl
   *
   * @param url a  String
   */
  public void setUrl(String url) {
    this.url = url;
  }

  /**
   * Method getUrl
   *
   * @return a String
   */
  public String getUrl() {
    return url;
  }


  /**
   * Method setCity
   *
   * @param city a  String
   */
  public void setCity(String city) {
    this.city = city;
  }

  /**
   * Method getCity
   *
   * @return a String
   */
  public String getCity() {
    return city;
  }

  /**
   * Method setState
   *
   * @param state a  String
   */
  public void setState(String state) {
    this.state = state;
  }

  /**
   * Method getState
   *
   * @return a String
   */
  public String getState() {
    return state;
  }

  /**
   * Method setCountry
   *
   * @param country a  String
   */
  public void setCountry(String country) {
    this.country = country;
  }

  /**
   * Method getCountry
   *
   * @return a String
   */
  public String getCountry() {
    return country;
  }

  public String getMobile() {
    return mobile;
  }

  public void setMobile(String mobile) {
    this.mobile = mobile;
  }

  public String getZip() {
    return zip;
  }

  public void setZip(String zip) {
    this.zip = zip;
  }

  public String getOrderFactor() {
    return orderFactor;
  }

  public void setOrderFactor(String orderFactor) {
    this.orderFactor = orderFactor;
  }

  public String getProvince() {
    return province;
  }

  public void setProvince(String province) {
    this.province = province;
  }

  public boolean isDeleted() {
    return deleted;
  }

  public void setDeleted(boolean deleted) {
    this.deleted = deleted;
  }

  public Date getLastModified() {
    return lastModified;
  }

  public void setLastModified(Date lastModified) {
    this.lastModified = lastModified;
  }

  public boolean equals(Object o) {
    if (o == null || !(o instanceof AnagraphicalDataOld))
      return false;
    else
      return id.equals(((AnagraphicalDataOld) o).getId());
  }

  public int hashCode() {

    int result = 0;
    if (id != null)
      result = id.hashCode();
    return result;
  }

}

