package com.twproject.two.resource;


import com.twproject.two.security.AreaOld;

import java.util.Date;


/**
 * This class ...
 * <p/>
 * Implements the OperatorAggregator interface using the ResourceHome filtering by
 * skill.
 *
 * @author Roberto Bicchierai & Pietro Polsinelli
 * @version 2 alpha
 * @since JDK 1.4
 */
public class SkillOld  {

  private String id;
  private String name;
  private String description;
  private AreaOld area;
  private boolean inherit = false;
  private boolean propagate = false;

  private long hourlyCost = 0;

  private boolean deleted;
  private Date lastModified;

  public static final String package_prefix = "com.twproject.resource";
  public static final String SKILL = package_prefix + ".SKILL";

  public SkillOld() {
  }

  public SkillOld(String sId) {
    setId(sId);
  }


  /**
   * Method setPropagate
   * interface OperatorAggregator implementation
   *
   * @param propagate a  boolean
   */
  public void setPropagate(boolean propagate) {
    this.propagate = propagate;
  }

  /**
   * Method getPropagate
   * interface OperatorAggregator implementation
   *
   * @return a boolean
   */
  public boolean getPropagate() {
    return false;
  }

  /**
   * Method setInherit
   * interface OperatorAggregator implementation
   *
   * @param inherit a  boolean
   */
  public void setInherit(boolean inherit) {
    this.inherit = inherit;
  }

  /**
   * Method getInherit
   * interface OperatorAggregator implementation
   *
   * @return a boolean
   */
  public boolean getInherit() {
    return false;
  }
  // end

  // interface Securable implementation
  // start

  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public AreaOld getArea() {
    return area;
  }

  public void setArea(AreaOld area) {
    this.area = area;
  }

  public boolean isInherit() {
    return inherit;
  }

  public boolean isPropagate() {
    return propagate;
  }

  public long getHourlyCost() {
    return hourlyCost;
  }

  public void setHourlyCost(long hourlyCost) {
    this.hourlyCost = hourlyCost;
  }

  public boolean isDeleted() {
    return deleted;
  }

  public void setDeleted(boolean deleted) {
    this.deleted = deleted;
  }

  public Date getLastModified() {
    return lastModified;
  }

  public void setLastModified(Date lastModified) {
    this.lastModified = lastModified;
  }
}

