package com.twproject.two.security;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.util.Hashtable;
import java.util.Map;

public class PermissionOld implements Comparable, Serializable {

  public int type;
  public boolean systemPermission;
  public String name;

  public static final String package_prefix = "com.twproject.security";

  // system permissions

  public final static PermissionOld perm_system_canManageCalendar = new PermissionOld(1301, true, "perm_system_canManageCalendar");
  public final static PermissionOld perm_system_canBackupSystem = new PermissionOld(1302, true, "perm_system_canBackupSystem");
  public final static PermissionOld perm_system_canRestoreSystem = new PermissionOld(1304, true, "perm_system_canRestoreSystem");
  public final static PermissionOld perm_system_canArchive = new PermissionOld(1304, true, "perm_system_canArchive");
  public final static PermissionOld perm_system_canAdminister = new PermissionOld(1305, true, "perm_system_canAdminister");
  public final static PermissionOld perm_role_canRead = new PermissionOld(1501, true, "perm_role_canRead");
  public final static PermissionOld perm_role_canWrite = new PermissionOld(1502, true, "perm_role_canWrite");


  // area permissions

  public final static PermissionOld perm_resource_canRead = new PermissionOld(101, false, "perm_resource_canRead");
  public final static PermissionOld perm_resource_canWrite = new PermissionOld(102, false, "perm_resource_canWrite");

  public final static PermissionOld perm_task_canRead = new PermissionOld(201, false, "perm_task_canRead");
  public final static PermissionOld perm_task_canWrite = new PermissionOld(202, false, "perm_task_canWrite");
  public final static PermissionOld perm_task_canInsertWorkLog = new PermissionOld(203, false, "perm_task_canInsertWorkLog");
  public final static PermissionOld perm_task_canDefinePM = new PermissionOld(204, false, "perm_task_canDefinePM");

  public final static PermissionOld perm_assig_canRead = new PermissionOld(205, false, "perm_assig_canRead");
  public final static PermissionOld perm_assig_canWrite = new PermissionOld(206, false, "perm_assig_canWrite");

  public final static PermissionOld perm_document_canRead = new PermissionOld(301, false, "perm_document_canRead");
  public final static PermissionOld perm_document_canWrite = new PermissionOld(302, false, "perm_document_canWrite");
  public final static PermissionOld perm_document_canOverwrite = new PermissionOld(303, false, "perm_document_canOverwrite");

  public final static PermissionOld perm_group_canRead = new PermissionOld(501, false, "perm_group_canRead");
  public final static PermissionOld perm_group_canWrite = new PermissionOld(502, false, "perm_group_canWrite");

  public final static PermissionOld perm_area_canRead = new PermissionOld(801, false, "perm_area_canRead");
  public final static PermissionOld perm_area_canWrite = new PermissionOld(802, false, "perm_area_canWrite");

  public final static PermissionOld perm_file_canRead = new PermissionOld(901, false, "perm_file_canRead");
  public final static PermissionOld perm_file_canWrite = new PermissionOld(902, false, "perm_file_canWrite");

  public final static PermissionOld perm_operator_canRead = new PermissionOld(1101, false, "perm_operator_canRead");
  public final static PermissionOld perm_operator_canWrite = new PermissionOld(1102, false, "perm_operator_canWrite");

  public final static PermissionOld perm_skill_canRead = new PermissionOld(1201, false, "perm_skill_canRead");
  public final static PermissionOld perm_skill_canWrite = new PermissionOld(1202, false, "perm_skill_canWrite");

  public final static PermissionOld perm_message_canRead = new PermissionOld(1401, false, "perm_mail_canRead");
  public final static PermissionOld perm_message_canWrite = new PermissionOld(1402, false, "perm_mail_canWrite");

  public final static PermissionOld perm_news_canRead = new PermissionOld(1601, false, "perm_news_canRead");
  public final static PermissionOld perm_news_canWrite = new PermissionOld(1602, false, "perm_news_canWrite");

  public final static PermissionOld perm_issue_canRead = new PermissionOld(1701, false, "perm_issue_canRead");
  public final static PermissionOld perm_issue_canWrite = new PermissionOld(1702, false, "perm_issue_canWrite");

  public final static PermissionOld perm_cost_canRead = new PermissionOld(1801, false, "perm_cost_canRead");
  public final static PermissionOld perm_cost_canWrite = new PermissionOld(1802, false, "perm_cost_canWrite");

  public final static PermissionOld perm_sync_can_read = new PermissionOld(1901, false, "perm_sync_can_read");
  public final static PermissionOld perm_sync_can_write = new PermissionOld(1902, false, "perm_sync_can_write");

  public final static PermissionOld perm_board_can_read = new PermissionOld(2001, false, "perm_board_can_read");
  public final static PermissionOld perm_board_can_write = new PermissionOld(2002, false, "perm_board_can_write");

  public static final String PERMISSION_LACKING = package_prefix + ".PERMISSION_LACKING";
  public static final String NO_RIGHTS = package_prefix + ".NO_RIGHTS";


  private static Map permissions = new Hashtable();


  private PermissionOld() {
  }

  private PermissionOld(int i, boolean isSystemPermission, String name) {
    this.type = i;
    this.name = name;
    this.systemPermission = isSystemPermission;
  }

  public void setType(int type) {
    this.type = type;
  }

  public int getType() {
    return this.type;
  }


  public boolean getSystemPermission() {
    return systemPermission;
  }

  public String getName() {
    return name;
  }


  public int compareTo(Object o) {
    if (o == null)
      return 0;
    else
      return this.getType() - ((PermissionOld) o).getType();
  }

  public boolean equals(Object o) {
    return this.compareTo(o) == 0;
  }

  /**
   * This method solves collection'identity
   */
  public int hashCode() {
    return getType();
  }

  /**
   * @return a Map of Permission with Permission.getType() as key cast (Integer)
   */
  public static Map getPermissions() {
    if (permissions.isEmpty()) {
      try {
        Field f[] = PermissionOld.class.getFields();
        for (int i = 0; i < f.length; i++) {
          if (f[i].getName().startsWith("perm_")) {
            PermissionOld p = (PermissionOld) f[i].get(new PermissionOld());
            permissions.put(new Integer(p.getType()), p);
          }
        }
      } catch (IllegalArgumentException e) {
        throw new RuntimeException(e);
      } catch (IllegalAccessException e) {
        throw new RuntimeException(e);
      }
    }
    return permissions;
  }

  public static PermissionOld getPermission(int type) {
    if (permissions.isEmpty())
      getPermissions();
    return (PermissionOld) permissions.get(new Integer(type));
  }
}

