package com.twproject.two.task;

import com.twproject.two.resource.ResourceOld;
import com.twproject.two.worklog.WorkLogOld;

import java.util.Date;
import java.util.HashSet;
import java.util.Set;


public class AssignementOld implements  Comparable {

  protected String id;
  private String description;
  protected ResourceOld resource;
  private TaskOld task;
  protected double mimimalWorkLog;
  private Date assignementDate;
  private Set workLogs;

  private boolean counted;
  private Date countingStartedAt;

  private boolean deleted;
  private Date lastModified;

  private String activity;

  private long hourlyCost = 0;

  private boolean enabled = true;

  public static final String package_prefix = "com.twproject.task";
  public static final String ASSIGNEMENT = package_prefix + ".ASSIGNEMENT";

  public static final String ACTIVITY_CONTINUOUS = ASSIGNEMENT + "ACTIVITY_CONTINUOUS";
  public static final String ACTIVITY_OCCASIONAL = ASSIGNEMENT + "ACTIVITY_OCCASIONAL";

  public AssignementOld() {
  }

  public AssignementOld(String id) {
    this.setId(id);
  }

  public ResourceOld getResource() {
    return resource;
  }

  public void setResource(ResourceOld resource) {
    this.resource = resource;
  }

  public double getMimimalWorkLog() {
    return mimimalWorkLog;
  }

  public void setMimimalWorkLog(double mimimalWorkLog) {
    this.mimimalWorkLog = mimimalWorkLog;
  }

  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public Date getAssignementDate() {
    return assignementDate;
  }

  public void setAssignementDate(Date assignementDate) {
    this.assignementDate = assignementDate;
  }

  public Set getWorkLogs() {
    return workLogs;
  }


  public void setWorkLogs(Set workLogs) {
    this.workLogs = workLogs;
  }

  public void addWorkLog(WorkLogOld wl) {
    if (workLogs == null) workLogs = new HashSet();
    workLogs.add(wl);
    wl.setAssig(this);
  }

  public void removeWorkLog(WorkLogOld wl) {
    if (workLogs != null)
      workLogs.remove(wl);
  }

  public TaskOld getTask() {
    return task;
  }

  public void setTask(TaskOld task) {
    this.task = task;
  }

  public int compareTo(Object o) {
    return this.getId().compareTo(((AssignementOld) o).getId());
  }

  public boolean equals(Object o) {
    return this.compareTo(o) == 0;
  }



  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public boolean isDeleted() {
    return deleted;
  }

  public void setDeleted(boolean deleted) {
    this.deleted = deleted;
  }

  public Date getLastModified() {
    return lastModified;
  }

  public void setLastModified(Date lastModified) {
    this.lastModified = lastModified;
  }

  public boolean isCounted() {
    return counted;
  }



  public Date getCountingStartedAt() {
    return countingStartedAt;
  }

  public void setCountingStartedAt(Date countingStartedAt) {
    this.countingStartedAt = countingStartedAt;
  }

  
  public String getActivity() {
    return activity;
  }

  public void setActivity(String activity) {
    this.activity = activity;
  }

  public long getHourlyCost() {
    return hourlyCost;
  }

  public void setHourlyCost(long hourlyCost) {
    this.hourlyCost = hourlyCost;
  }

  public boolean isEnabled() {
    return enabled;
  }

  public void setEnabled(boolean enabled) {
    this.enabled = enabled;
  }

  private void setCounted(boolean counted) {
    this.counted = counted;
  }
}
