package com.twproject.two.task;


import com.twproject.two.ontology.SecuredSupportOld;

import java.util.Date;
import java.util.List;

/**
 * Permits to define requirements on a task in order Is structured as a tree.
 */
public class RequirementOld implements  Comparable {

  private String id;

  private TaskOld task;

  /**
   * approval, view, progess..
   */


  private String tcName;

  private boolean fullfilled = false;
  private SecuredSupportOld fulfillSource;
  private long releasedProgress;
  private int releasedStatus;

  private boolean linkMeUsingAND = true;

  private List childRequirements;

  private boolean deleted;
  private Date lastModified;

  public static final String package_prefix = "com.twproject.task";
  public static final String REQUIREMENT = package_prefix + ".REQUIREMENT";

  public RequirementOld() {
  }

  public RequirementOld(String id) {
    this.setId(id);
  }

  /**
   * A requirement isFulfilled if
   *
   */
  public boolean isFulfilled() {
    if (!fullfilled)
      return false;

    if (childRequirements != null) {
      boolean atLeastOneFullfilled = false;
      for (int i = 0; i < childRequirements.size(); i++) {
        RequirementOld requirementOld = (RequirementOld) childRequirements.get(i);
        if (!requirementOld.isFulfilled() && requirementOld.linkMeUsingAND)
          return false;
        if (requirementOld.isFulfilled() && !requirementOld.linkMeUsingAND)
          atLeastOneFullfilled = true;

      }
      if (atLeastOneFullfilled)
        return true;
      else
        return false;
    }

    return true;
  }

  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }




  protected String getTcName() {
    return tcName;
  }

  protected void setTcName(String tcName) {
    this.tcName = tcName;
  }

  public boolean isFullfilled() {
    return fullfilled;
  }

  public void setFullfilled(boolean fullfilled) {
    this.fullfilled = fullfilled;
  }

  public SecuredSupportOld getFulfillSource() {
    return fulfillSource;
  }

  public void setFulfillSource(SecuredSupportOld fulfillSource) {
    this.fulfillSource = fulfillSource;
  }

  public long getReleasedProgress() {
    return releasedProgress;
  }

  public void setReleasedProgress(long releasedProgress) {
    this.releasedProgress = releasedProgress;
  }

  public int getReleasedStatus() {
    return releasedStatus;
  }

  public void setReleasedStatus(int releasedStatus) {
    this.releasedStatus = releasedStatus;
  }

  public boolean isLinkMeUsingAND() {
    return linkMeUsingAND;
  }

  public void setLinkMeUsingAND(boolean linkMeUsingAND) {
    this.linkMeUsingAND = linkMeUsingAND;
  }

  public List getChildRequirements() {
    return childRequirements;
  }

  public void setChildRequirements(List childRequirements) {
    this.childRequirements = childRequirements;
  }


  public int compareTo(Object o) {
    return this.getId().compareTo(((RequirementOld) o).getId());
  }

  public boolean equals(Object o) {
    return this.compareTo(o) == 0;
  }


  public TaskOld getTask() {
    return task;
  }

  public void setTask(TaskOld task) {
    this.task = task;
  }

  public boolean isDeleted() {
    return deleted;
  }

  public void setDeleted(boolean deleted) {
    this.deleted = deleted;
  }

  public Date getLastModified() {
    return lastModified;
  }

  public void setLastModified(Date lastModified) {
    this.lastModified = lastModified;
  }
}
