package com.twproject.worklog;

import com.twproject.task.Assignment;
import com.twproject.task.Issue;
import com.twproject.task.Task;
import org.jblooming.agenda.CompanyCalendar;
import org.jblooming.ontology.LoggableIdentifiableSupport;
import org.jblooming.persistence.exceptions.RemoveException;
import org.jblooming.persistence.exceptions.StoreException;
import org.jblooming.persistence.hibernate.PersistenceContext;
import org.jblooming.utilities.DateUtilities;
import org.jblooming.utilities.JSP;
import org.jblooming.waf.view.PageState;

import java.util.Date;

public class Worklog extends LoggableIdentifiableSupport {

  private long duration;
  private String action;
  private Date inserted;
  private Assignment assig;
  private Issue issue;
 
  public Worklog() {
  }

  public Worklog(int id) {
    super(id);
  }


  public String getAction() {
    return action;
  }

  public void setAction(String action) {
    this.action = action;
  }

  public long getDuration() {
    return duration;
  }

  public void setDuration(long duration) {
    if (duration<CompanyCalendar.MILLIS_IN_MINUTE)
      duration = CompanyCalendar.MILLIS_IN_MINUTE;
    this.duration = duration;
  }

  public Date getInserted() {
    return inserted;
  }

  public void setInserted(Date inserted) {
    this.inserted = inserted;
  }

  public Assignment getAssig() {
    return assig;
  }

  public void setAssig(Assignment assig) {
    this.assig = assig;
  }


  public String getName() {
    return getId() + "";
  }

  public Issue getIssue() {
    return issue;
  }

  public void setIssue(Issue issue) {
    this.issue = issue;
  }

  public String getDisplayName(PageState pageState) {
    return DateUtilities.dateToString(inserted,pageState.sessionState)+":"+
      assig.getDisplayName(pageState)+JSP.limWr(JSP.w(action),10)+" - dur."+
      DateUtilities.getMillisInHoursMinutes(duration);
  }

  public void store(PersistenceContext pc) throws StoreException {
    super.store(pc);
    getAssig().addWorklogInMemory(this);
    getAssig().store(pc);
  }

  public void remove(PersistenceContext pc) throws RemoveException {
    Task task = getAssig().getTask();
    super.remove(pc);
    try {
      task.updateProgress(pc);
    } catch (StoreException e) {
      throw new RemoveException(e);
    }
  }

}